#include "include/Batalha.hpp"
#include "include/NPC.hpp"
#include "include/posicionaNaTela.hpp"

char nomeInimigos[6][30] = {"fotoEspinho","fotoGeleca","fotoGeleca2","fotoGeleca3","fotoRocha","fotoRocha2"};

void HBL_function(void);

s8 width;
s8 height;
u16 add;
s32 eixo_x;   /*Scroll posicoes...*/
s32 eixo_y;
u8 flag_descarrega;
s32 posicaoHeroi[3][2];

void Batalha::guardaPosicaoHeroiAntes(Heroi *heroi)
{
	posicaoHeroi[0][0] = heroi->getPosicaoTelaX();
	posicaoHeroi[0][1] = heroi->getPosicaoTelaY();

	posicaoHeroi[1][0] = heroi->getPosicaoCenarioX();
	posicaoHeroi[1][1] = heroi->getPosicaoCenarioY();

	posicaoHeroi[2][0] = heroi->getScrollX();
	posicaoHeroi[2][1] = heroi->getScrollY();
}

void Batalha::reposicionaHeroi(Heroi *heroi)
{
	heroi->setPosicaoTelaX(posicaoHeroi[0][0]);
	heroi->setPosicaoTelaY(posicaoHeroi[0][1]);

	heroi->setPosicaoCenarioX(posicaoHeroi[1][0]);
	heroi->setPosicaoCenarioY(posicaoHeroi[1][1]);

	heroi->setScrollX(posicaoHeroi[2][0]);
	heroi->setScrollY(posicaoHeroi[2][1]);
}

u8 Batalha::getNumeroInimigos(){
	return _numero_inimigos;
}

void Batalha::setNumeroInimigos(u8 numero_inimigos){
	_numero_inimigos = numero_inimigos; 
}

/*funcao que devolve 1 se encontrar uma batalha*/
int Batalha::encontra_batalha()
{
   	float porcentagem;

	PA_InitRand();

	porcentagem = PA_RandMax(1000);
	
//	if (porcentagem < 0)
//		porcentagem = -porcentagem;
//
//	if (porcentagem < 50){
//		return 1;
//	}

	return 0;
}

void Batalha::inicia_variaveis_transicao(){

	width = cwidth = 8;
	height = cheight = 8;
	add = cadd = 0;
	eixo_x = ceixo_x = 0;   /*Scroll posicoes...*/
	eixo_y = ceixo_y = 0;
}


void HBL_function(void){
	s8 vcount = PA_GetVcount();
   	vcount++;
   	if(vcount > 192) vcount = 0;  
   
   	PA_BGScrollX(0, 3, (eixo_x&511) + ((PA_Sin((vcount+eixo_y)*height+add)*width)>>8));
   	PA_BGScrollX(1, 3, (eixo_x&511) + ((PA_Sin((vcount+eixo_y)*height+add)*width)>>8));
}   

/* a variavel i é o define que fala qual musica deve ser descarregada para entrar a musica de batalha*/
void Batalha::tela_transicao(int i, Cenario *cenario){
	irqSet(IRQ_HBLANK, HBL_function);
	irqEnable(IRQ_HBLANK);

	inicia_variaveis_transicao();

	while (1){
		cadd+=4; cadd&= 511;	// Move a onda
		add = cadd;
		add &= 511;

		cheight += 1;
		cwidth += 1;

		height = cheight;
		width = cwidth;

		if (height == 110){
			/*descarrega o cenario atual e coloca outro*/
			carregaCenarioBatalha(cenario);
		}

      	if (cwidth == 0) break;

		PA_WaitForVBL();
	}
   	irqDisable(IRQ_HBLANK);
}

void Batalha::mostraStatusHeroi(Heroi *heroi){
	/*status do heroi na batalha*/
	PA_OutputText (1, 4, 16, "                            ");
	PA_OutputText (1, 4, 16, "%c3%d/%d", heroi->getHp(), heroi->getHpMax());
	PA_OutputText (1, 4, 18, "                            ");
	PA_OutputText (1, 4, 18, "%c3%d/%d", heroi->getMp(), heroi->getMpMax());
	PA_OutputText(1, 4, 20, "                ");
	if (heroi->getUsandoEspiritoDoFogo())
		PA_OutputText(1, 6, 20, "%c1fogo");
	else
		PA_OutputText(1, 6, 20, "%c3normal");
}

void Batalha::mostraStatusInimigo (Inimigo **inimigo, int n_inimigos){
	for (int i = 0; i < n_inimigos; i++){
		PA_OutputText (1, 56, 5 + (6*i), "                 ");
		PA_OutputText (1, 56, 5 + (6*i), "%c3%d", inimigo[i]->getHp());
		PA_OutputText (1, 56, 7 + (6*i), "                 ");
		PA_OutputText (1, 56, 7 + (6*i), "%c3%d", inimigo[i]->getMp());
	}
}

void Batalha::iniciaImagemDeDanos (){

	/*heroi_imagem_life = new Numero();
	heroi_imagem_life->setId(HEROI);

	inimigoHer1_imagem_dano = new Numero();
	heroiIni1_imagem_dano = new Numero();
	heroiIni1_imagem_dano_rot = new Numero();
	heroiIni1_imagem_dano_rot_fogo_ef = new Numero();
	heroiIni1_imagem_dano_rot_fogo_nef = new Numero();
	heroiIni1_imagem_dano_mag_ef = new Numero();
	heroiIni1_imagem_dano_mag_nef = new Numero();
	heroiIni1_imagem_dano_fogo_ef = new Numero();
	heroiIni1_imagem_dano_fogo_nef = new Numero();

	inimigoHer1_imagem_dano->setId(HEROI);
	heroiIni1_imagem_dano->setId(INIMIGO1);
	heroiIni1_imagem_dano_rot->setId(INIMIGO1);
	heroiIni1_imagem_dano_rot_fogo_ef->setId(INIMIGO1);
	heroiIni1_imagem_dano_rot_fogo_nef->setId(INIMIGO1);
	heroiIni1_imagem_dano_mag_ef->setId(INIMIGO1);
	heroiIni1_imagem_dano_mag_nef->setId(INIMIGO1);
	heroiIni1_imagem_dano_fogo_ef->setId(INIMIGO1);
	heroiIni1_imagem_dano_fogo_nef->setId(INIMIGO1);


	if (getNumeroInimigos() >= 2){
		inimigoHer2_imagem_dano = new Numero();
		heroiIni2_imagem_dano = new Numero();
		heroiIni2_imagem_dano_rot = new Numero();
		heroiIni2_imagem_dano_rot_fogo_ef = new Numero();
		heroiIni2_imagem_dano_rot_fogo_nef = new Numero();
		heroiIni2_imagem_dano_mag_ef = new Numero();
		heroiIni2_imagem_dano_mag_nef = new Numero();
		heroiIni2_imagem_dano_fogo_ef = new Numero();
		heroiIni2_imagem_dano_fogo_nef = new Numero();

		inimigoHer2_imagem_dano->setId(HEROI);
		heroiIni2_imagem_dano->setId(INIMIGO2);
		heroiIni2_imagem_dano_rot->setId(INIMIGO2);
		heroiIni2_imagem_dano_rot_fogo_ef->setId(INIMIGO2);
		heroiIni2_imagem_dano_rot_fogo_nef->setId(INIMIGO2);
		heroiIni2_imagem_dano_mag_ef->setId(INIMIGO2);
		heroiIni2_imagem_dano_mag_nef->setId(INIMIGO2);
		heroiIni2_imagem_dano_fogo_ef->setId(INIMIGO2);
		heroiIni2_imagem_dano_fogo_nef->setId(INIMIGO2);
	}
	
	if (getNumeroInimigos() == 3){
		inimigoHer3_imagem_dano = new Numero();
		heroiIni3_imagem_dano = new Numero();
		heroiIni3_imagem_dano_rot = new Numero();
		heroiIni3_imagem_dano_rot_fogo_ef = new Numero();
		heroiIni3_imagem_dano_rot_fogo_nef = new Numero();
		heroiIni3_imagem_dano_mag_ef = new Numero();
		heroiIni3_imagem_dano_mag_nef = new Numero();
		heroiIni3_imagem_dano_fogo_ef = new Numero();
		heroiIni3_imagem_dano_fogo_nef = new Numero();

		inimigoHer3_imagem_dano->setId(HEROI);
		heroiIni3_imagem_dano->setId(INIMIGO3);
		heroiIni3_imagem_dano_rot->setId(INIMIGO3);
		heroiIni3_imagem_dano_rot_fogo_ef->setId(INIMIGO3);
		heroiIni3_imagem_dano_rot_fogo_nef->setId(INIMIGO3);
		heroiIni3_imagem_dano_mag_ef->setId(INIMIGO3);
		heroiIni3_imagem_dano_mag_nef->setId(INIMIGO3);
		heroiIni3_imagem_dano_fogo_ef->setId(INIMIGO3);
		heroiIni3_imagem_dano_fogo_nef->setId(INIMIGO3);
	}*/
}

void Batalha::liberaImagemDeDanos (){
	/*free(heroi_imagem_life);

	free(inimigoHer1_imagem_dano);
	free(heroiIni1_imagem_dano);
	free(heroiIni1_imagem_dano_rot);
	free(heroiIni1_imagem_dano_rot_fogo_ef);
	free(heroiIni1_imagem_dano_rot_fogo_nef);
	free(heroiIni1_imagem_dano_mag_ef);
	free(heroiIni1_imagem_dano_mag_nef);
	free(heroiIni1_imagem_dano_fogo_ef);
	free(heroiIni1_imagem_dano_fogo_nef);

	if (getNumeroInimigos() >= 2){
		free(inimigoHer2_imagem_dano);
		free(heroiIni2_imagem_dano);
		free(heroiIni2_imagem_dano_rot);
		free(heroiIni2_imagem_dano_rot_fogo_ef);
		free(heroiIni2_imagem_dano_rot_fogo_nef);
		free(heroiIni2_imagem_dano_mag_ef);
		free(heroiIni2_imagem_dano_mag_nef);
		free(heroiIni2_imagem_dano_fogo_ef);
		free(heroiIni2_imagem_dano_fogo_nef);
	}
	
	if (getNumeroInimigos() == 3){
		free(inimigoHer3_imagem_dano);
		free(heroiIni3_imagem_dano);
		free(heroiIni3_imagem_dano_rot);
		free(heroiIni3_imagem_dano_rot_fogo_ef);
		free(heroiIni3_imagem_dano_rot_fogo_nef);
		free(heroiIni3_imagem_dano_mag_ef);
		free(heroiIni3_imagem_dano_mag_nef);
		free(heroiIni3_imagem_dano_fogo_ef);
		free(heroiIni3_imagem_dano_fogo_nef);
	}*/
}

void descarrega_carrega_back_batalha (Cenario *cenario, const char* ref1, const char* ref2){
	cenario->descarregaBackground(0, 3, ref1);
	cenario->carregaBackground(0, 3, ref2, ref2);
	PA_InitParallaxX(0, 0, 256, 128, 256);
	PA_InitParallaxY(0, 0, 256, 128, 256);
}

void Batalha::carregaCenarioBatalha(Cenario *cenario){
	
	if (strcmp (cenario->getReferencia(), "mapa") == 0){
		cenario->setReferenciaAnterior("mapa");
		descarrega_carrega_back_batalha (cenario, "mapa", "batalhaMapa");
	}
	
	if (strcmp (cenario->getReferencia(), "cenarioCaverna") == 0){
		cenario->setReferenciaAnterior("cenarioCaverna");
		descarrega_carrega_back_batalha (cenario, "cenarioCaverna", "batalhaCaverna");
	}
	
	if (strcmp (cenario->getReferencia(), "cenarioCaverna2") == 0){
		cenario->setReferenciaAnterior("cenarioCaverna2");
		descarrega_carrega_back_batalha (cenario, "cenarioCaverna2", "batalhaCaverna");
	}
	
	if (strcmp (cenario->getReferencia(), "cenarioCaverna3") == 0){
		cenario->setReferenciaAnterior("cenarioCaverna3");
		descarrega_carrega_back_batalha (cenario, "cenarioCaverna3", "batalhaCaverna");
	}
	
	if (strcmp (cenario->getReferencia(), "deserto") == 0){
		cenario->setReferenciaAnterior("deserto");
		descarrega_carrega_back_batalha (cenario, "deserto", "batalhaDeserto");
	}

	if (strcmp (cenario->getReferencia(), "deserto2") == 0){
		cenario->setReferenciaAnterior("deserto2");
		descarrega_carrega_back_batalha (cenario, "deserto2", "batalhaDeserto");
	}
	
	if (strcmp (cenario->getReferencia(), "floresta1") == 0){
		cenario->setReferenciaAnterior("floresta1");
		descarrega_carrega_back_batalha (cenario, "floresta1", "batalhaFloresta");
	}
	
	if (strcmp (cenario->getReferencia(), "floresta2") == 0){
		cenario->setReferenciaAnterior("floresta2");
		descarrega_carrega_back_batalha (cenario, "floresta2", "batalhaFloresta");
	}
	
	if (strcmp (cenario->getReferencia(), "Rocha") == 0){
		cenario->setReferenciaAnterior("Rocha");
		descarrega_carrega_back_batalha (cenario, "Rocha", "batalhaRocha");
	}
}

Inimigo **Batalha::sorteiaInimigos (Inimigo **inimigo, int n_inimigos){
	int indice, id_inimigo_sorteado[3] = {-1, -1, -1}, escolhidos = 0;
	bool aceito;
	PA_InitRand();

	//enquanto nao forem escolhidos 3 inimigos
	while (escolhidos != 3){
		aceito = true;
		indice = PA_RandMinMax (0, 5);
		for (int i = 0; i < getNumeroInimigos(); i++){
			//verificar se o indice ja nao foi escolhido
			if (id_inimigo_sorteado[i] == indice){
				aceito = false;
				break;
			}
		}
		//se o indice ainda nao foi escolhido
		if (aceito){
			id_inimigo_sorteado[escolhidos] = indice;
			escolhidos++;
		}
	}
	
	inimigo = initInimigos (inimigo, n_inimigos, id_inimigo_sorteado);
	return inimigo;
}

Inimigo **Batalha::initInimigos (Inimigo **inimigo, int n_inimigos, int id_inimigo_sorteado[]){
	
	inimigo = (Inimigo**) malloc (n_inimigos * sizeof(Inimigo*));
	for (int i = 0; i < n_inimigos; i++){
		inimigo[i] = new Inimigo();
	
		/*fazer um init pra cada inimigo*/
		inimigo[i]->setNome(nomeInimigos[id_inimigo_sorteado[i]]);
		inimigo[i]->setNomeArquivo(retornaNomeInimigo(inimigo[i]->getNome()));

		if (strcmp(inimigo[i]->getNomeArquivo(), "espinho") == 0){
			inimigo[i]->iniciaEspinho(i);
		}
		else if (strcmp(inimigo[i]->getNomeArquivo(), "gelecaVerde") == 0){
			inimigo[i]->iniciaGelecaVerde(i);
		}
		else if (strcmp(inimigo[i]->getNomeArquivo(), "gelecaVermelho") == 0){
			inimigo[i]->iniciaGelecaVermelho(i);
		}
		else if (strcmp(inimigo[i]->getNomeArquivo(), "gelecaAzul") == 0){
			inimigo[i]->iniciaGelecaAzul(i);
		}
		else if (strcmp(inimigo[i]->getNomeArquivo(), "rocha") == 0){
			inimigo[i]->iniciaRocha(i);
		}
		else if (strcmp(inimigo[i]->getNomeArquivo(), "rocha2") == 0){
			inimigo[i]->iniciaRocha2(i);
		}
	}
	
	flag_descarrega = 0;
	return inimigo;
}

void Batalha::apagaFotosInimigos (Inimigo **inimigo){
	if (getNumeroInimigos() > 0)
		descarregaSprite (inimigo[0]->getNome(), 1);
	
	if (getNumeroInimigos() > 1)
		descarregaSprite (inimigo[1]->getNome(), 1);

	if (getNumeroInimigos() > 2)
		descarregaSprite (inimigo[2]->getNome(), 1);
}


/*atraves do nome da foto, a funcao retorna o sprite que deve ser carregado para o inimigo*/
char *Batalha::retornaNomeInimigo (char *nomeFoto){

	//waits para que os sprites nao fiquem todos com a animacao juntinha (para nao ficar artificial)
	PA_WaitForVBL ();
	PA_WaitForVBL ();

	if (strcmp (nomeFoto, "fotoEspinho") == 0)
		return "espinho";

	if (strcmp (nomeFoto, "fotoGeleca") == 0)
		return "gelecaVerde";
	
	if (strcmp (nomeFoto, "fotoGeleca2") == 0)
		return "gelecaVermelho";
	
	if (strcmp (nomeFoto, "fotoGeleca3") == 0)
		return "gelecaAzul";
	
	if (strcmp (nomeFoto, "fotoRocha") == 0)
		return "rocha";

	if (strcmp (nomeFoto, "fotoRocha2") == 0)
		return "rocha2";
}

Inimigo **Batalha::carregaInimigo (Inimigo **inimigo)
{
	u8 i;
	for(i = 0; i < getNumeroInimigos(); i++)
	{
		carregaSprite(0, inimigo[i]->getNomeArquivo(), 
			fix_norm(inimigo[i]->getPosicaoCenarioX()), 
			fix_norm(inimigo[i]->getPosicaoCenarioY()), 
			0, 32, 32, 0, 3, 6);
	}
}

void Batalha::descarregaInimigo (Inimigo **inimigo)
{
	u8 i;
	for(i = 0; i < getNumeroInimigos(); i++)
	{
		PA_StopSpriteAnim (0, NF_EasyGetSpriteId (0, inimigo[i]->getNomeArquivo()));
		descarregaSprite (inimigo[i]->getNomeArquivo(), 0);
	}
}

void Batalha::empurraHeroi (Heroi *heroi, Inimigo *inimigo){
	s32 angulo;

	heroi->setContTomouDano(heroi->getContTomouDano() + 1);
	angulo = PA_GetAngle (fix_norm(inimigo->getPosicaoCenarioX()) - 16, fix_norm(inimigo->getPosicaoCenarioY()) - 16, fix_norm(heroi->getPosicaoCenarioX()) - 32, fix_norm(heroi->getPosicaoCenarioY()) - 32);

	heroi->movimentaParaLadoDireito (angulo);
	heroi->movimentaParaLadoEsquerdo (angulo);

	//limites da tela
	if (fix_norm(heroi->getPosicaoCenarioX() + (2 * PA_Cos(angulo))) <= 500 && fix_norm(heroi->getPosicaoCenarioX() + (2 * PA_Cos(angulo))) >= 16){
		heroi->setPosicaoTelaX (heroi->getPosicaoTelaX() + (2 * PA_Cos(angulo)));
		heroi->setPosicaoCenarioX (heroi->getPosicaoCenarioX() + (2 * PA_Cos(angulo)));
	}

	if (fix_norm(heroi->getPosicaoCenarioY() - (2 * PA_Sin(angulo))) >= 64 && fix_norm(heroi->getPosicaoCenarioY() - (2 * PA_Sin(angulo))) <= 160){
		heroi->setPosicaoTelaY (heroi->getPosicaoTelaY() - (2 * PA_Sin(angulo)));
		heroi->setPosicaoCenarioY (heroi->getPosicaoCenarioY() - (2 * PA_Sin(angulo)));
	}
					
	NF_EasyMoveSprite(0, heroi->getNome(), (fix_norm(heroi->getPosicaoTelaX())) - 32, (fix_norm(heroi->getPosicaoTelaY())) - 32);
}

//tomando dano e fazer ele dando dano no inimigo
void Batalha::heroiNaBatalha (Heroi *heroi, Inimigo **inimigo, s16 posCenario[], Cenario *cenario){

	//se inimigo colide no heroi, ele faz a animacao do ataque 

	for (int i = 0; i < 3; i++){
		if (heroi->getContTomouDano() == 0 && inimigo[i]->colisaoComHeroi(heroi)){
			heroi->setTomouDano(true);
			heroi->setContTomouDano(1);
			PA_StartSpriteAnimEx  (0, NF_EasyGetSpriteId (0, inimigo[i]->getNomeArquivo()), 4, 7, 10, ANIM_LOOP, 1);
			inimigo[i]->setStatusAtacando (true);
		}
	}

	//heroi sendo empurrado pra tras
	for (int i = 0; i < 3; i++){
		if (heroi->getTomouDano() && (heroi->getContTomouDano() < TEMPO_REPULSAO)){
			if (inimigo[i]->getStatusAtacando())
				empurraHeroi (heroi, inimigo[i]);
		}

		//se ja foi todo empurrado, para
		if (heroi->getContTomouDano() == TEMPO_REPULSAO){
			heroi->setContTomouDano(0);
			heroi->setTomouDano(false);
			heroi->diminuiHp(inimigo[i]->getAtaque(3)); //nao mude a constante por enquanto
		}
	}
}

void Batalha::heroiBateNoInimigo (Heroi *heroi, Inimigo **inimigo){
	s32 angulo, x_heroi, y_heroi, x_inimigo, y_inimigo;

	for (int i = 0; i < getNumeroInimigos(); i++){
		angulo = PA_GetAngle (fix_norm(heroi->getPosicaoCenarioX()) - 32, fix_norm(heroi->getPosicaoCenarioY()) - 32, fix_norm(inimigo[i]->getPosicaoCenarioX()) - 16, fix_norm(inimigo[i]->getPosicaoCenarioY()) - 16);

		x_heroi = fix_norm(heroi->getPosicaoCenarioX());
		y_heroi = fix_norm(heroi->getPosicaoCenarioY());
		x_inimigo =  fix_norm(inimigo[i]->getPosicaoCenarioX());
		y_inimigo =  fix_norm(inimigo[i]->getPosicaoCenarioY());

		//verifica se o heroi acerta o inimigo virado pra direcao certa
		if (PA_Distance(x_heroi - 32, y_heroi - 32, x_inimigo - (inimigo[i]->getTamSprite()/2), y_inimigo - (inimigo[i]->getTamSprite()/2)) <= 31*31){
			if (heroi->getReconhecendoCirc() == false){
				if (heroi->getDirecao() == CIMA && (angulo > 62  && angulo < 190)){
					inimigo[i]->setTomouDano(true);
					//playEfeito("somGolpeAcertado");
				}
				else if (heroi->getDirecao() == BAIXO && (angulo > 316 && angulo < 443)){
					inimigo[i]->setTomouDano(true);
					//playEfeito("somGolpeAcertado");
				}
				else if (heroi->getDirecao() == LADO_ESQUERDO && (angulo > 189 && angulo < 317)){
					inimigo[i]->setTomouDano(true);
					//playEfeito("somGolpeAcertado");
				}
				else if (heroi->getDirecao() == LADO_DIREITO && (angulo > 442 || angulo < 63)){
					inimigo[i]->setTomouDano(true);
					//playEfeito("somGolpeAcertado");
				}
			}
			else
				inimigo[i]->setTomouDano(true);
		}

		/*atribui dano a ser mostrado na tela*/
		if (inimigo[i]->getTomouDano() && inimigo[i]->getContTomouDano() == 1){
			if (heroi->getUsandoEspiritoDoFogo()){
				mostraDanoNaTela(heroi, inimigo[i], heroi->getPtsAtaque()*2);
			}
			else
				mostraDanoNaTela(heroi, inimigo[i], heroi->getPtsAtaque());
		}
	}
}

void Batalha::mostraDanoNaTela (Heroi *heroi, Inimigo *inimigo, int dano){
	int x, y;

	x = fix_norm(inimigo->getPosicaoCenarioX() - heroi->getScrollX());
	y = fix_norm(inimigo->getPosicaoCenarioY());
	posicionaNaTela(x, y, dano);
}

void telaPontuacao(Heroi *heroi)
{
	stopMP3();
	NF_LoadFatBg("telaPontuacao", "telaPontuacao");
	NF_LoadRamBg(0, 2, "telaPontuacao");

	PA_OutputText (0, 11, 10, "%c1Voce ganhou");
	PA_OutputText (0, 16, 12, "%c1%d", heroi->getExperienciaAcumulada());
	PA_OutputText (0, 9, 14, "%c1de experiencia");
	transicao_clarear();
	while(!Pad.Newpress.A)
	{
		PA_WaitForVBL();
	}
	transicao_escurecer();
	PA_DeleteBg (0, 2);
	NF_UnloadBg("telaPontuacao");

	PA_OutputText (0, 10, 10, "                               ");
	PA_OutputText (0, 13, 12, "                               ");
	PA_OutputText (0, 8, 14, "                                 ");
}

//verifica se apertou o botao pra trocar de espírito
void Batalha::incorporaEspirito(Heroi *heroi){
	if (Pad.Newpress.L){
		if (heroi->getUsandoEspiritoDoFogo()){
			heroi->setUsandoEspiritoDoFogo(false);
			PA_OutputText(1, 6, 20, "          ");
			PA_OutputText(1, 6, 20, "%c3normal");
		}
		else{
			heroi->setUsandoEspiritoDoFogo(true);
			PA_OutputText(1, 6, 20, "             ");
			PA_OutputText(1, 6, 20, "%c1fogo");
		}
	}
}

void Batalha::retocaMusica(Cenario *cenario)
{
	if(strcmp(cenario->getReferencia(), "mapa") == 0)
	{
		playMP3("mapa");
		AS_SetMP3Loop(true);
	}
	else if(strcmp(cenario->getReferencia(), "floresta1") == 0 || 
			strcmp(cenario->getReferencia(), "floresta2") == 0)
	{
		playMP3("floresta");
		AS_SetMP3Loop(true);
	}
	else if(strcmp(cenario->getReferencia(), "deserto") == 0 ||
			strcmp(cenario->getReferencia(), "deserto2") == 0)
	{
		playMP3("deserto");
		AS_SetMP3Loop(true);
	}
	else if(strcmp(cenario->getReferencia(), "cenarioCaverna") == 0 ||
			strcmp(cenario->getReferencia(), "cenarioCaverna2") == 0 ||
			strcmp(cenario->getReferencia(), "cenarioCaverna3") == 0)
	{
		playMP3("caverna");
		AS_SetMP3Loop(true);
	}
	
}

void Batalha::iniciaImagemDano (Inimigo **inimigo, Heroi *heroi){
		//seta todos os danos das imagens
		/*heroi_imagem_life->setDano(50);
		heroi_imagem_life->carregaNum();
	
		inimigoHer1_imagem_dano->setDano(inimigo[0]->getAtaque(3));
		heroiIni1_imagem_dano->setDano(heroi->getAtaque(3));
		heroiIni1_imagem_dano_rot->setDano(heroi->getAtaque(3) * 1.5);
		heroiIni1_imagem_dano_rot_fogo_ef->setDano(heroi->getAtaque(3) * 3);
		heroiIni1_imagem_dano_rot_fogo_nef->setDano(heroi->getAtaque(3) - 2);
		heroiIni1_imagem_dano_mag_ef->setDano(heroi->getAtaque(3) * 2.5);
		heroiIni1_imagem_dano_mag_nef->setDano(heroi->getAtaque(3) - 1);
		heroiIni1_imagem_dano_fogo_ef->setDano(heroi->getAtaque(3) * 2);
		heroiIni1_imagem_dano_fogo_nef->setDano(heroi->getAtaque(3) - 3);
		
		inimigoHer1_imagem_dano->carregaNum();
		heroiIni1_imagem_dano->carregaNum();
		heroiIni1_imagem_dano_rot->carregaNum();
		heroiIni1_imagem_dano_rot_fogo_ef->carregaNum();
		heroiIni1_imagem_dano_rot_fogo_nef->carregaNum();
		heroiIni1_imagem_dano_mag_ef->carregaNum();
		heroiIni1_imagem_dano_mag_nef->carregaNum();
		heroiIni1_imagem_dano_fogo_ef->carregaNum();

		if (getNumeroInimigos() >= 2){
			inimigoHer2_imagem_dano->setDano(inimigo[1]->getAtaque(3));
			heroiIni2_imagem_dano->setDano(heroi->getAtaque(3));
			heroiIni2_imagem_dano_rot->setDano(heroi->getAtaque(3) * 1.5);
			heroiIni2_imagem_dano_rot_fogo_ef->setDano(heroi->getAtaque(3) * 3);
			heroiIni2_imagem_dano_rot_fogo_nef->setDano(heroi->getAtaque(3) - 2);
			heroiIni2_imagem_dano_mag_ef->setDano(heroi->getAtaque(3) * 2.5);
			heroiIni2_imagem_dano_mag_nef->setDano(heroi->getAtaque(3) - 1);
			heroiIni2_imagem_dano_fogo_ef->setDano(heroi->getAtaque(3) * 2);
			heroiIni2_imagem_dano_fogo_nef->setDano(heroi->getAtaque(3) - 3);
		
			inimigoHer2_imagem_dano->carregaNum();
			heroiIni2_imagem_dano->carregaNum();
			heroiIni2_imagem_dano_rot->carregaNum();
			heroiIni2_imagem_dano_rot_fogo_ef->carregaNum();
			heroiIni2_imagem_dano_rot_fogo_nef->carregaNum();
			heroiIni2_imagem_dano_mag_ef->carregaNum();
			heroiIni2_imagem_dano_mag_nef->carregaNum();
			heroiIni2_imagem_dano_fogo_ef->carregaNum();
			heroiIni2_imagem_dano_fogo_nef->carregaNum();
		}
		
		if (getNumeroInimigos() == 3){
			inimigoHer3_imagem_dano->setDano(inimigo[2]->getAtaque(3));
			heroiIni3_imagem_dano->setDano(heroi->getAtaque(3));
			heroiIni3_imagem_dano_rot->setDano(heroi->getAtaque(3) * 1.5);
			heroiIni3_imagem_dano_rot_fogo_ef->setDano(heroi->getAtaque(3) * 3);
			heroiIni3_imagem_dano_rot_fogo_nef->setDano(heroi->getAtaque(3) - 2);
			heroiIni3_imagem_dano_mag_ef->setDano(heroi->getAtaque(3) * 2.5);
			heroiIni3_imagem_dano_mag_nef->setDano(heroi->getAtaque(3) - 1);
			heroiIni3_imagem_dano_fogo_ef->setDano(heroi->getAtaque(3) * 2);
			heroiIni3_imagem_dano_fogo_nef->setDano(heroi->getAtaque(3) - 3);
		
			inimigoHer3_imagem_dano->carregaNum();
			heroiIni3_imagem_dano->carregaNum();
			heroiIni3_imagem_dano_rot->carregaNum();
			heroiIni3_imagem_dano_rot_fogo_ef->carregaNum();
			heroiIni3_imagem_dano_rot_fogo_nef->carregaNum();
			heroiIni3_imagem_dano_mag_ef->carregaNum();
			heroiIni3_imagem_dano_mag_nef->carregaNum();
			heroiIni3_imagem_dano_fogo_ef->carregaNum();
			heroiIni1_imagem_dano_fogo_nef->carregaNum();
		}*/

}

void Batalha::atualizaTemporarios(Heroi *heroi){
	int i = 6;

	//atualiza a posicao do sprite do espirito entrando/saindo
	if (Pad.Newpress.L){
		if (heroi->getUsandoEspiritoDoFogo())
			PA_StartSpriteAnimEx(0,  NF_EasyGetSpriteId (0, "espirito_fogo_entrando"), 0, 5, 12, ANIM_ONESHOT);
		else
			PA_StartSpriteAnimEx(0,  NF_EasyGetSpriteId (0, "espirito_fogo_saindo"), 0, 5, 12, ANIM_ONESHOT);
	}

	if (heroi->getUsandoEspiritoDoFogo()){
		i = PA_GetSpriteAnimFrame (0, NF_EasyGetSpriteId (0, "espirito_fogo_entrando"));

		if (i <= 5){
			NF_EasyMoveSprite (0, "espirito_fogo_entrando", fix_norm(heroi->getPosicaoTelaX()) - 16, fix_norm(heroi->getPosicaoTelaY()) - 16);
		}
		else
			NF_EasyMoveSprite (0, "espirito_fogo_entrando", 900, 900);

	}
	else{
		i = PA_GetSpriteAnimFrame (0, NF_EasyGetSpriteId (0, "espirito_fogo_saindo"));

		if (i <= 5){
			NF_EasyMoveSprite (0, "espirito_fogo_saindo", fix_norm(heroi->getPosicaoTelaX()) - 16, fix_norm(heroi->getPosicaoTelaY()) - 16);
		}
		else
			NF_EasyMoveSprite (0, "espirito_fogo_saindo", 900, 900);
	}
}

void Batalha::recarregaSpriteDoCenario(Cenario *cenario, int statusBau){
	if (strcmp(cenario->getReferenciaAnterior(), "cenarioCaverna") == 0){
		carregaSpriteCaverna(statusBau);
	}
	else
	if (strcmp(cenario->getReferenciaAnterior(), "deserto") == 0){
		carregaSpriteDeserto();
	}
	else
	if (strcmp(cenario->getReferenciaAnterior(), "floresta1") == 0){
		carregaSpriteFloresta();
	}
}

Inimigo **Batalha::batalha (Heroi *heroi, Cenario *cenario, Status *status, Inimigo **inimigo, Magia *magia, s16 pos_cenario[], int statusBau){
	/* Sorteia o numero de inimigos e mostra o avatar no status*/
	float numero_inimigos;
	bool atualiza_magia = false;
	
	if (getNumeroInimigos() == 0){
		PA_InitRand();
		numero_inimigos = PA_RandMinMax(1, 3);
		setNumeroInimigos(numero_inimigos);
		inimigo = sorteiaInimigos(inimigo, getNumeroInimigos());
		status->carregaInimigoStatus(inimigo, getNumeroInimigos());
		carregaInimigo (inimigo);
		mostraStatusInimigo (inimigo, numero_inimigos);
		iniciaImagemDeDanos();
		iniciaImagemDano(inimigo, heroi);
		carregaSpriteNaoAnimado (0, "espirito_fogo_entrando", 900, 900, 32, 32);
		NF_EasySetSpriteLayer(0, "espirito_fogo_entrando", 0);
		carregaSpriteNaoAnimado (0, "espirito_fogo_saindo", 900, 900, 32, 32);
		NF_EasySetSpriteLayer(0, "espirito_fogo_saindo", 0);
	}

	incorporaEspirito(heroi);
	atualizaTemporarios(heroi);

	/*parte da porrada*/
	if(flag_descarrega == 0)
	{
		mostraStatusHeroi (heroi);

		/*HEROI ATACANDO INIMIGO e inimigo sendo jogado pra tras*/
		if (heroi->getStatus() == ATACANDO && heroi->getTempoAtaque(ATAQUE_A) <= 1400){
			heroiBateNoInimigo(heroi, inimigo);
		}
	
		//se magia esta funcionando
		if (magia->getVivo()){ 
			bool bateu = false;
			//verifica se bateu em alguem
			for (int i = 0; i < getNumeroInimigos(); i ++){
				if (inimigo[i]->getDanoMagico() == false){
					inimigo[i]->setDanoMagico (magia->controlaMagia(heroi->getScrollX(), heroi->getScrollY(),
											   inimigo[i]->getPosicaoCenarioX(), inimigo[i]->getPosicaoCenarioY(),
											   inimigo[i]->getTamSprite(), 0));
				}
			}
			//diminui o tempo de vida
			magia->tempoDeVidaMagia();
			//atualiza a magia se ainda esta viva e nao bateu em ninguem
			if (magia->getVivo()){
				NF_EasyMoveSprite ( 0, "bola_de_fogo",
							fix_norm(magia->getXMagia()) - fix_norm(heroi->getScrollX()),
							fix_norm(magia->getYMagia()) - fix_norm(heroi->getScrollY()));
			}
		}

		for (int i = 0; i < getNumeroInimigos(); i++){
			if (inimigo[i]->getMorto() == false)
				inimigo[i]->comportamentoInimigo(heroi, flag_descarrega, 0);
			else
				inimigo[i]->setPosicaoCenarioX(900);
		}
	}

	//pra sair da batalha
	if (Pad.Newpress.A && (flag_descarrega == 0)){
		transicao_escurecer();
		heroi->setTrocouCenario(1);

		apagaFotosInimigos (inimigo);
		descarregaInimigo (inimigo);
		
		flag_descarrega = 1;
		PA_SetSpriteXY(0, NF_EasyGetSpriteId(0, "espirito_fogo_entrando"), 300, 300);
		PA_SetSpriteXY(0, NF_EasyGetSpriteId(0, "espirito_fogo_saindo"), 300, 300);

		recarregaSpriteDoCenario(cenario, statusBau);

		if (strcmp (cenario->getReferencia(), "batalhaMapa") == 0)
			descarrega_carrega_back_batalha (cenario, "batalhaMapa", cenario->getReferenciaAnterior());

		if (strcmp (cenario->getReferencia(), "batalhaCaverna") == 0)
			descarrega_carrega_back_batalha (cenario, "batalhaCaverna", cenario->getReferenciaAnterior());
		
		if (strcmp (cenario->getReferencia(), "batalhaDeserto") == 0)
			descarrega_carrega_back_batalha (cenario, "batalhaDeserto", cenario->getReferenciaAnterior());
		
		if (strcmp (cenario->getReferencia(), "batalhaFloresta") == 0)
			descarrega_carrega_back_batalha (cenario, "batalhaFloresta", cenario->getReferenciaAnterior());
		
		if (strcmp (cenario->getReferencia(), "batalhaRocha") == 0)
			descarrega_carrega_back_batalha (cenario, "batalhaRocha", cenario->getReferenciaAnterior());
		
		status->descarrega_template_batalha();

		for (int i = 0; i < numero_inimigos; i++)
			free(inimigo[i]);

		heroi->carregaSprite(1, 1);
		//descarregaEfeito("somGolpeAcertado");
		// Colocar aqui a pontuacao final
		telaPontuacao(heroi);
		heroi->carregaSprite(0, 0);
		reposicionaHeroi(heroi);

		carregaSpriteNaoAnimado (1, "seta",  status->get_x_seta(), status->get_y_seta(), 16, 16);
		NF_EasySetSpriteLayer (1, "seta", 1);
		//stopMP3();
		descarregaEfeito("inimigoMorrendo");
	}

	if (heroi->getTrocouCenario() >= 1){
		heroi->setTrocouCenario(heroi->getTrocouCenario()+1);
		if (heroi->getTrocouCenario() == 4){
			heroi->setTrocouCenario(0);
			transicao_clarear();
			free (inimigo);
			retocaMusica(cenario);

			descarregaSprite("espirito_fogo_entrando", 0);
			descarregaSprite("espirito_fogo_saindo", 0);

			return NULL;
		}
	}
	return inimigo;
}
