/*=========================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	Broken Soul is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
=========================================================================*/

/*#include <PA9.h>*/
//#include <maxmod9.h>

#include "include/Cenario.hpp"

void Cenario::setReferencia(const char* referencia)
{
	referenciaAtual = referencia;
}

void Cenario::setReferenciaAnterior(const char* referencia)
{
	referenciaAnterior = referencia;
}

const char* Cenario::getReferencia()
{
	return referenciaAtual;
}

const char* Cenario::getReferenciaAnterior()
{
	return referenciaAnterior;
}

/* Carrega o cenario. */
void Cenario::carregaBackground(u16 tela, u16 bg_num, const char* referencia, const char* nome)
{
	setReferencia(referencia);
	/*
	 * void NF_LoadFatBg(const char* referencia, const char* nome);
	 * 
	 * Load a TILED Bg from EFS or FAT to RAM and asign a name to it.
	 */
	NF_LoadFatBg(referencia, nome);
	/*
	 * void NF_LoadRamBg(u16 tela, u16 bg_num, const char* referencia);
	 *
	 * Load a Bg from RAM to VRAM. Load it before with NF_LoadFatBg();
	 */
	NF_LoadRamBg(tela, bg_num, referencia);
}

/* Descarrega o cenario. */
void Cenario::descarregaBackground(u16 tela, u16 bg_num, const char* referencia)
{
	/* void PA_DeleteBg(u16 tela, u16 bg_num) */
	PA_DeleteBg(tela, bg_num);
	/* void NF_UnloadBg(const char* referencia) */
	NF_UnloadBg(referencia);
}

/* Deslisa o cenario na tela conforme o Heroi anda. */
void Cenario::moveBackground(s16 pos_cenario[], s32 scrollX, s32 scrollY, u8 direcao)
{
	if (pos_cenario[0] > 127 || pos_cenario[1] > 96){
		pos_cenario[0] -= 1; /* Posicao X */
		pos_cenario[1] -= 1; /* Posicao Y */
	}

	PA_ParallaxScrollXY(0, (fix_norm(scrollX)), (fix_norm(scrollY)));
}


