/*=========================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	Broken Soul is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
============================================================================*/
#include "include/NPC.hpp"
#include "include/Sound.hpp"
#include "include/Heroi.hpp"

u8 direcaoColisaoHorizontal, direcaoColisaoVertical;
u8 enderecoHeroi;	


s8 Heroi::getMp()
{
	return _mp;
}

void Heroi::setMp(s8 mp)
{
	_mp = mp;
}

s8 Heroi::getMpMax()
{
	return _mp_max;
}

void Heroi::setMpMax(s8 mp)
{
	_mp_max = mp;
}

s8 Heroi::getTrocouCenario(){
	return _trocou_cenario;
}

void Heroi::setTrocouCenario(s8 trocouCenario){
	_trocou_cenario = trocouCenario;
}

s8 Heroi::getPtsEvasao()
{
	return _pts_evasao;
}

void Heroi::setPtsEvasao(s8 evasao)
{
	_pts_evasao = evasao;
}

s8 Heroi::getPtsMagia()
{
	return _pts_magia;
}

void Heroi::setPtsMagia(s8 magia)
{
	_pts_magia = magia;
}

s8 Heroi::getPtsDefesa()
{
	return _pts_defesa;
}

void Heroi::setPtsDefesa(s8 defesa)
{
	_pts_defesa = defesa;
}

s8 Heroi::getHpMax()
{
	return _hp_max;
}

void Heroi::setHpMax(s8 hp)
{
	_hp_max = hp;
}

s32 Heroi::getDinheiro()
{
	return _dinheiro;
}

void Heroi::setDinheiro(s32 dinheiro)
{
	_dinheiro = dinheiro;
}

s32 Heroi::getNivel()
{
	return _nivel;
}

void Heroi::setNivel(s32 nivel)
{
	_nivel = nivel;
}


s32 Heroi::getXPMagia()
{
	return _xp_magia;
}

void Heroi::setXPMagia(s32 xp_magia)
{
	_xp_magia = xp_magia;
}

s32 Heroi::getXPMagiaMax()
{
	return _xp_magia_max;
}

void Heroi::setXPMagiaMax(s32 xp_magia_max)
{
	_xp_magia_max = xp_magia_max;
}

s32 Heroi::getNivelMagia()
{
	return _nivel_magia;
}

void Heroi::aumentaHp(u16 mais_hp){
	setHp(getHp() + mais_hp);
}

void Heroi::diminuiHp(u16 menos_hp){
	if(_hp - menos_hp <= 0)
	{
		_hp = 0;
	}
	else 
	{
		_hp -= menos_hp;
	}
}

void Heroi::aumentaMp(u8 mais_mp){
	_mp += mais_mp;
}

void Heroi::diminuiMp(u8 menos_mp){
	_mp -= menos_mp;
}

void Heroi::aumentaExperiencia(s32 mais_exp){
	_experienciaAcumulada += mais_exp;
	_experiencia += mais_exp;
}

void Heroi::zeraExperiencia(){
	_experiencia = 0;
}

void Heroi::aumentaExperienciaMagica(s32 mais_exp_mag){
	_xp_magia += mais_exp_mag;
}

void Heroi::zeraExperienciaMagica(){
	_xp_magia = 0;
}

void Heroi::setNivelMagia(s32 nivel_magia)
{
	_nivel_magia = nivel_magia;
}

void Heroi::aumentaNivel(s32 nivelAdicional)
{
	setNivel(getNivel() + nivelAdicional);
}

void Heroi::aumentaMp(s8 mpAdicional)
{
	setMp(getMp() + mpAdicional);
}

void Heroi::aumentaPtsDefesa(s8 defesaAdicional)
{
	setPtsDefesa(getPtsDefesa() + defesaAdicional);
}

void Heroi::aumentaPtsMagia(s8 ptsMagiaAdicional)
{
	setPtsMagia(getPtsMagia() + ptsMagiaAdicional);
}

void Heroi::aumentaPtsEvasao(s8 evasaoAdicional)
{
	setPtsEvasao(getPtsEvasao() + evasaoAdicional);
}

void Heroi::aumentaDinheiro(s32 dinheiroAdicional)
{
	setDinheiro(getDinheiro() + dinheiroAdicional);
}

void Heroi::setDirecaoColisaoHorizontal(u8 direcao)
{
	direcaoColisaoHorizontal = direcao;
}

void Heroi::setDirecaoColisaoVertical(u8 direcao)
{
	direcaoColisaoVertical = direcao;
}

void Heroi::setAngulo(s32 novoAngulo)
{
	angulo = novoAngulo;
}

s32 Heroi::getAngulo()
{
	return angulo;
}

s32 Heroi::getPosicaoCenarioAnteriorX()
{
	return _posicaoCenarioAnterior[0];
}

void Heroi::setPosicaoCenarioAnteriorX(s32 posicaoX)
{
	_posicaoCenarioAnterior[0] = posicaoX;
}

s32 Heroi::getPosicaoCenarioAnteriorY()
{
	return _posicaoCenarioAnterior[1];
}

void Heroi::setPosicaoCenarioAnteriorY(s32 posicaoY)
{
	_posicaoCenarioAnterior[1] = posicaoY;
}

s32 Heroi::getPosicaoTelaAnteriorY()
{
	return _posicaoTelaAnterior[1];
}

void Heroi::setPosicaoTelaAnteriorY(s32 posicaoY)
{
	_posicaoTelaAnterior[1] = posicaoY;
}

s32 Heroi::getPosicaoTelaAnteriorX()
{
	return _posicaoTelaAnterior[0];
}

void Heroi::setPosicaoTelaAnteriorX(s32 posicaoX)
{
	_posicaoTelaAnterior[0] = posicaoX;
}

s32 Heroi::getScrollAnteriorX()
{
	return _scrollAnterior[0];
}

void Heroi::setScrollAnteriorX(s32 scrollX)
{
	_scrollAnterior[0] = scrollX;
}

s32 Heroi::getScrollAnteriorY()
{
	return _scrollAnterior[1];
}

void Heroi::setScrollAnteriorY(s32 scrollY)
{
	_scrollAnterior[1] = scrollY;
}

bool Heroi::getTomouDano()
{
	return _tomouDano;
}

void Heroi::setTomouDano(bool tomou)
{
	_tomouDano = tomou;
}

u16 Heroi::getContTomouDano(){
	return _contTomouDano;
}

void Heroi::setContTomouDano(u16 cont){
	_contTomouDano = cont;
}

void Heroi::setExperienciaAcumulada(s32 experiencia)
{
	_experienciaAcumulada = experiencia;
}

s32 Heroi::getExperienciaAcumulada()
{
	return _experienciaAcumulada;
}

ListaLigada *Heroi::getMochila()
{
	return mochila;
}

bool Heroi::getUsandoEspiritoDoFogo(){
	return _usando_esp_fogo;
}

void Heroi::setUsandoEspiritoDoFogo(bool usando){
	_usando_esp_fogo = usando;
}

void Heroi::setDuploClique (u8 add){
	_duplo_clique = add;
}

u8 Heroi::getDuploClique (){
	return _duplo_clique;
}

bool Heroi::getVoltaX(u8 pos){
	return _voltaX[pos];
}

bool Heroi::getVoltaY(u8 pos){
	return _voltaY[pos];
}

u8 Heroi::getXReco(){
	return _x_reco;
}

u8 Heroi::getYReco(){
	return _y_reco;
}

void Heroi::setVoltaX(u8 pos, bool x){
	_voltaX[pos] = x;
}

void Heroi::setVoltaY(u8 pos, bool y){
	_voltaY[pos] = y;
}

void Heroi::setXReco(u8 x){
	_x_reco = x;
}

void Heroi::setYReco(u8 y){
	_y_reco = y;
}

void Heroi::setReconhecendoCirc(bool rec){
	_reconhecendoCirc = rec;
}

bool Heroi::getReconhecendoCirc(){
	return _reconhecendoCirc;
}

void Heroi::iniciaVetRecCirc(){
	for(int i = 0; i < 3; i++){
		setVoltaX(i, false);
		if (i < 2)
			setVoltaY(i, false);
	}
}

void Heroi::iniciaRecoCirc(){
	setXReco(Stylus.X);
	setYReco(Stylus.Y);
	iniciaVetRecCirc();
	setReconhecendoCirc(true);
}

void Heroi::intencaoGolpeGiratorio(){
	if (Stylus.Newpress && !getReconhecendoCirc()){
		u8 angulo = PA_GetAngle(Stylus.X, Stylus.Y, fix_norm(getPosicaoTelaX()), fix_norm(getPosicaoTelaY()));
		if (angulo >= 64 && angulo <= 220){
			iniciaRecoCirc();
		}
	}

	if (getReconhecendoCirc()){
		if (reconhecendoCirc()){
			golpeGiratorio();
		}
	}
}

bool Heroi::reconhecendoCirc(){
	//se esta com o stylus indo pra esq.
	if (getXReco() >= Stylus.X && getVoltaX(0) == false && getVoltaX(1) == false){
		setXReco(Stylus.X);
	}

	else if (getVoltaX(0) == false && getVoltaX(1) == false)
		setVoltaX(0, true);//se mudou de direcao

	//se esta com o stylus pra dir
	if (getXReco() <= Stylus.X && getVoltaX(0) && getVoltaX(1) == false){
		setXReco(Stylus.X);
	}

	else if (getVoltaX(0) && getVoltaX(1) == false)
		setVoltaX(1, true);//se mudou de direcao de novo

	//se esta indo pra dir pela segunda vez
	if (getVoltaX(1) && getVoltaX(2) == false && getXReco() >= Stylus.X && getVoltaX(0)){
		setXReco(Stylus.X);
		setVoltaX(2, true);
	}

	//se esta com o stylus indo pra baixo
	if (getYReco() <= Stylus.Y && getVoltaY(0) == false && getVoltaY(1) == false){
		setYReco(Stylus.Y);
	}
	else if (getVoltaY(0) == false) //se mudou de direcao
		setVoltaY(0, true);

	//se esta com o stylus indo pra cima
	if (getVoltaY(0) && getYReco() >= Stylus.Y && getVoltaY(1) == false){
		setYReco(Stylus.Y);
		setVoltaY(1, true);
	}

	//tirar o stylus da tela significa terminar o reconhecimento
	if (Stylus.Released){
		if (Stylus.Downtime >= 16 && Stylus.Downtime <= 25)
			if (getVoltaX(0) && getVoltaX(1) && getVoltaX(2) && getVoltaY(0) && getVoltaY(1)){
//				setReconhecendoCirc(false);
				return true;
			}
		iniciaVetRecCirc();

		setReconhecendoCirc(false);
	}

	return false;
}

void Heroi::ataca()
{
	/* Ataque se pressionar A e nao jah estiver atacando */
	espadada();
	intencaoGolpeGiratorio();

	/* Tempo de ataque */
	if(getStatus() == ATACANDO)
	{
		setTempoAtaque(ATAQUE_A, getTempoAtaque(ATAQUE_A) - 48);
	}

	/* Para o ataque e fica parado */
	if(getTempoAtaque(ATAQUE_A) < 0)
	{
		pahra();
		setStatus(PARADO); /* Heroi parado */
		setTempoAtaque(ATAQUE_A, 0);
	}
}

void Heroi::lancaMagia(Magia *magia)
{	
	//funcao que reconhece um traco e o angulo dele com o heroi
	if (Pad.Held.Down == 1){
		if (magia->getRecoAtivado() == false && PA_SpriteTouched(NF_EasyGetSpriteId(0,"heroi_ataque"))){
			magia->setXInicial (Stylus.X);
			magia->setYInicial (Stylus.Y);
			magia->setRecoAtivado (true);
			magia->setContMagiaVivo (0);
		}
	}

	//nao reconhece o movimento do stylus se a magia ainda estiver na tela
	if (Stylus.Released && magia->getRecoAtivado()){
		magia->setRecoAtivado (false);
		if (!magia->getVivo()){
			if (PA_Distance(magia->getXInicial(), magia->getYInicial(), Stylus.X, Stylus.Y) >= 40*40){
				magia->setAtivado(true);
				magia->setVivo(true);
			}
		}
	}
	//fim da funcao que reconhece o traco

	if(magia->getAtivado())
	{
		magia->setAtivado(false);
		setTempoAtaque(ATAQUE_A, 2300);
		setStatus(LANCANDO_MAGIA);
		PA_WaitForVBL();
		PA_WaitForVBL();

		if(getDirecao() == CIMA) /* UP */
		{
			magia->iniciaMagia (getPosicaoCenarioX(), getPosicaoCenarioY(), magia->getAngulo(), CIMA);
			PA_StartSpriteAnimEx(0, enderecoHeroi, LANCANDO_MAGIA_INICIO_CIMA, LANCANDO_MAGIA_FIM_CIMA, VELOCIDADE_ANIMACAO_MAGIA, ANIM_ONESHOT);
		}
		else if(getDirecao() == BAIXO) /* DOWN */
		{
			magia->iniciaMagia (getPosicaoCenarioX(), getPosicaoCenarioY(), magia->getAngulo(), BAIXO);
			PA_StartSpriteAnimEx(0, enderecoHeroi, LANCANDO_MAGIA_INICIO_BAIXO, LANCANDO_MAGIA_FIM_BAIXO, VELOCIDADE_ANIMACAO_MAGIA, ANIM_ONESHOT);
		}
		else if(getDirecao() == LADO_DIREITO) /* RIGHT */
		{
			magia->iniciaMagia (getPosicaoCenarioX(), getPosicaoCenarioY(), magia->getAngulo(), LADO_DIREITO);
			PA_StartSpriteAnimEx(0, enderecoHeroi, LANCANDO_MAGIA_INICIO_LADO, LANCANDO_MAGIA_FIM_LADO, VELOCIDADE_ANIMACAO_MAGIA, ANIM_ONESHOT);
			PA_SetSpriteHflip(0, 0, 1);
		}
		else if(getDirecao() == 4) /* LEFT */
		{
			magia->iniciaMagia (getPosicaoCenarioX(), getPosicaoCenarioY(), magia->getAngulo(), LADO_ESQUERDO);
			PA_StartSpriteAnimEx(0, enderecoHeroi, LANCANDO_MAGIA_INICIO_LADO, LANCANDO_MAGIA_FIM_LADO, VELOCIDADE_ANIMACAO_MAGIA, ANIM_ONESHOT);
			PA_SetSpriteHflip(0, 0, 0);
		}
		magia->setAngulo(PA_GetAngle(magia->getXInicial(),
									 magia->getYInicial(),
									 Stylus.X,
									 Stylus.Y));
	}

	/* Tempo de ataque */
	if(getStatus() == LANCANDO_MAGIA)
	{
		setTempoAtaque(ATAQUE_A, getTempoAtaque(ATAQUE_A) - 48);
	}

	/* Para o ataque e fica parado */
	if(getTempoAtaque(ATAQUE_A) < 0)
	{
		pahra();
		setStatus(PARADO); /* Heroi parado */
		setTempoAtaque(ATAQUE_A, 0);
	}

}

//verifica se realizou o clique duplo
void Heroi::duploClique(){
	if (Stylus.Released && Stylus.Downtime <= 7)
		setDuploClique(getDuploClique() + 1);
	else if (Stylus.Downtime > 7)
		setDuploClique(0);
}

void Heroi::espadada()
{
	duploClique();

	//if((Stylus.DblClick) && (!Pad.Held.Left) && (getStatus() != ATACANDO))
	if (getDuploClique() == 2){
		if (getUsandoEspiritoDoFogo() == false){
			if(!Pad.Held.Down && (getStatus() != ATACANDO))
			{
				setTempoAtaque(ATAQUE_A, 1150);
				setStatus(ATACANDO);
				carregaEfeito("efeitoEspadada", "espadada");
				playEfeito("efeitoEspadada");
				descarregaEfeito("efeitoEspadada");
				PA_WaitForVBL();
				PA_WaitForVBL();
				PA_WaitForVBL();
				
				if(getDirecao() == CIMA) /* UP */
				{
					PA_StartSpriteAnimEx(0, enderecoHeroi, ATAQUE_A_INICIO_CIMA, ATAQUE_A_FIM_CIMA, VELOCIDADE_ATAQUE, ANIM_ONESHOT);
				}
				else if(getDirecao() == BAIXO) /* DOWN */
				{
					PA_StartSpriteAnimEx(0, enderecoHeroi, ATAQUE_A_INICIO_BAIXO, ATAQUE_A_FIM_BAIXO, VELOCIDADE_ATAQUE, ANIM_ONESHOT);
					}
				else if(getDirecao() == LADO_DIREITO) /* RIGHT */
				{
					PA_StartSpriteAnimEx(0, enderecoHeroi, ATAQUE_A_INICIO_LADO, ATAQUE_A_FIM_LADO, VELOCIDADE_ATAQUE, ANIM_ONESHOT);
					PA_SetSpriteHflip(0, 0, 1);
				}
				else if(getDirecao() == 4) /* LEFT */
				{
					PA_StartSpriteAnimEx(0, enderecoHeroi, ATAQUE_A_INICIO_LADO, ATAQUE_A_FIM_LADO, VELOCIDADE_ATAQUE, ANIM_ONESHOT);
					PA_SetSpriteHflip(0, 0, 0);
				}
			}
		}
		else{
			if(!Pad.Held.Down && (getStatus() != ATACANDO))
			{
				//verifica se possui mp o suficiente pra lancar a espadada de fogo
				if (getMp() >= 2){
					setTempoAtaque(ATAQUE_A, 1150);
					setStatus(ATACANDO);
					carregaEfeito("efeitoEspadada", "espadada");
					playEfeito("efeitoEspadada");
					descarregaEfeito("efeitoEspadada");
					PA_WaitForVBL();
					PA_WaitForVBL();
					PA_WaitForVBL();
						
					if(getDirecao() == CIMA) /* UP */
					{
						PA_StartSpriteAnimEx(0, enderecoHeroi, ATAQUE_ESPADA_FOGO_INICIO_CIMA, ATAQUE_ESPADA_FOGO_FIM_CIMA, VELOCIDADE_ATAQUE, ANIM_ONESHOT);
					}
					else if(getDirecao() == BAIXO) /* DOWN */
					{
						PA_StartSpriteAnimEx(0, enderecoHeroi, ATAQUE_ESPADA_FOGO_INICIO_BAIXO, ATAQUE_ESPADA_FOGO_FIM_BAIXO, VELOCIDADE_ATAQUE, ANIM_ONESHOT);
					}
					else if(getDirecao() == LADO_DIREITO) /* RIGHT */
					{
						PA_StartSpriteAnimEx(0, enderecoHeroi, ATAQUE_ESPADA_FOGO_INICIO_LADO, ATAQUE_ESPADA_FOGO_FIM_LADO, VELOCIDADE_ATAQUE, ANIM_ONESHOT);
						PA_SetSpriteHflip(0, 0, 1);
					}
					else if(getDirecao() == 4) /* LEFT */
					{
						PA_StartSpriteAnimEx(0, enderecoHeroi, ATAQUE_ESPADA_FOGO_INICIO_LADO, ATAQUE_ESPADA_FOGO_FIM_LADO, VELOCIDADE_ATAQUE, ANIM_ONESHOT);
						PA_SetSpriteHflip(0, 0, 0);
					}
	
					setMp(getMp() - 2);
				}
			}
		}
		setDuploClique(0);
	}
}

void Heroi::golpeGiratorio()
{
		setStatus(ATACANDO);
		if(getUsandoEspiritoDoFogo())
		{
			setTempoAtaque(ATAQUE_A, 900);
			PA_StartSpriteAnimEx(0, enderecoHeroi, 102, 107, 20, ANIM_ONESHOT);
		}
		else 
		{
			setTempoAtaque(ATAQUE_A, 1000);
			PA_StartSpriteAnimEx(0, enderecoHeroi, 68, 74, 20, ANIM_ONESHOT);
		}
}



/* Vira o heroi para o lado correto */
void Heroi::vira(u16 angulo)
{
	// Cima
	if(angulo > 62  && angulo < 190)
	{
		if(getDirecao() != CIMA)
		{
			PA_StartSpriteAnim(0, enderecoHeroi, INICIO_SPRITE_ANDANDO_CIMA, FIM_SPRITE_ANDANDO_CIMA, getVelocidade());
		}
		setDirecao(CIMA);
	}
		// Baixo
	if(angulo > 316 && angulo < 443)
	{
		if(getDirecao() != BAIXO)
		{
			PA_StartSpriteAnim(0, enderecoHeroi, INICIO_SPRITE_ANDANDO_BAIXO, FIM_SPRITE_ANDANDO_BAIXO, getVelocidade());
		}
		setDirecao(BAIXO);
	}
	
	// Direita
	if(angulo > 442 || angulo < 63) 
	{
		if(getDirecao() != LADO_DIREITO)
		{
			PA_StartSpriteAnim(0, enderecoHeroi, INICIO_SPRITE_ANDANDO_LADO, FIM_SPRITE_ANDANDO_LADO, getVelocidade());
			PA_SetSpriteHflip(0, 0, 1);
		}
		setDirecao(LADO_DIREITO);
	}

	// Esquerda
	if(angulo > 189 && angulo < 317) 
	{
		if(getDirecao() != LADO_ESQUERDO)
		{
			PA_StartSpriteAnim(0, enderecoHeroi, INICIO_SPRITE_ANDANDO_LADO, FIM_SPRITE_ANDANDO_LADO, getVelocidade());
			PA_SetSpriteHflip(0, 0, 0);
		}
		setDirecao(LADO_ESQUERDO);
	}
}

/* Para a animacao do heroi */
void Heroi::pahra()
{
	switch(getDirecao())
	{
		case CIMA:
			PA_SetSpriteAnim(0, enderecoHeroi, INICIO_SPRITE_ANDANDO_CIMA);
			break;	
		case BAIXO:
			PA_SetSpriteAnim(0, enderecoHeroi, INICIO_SPRITE_ANDANDO_BAIXO);
			break;
		case LADO_DIREITO:
			PA_SetSpriteAnim(0, enderecoHeroi, INICIO_SPRITE_ANDANDO_LADO);
			PA_SetSpriteHflip(0, enderecoHeroi, 1);
			break;
		case LADO_ESQUERDO:
			PA_SetSpriteAnim(0, enderecoHeroi, INICIO_SPRITE_ANDANDO_LADO);
			PA_SetSpriteHflip(0, enderecoHeroi, 0);
			break;
		default:
			PA_SetSpriteAnim(0, enderecoHeroi, INICIO_SPRITE_ANDANDO_BAIXO);
	}
}

/* Atualiza as novas posicoes */
void Heroi::atualizaPosicoes(u16 angulo)
{
	if(direcaoColisaoHorizontal != 1)
	{
		setPosicaoTelaX(getPosicaoTelaX() + PA_Cos(angulo));
		setPosicaoCenarioX(getPosicaoCenarioX() + PA_Cos(angulo));
	}

	if(direcaoColisaoVertical != 1)
	{
		setPosicaoTelaY(getPosicaoTelaY() - PA_Sin(angulo));
		setPosicaoCenarioY(getPosicaoCenarioY() - PA_Sin(angulo));
	}
}

/* Funcao responsavel pela movimentacao do heroi */
void Heroi::movimenta(u16 angulo, const char* referencia)
{
    atualizaPosicoes(angulo);
	
	/* No cenario do INN, nao precisa de scroll de cenario em nenhuma direcao.
	  * Entao, se a referencia do cenario em que o heroi esta � "inn", nao ha necessidade de controlar a movimentacao 
	  * para os lados, para cima, ou para baixo. */
	if (strcmp(referencia, "inn") == 0) {
		return;
	}
	
	/* Nos cenarios do castelo e da rocha, nao precisa de scroll lateral. So atualiza o scroll vertical. */
	else if (strcmp(referencia, "castelo") == 0 || strcmp(referencia, "Rocha") == 0) {
		movimentaParaCima(angulo);
		movimentaParaBaixo(angulo);
	}

	/*nos cenarios de batalha nao precisamos de scroll vertical, portando usamos apenas os laterais*/
	else if (strcmp(referencia, "batalhaMapa") == 0 || 
			strcmp(referencia, "batalhaRocha") == 0 || 
			strcmp(referencia, "batalhaDeserto") == 0 || 
			strcmp(referencia, "batalhaFloresta") == 0 || 
			strcmp (referencia, "batalhaCaverna") == 0){
		movimentaParaLadoDireito(angulo);
		movimentaParaLadoEsquerdo(angulo);
	}
	
	/* Nos outros cenarios, atualiza os scrolls normalmente */
	else {
		movimentaParaCima(angulo);
		movimentaParaBaixo(angulo);
		movimentaParaLadoDireito(angulo);
		movimentaParaLadoEsquerdo(angulo);
	}	

	direcaoColisaoHorizontal = 0;
	direcaoColisaoVertical = 0;
}

void Heroi::movimentaParaLadoEsquerdo(u16 angulo)
{
	/* Caso o heroi tah quase no fim da tela, mas o cenario nao acabou, fixe o heroi nessa posicao*/
	if((fix_norm(getPosicaoTelaX()) < 64) && ((fix_norm(getPosicaoCenarioX()))>=64))
	{
		setPosicaoTelaX(norm_fix(64));
	}

	/* desliza o cenario */
	if(((fix_norm(getPosicaoCenarioX() - getScrollX())) > 160) && ((fix_norm(getPosicaoCenarioX()) < (512 - 96))))
	{
		setScrollX(getPosicaoCenarioX() - (norm_fix(160)));
	}
	else if(((fix_norm(getPosicaoCenarioX() - getScrollX()) < 64)) && ((fix_norm(getPosicaoCenarioX())) > 64))
	{
		setScrollX(getPosicaoCenarioX() - (norm_fix(64)));
	}
}

void Heroi::movimentaParaLadoDireito(u16 angulo)
{
	/* Caso o heroi tah quase no fim da tela, mas o cenario nao acabou, fixe o heroi nessa posicao*/
	if(((fix_norm(getPosicaoTelaX())>160)) && ((fix_norm(getPosicaoCenarioX()))< (512-96)))
	{
		setPosicaoTelaX(norm_fix(160));
	}

	/* desliza o cenario */
	if(((fix_norm(getPosicaoCenarioX() - getScrollX())) > 160) && ((fix_norm(getPosicaoCenarioX()) < (512 - 96))))
	{
		setScrollX(getPosicaoCenarioX() - (norm_fix(160)));
	}
}

void Heroi::movimentaParaBaixo(u16 angulo)
{
	/* Caso o heroi tah quase no fim da tela, mas o cenario nao acabou, fixe o heroi nessa posicao*/
	if(((fix_norm(getPosicaoTelaY())>150)) && ((fix_norm(getPosicaoCenarioY()))< (512-40)))
	{
		setPosicaoTelaY(norm_fix(150));
	}

	/* desliza o cenario */
	if(((fix_norm(getPosicaoCenarioY() - getScrollY())) > 150) && ((fix_norm(getPosicaoCenarioY()) < (512 - 40))))
	{
		setScrollY(getPosicaoCenarioY() - (norm_fix(150)));
	}
}

void Heroi::movimentaParaCima(u16 angulo)
{
	/* Caso o heroi tah quase no fim da tela, mas o cenario nao acabou, fixe o heroi nessa posicao*/
	if((fix_norm(getPosicaoTelaY()) < 64) && ((fix_norm(getPosicaoCenarioY()))>=64))
	{
		setPosicaoTelaY(norm_fix(64));
	}

	/* desliza o cenario */
	if(((fix_norm(getPosicaoCenarioY() - getScrollY())) > 150) && ((fix_norm(getPosicaoCenarioY()) < (512 - 96))))
	{
		setScrollY(getPosicaoCenarioY() - (norm_fix(150)));
	}
	else if(((fix_norm(getPosicaoCenarioY() - getScrollY()) < 64)) && ((fix_norm(getPosicaoCenarioY())) > 64))
	{
		setScrollY(getPosicaoCenarioY() - (norm_fix(64)));
	}
}

void Heroi::posicaoCenario(s16 pos_cenario[])
{
	s16 temp;
	if (getDirecao() == CIMA){
		temp = getPosicaoTelaY() - Stylus.Y;
		pos_cenario[1] = getPosicaoTelaY() + temp;
	}
	if (getDirecao() == BAIXO){
		temp = Stylus.Y - getPosicaoTelaY();
		pos_cenario[1] = getPosicaoTelaY() + temp;
	}
	if (getDirecao() == LADO_DIREITO){
		temp = Stylus.X - getPosicaoTelaX();
		pos_cenario[0] = getPosicaoTelaX() + temp;
	}
	if (getDirecao() == LADO_ESQUERDO){
		temp = getPosicaoTelaX() - Stylus.X;
		pos_cenario[0] = getPosicaoTelaX() + temp;
	}
}

/* Funcao que faz o heroi andar na tela e no cenario e verifica se ele colide com o cenario */
void Heroi::anda(s16 pos_cenario[], Cenario *cenario)
{
	int trocou_cenario = 0;
	u8 tipoCenario, flag;
	flag = 0;
	
	/*PA_OutputText(0 ,0 , 1, "                                        ");
	PA_OutputText(0 ,0 , 1, "PosTela: %d %d", fix_norm(getPosicaoTelaX()), fix_norm(getPosicaoTelaY()));

	PA_OutputText(0 ,2 , 2, "                                        ");
	PA_OutputText(0 ,2 , 2, "PosCenario: %d %d", fix_norm(getPosicaoCenarioX()), fix_norm(getPosicaoCenarioY()));

	PA_OutputText(0 ,3 , 3, "                                        ");
	PA_OutputText(0 ,3 , 3, "PosScroll: %d %d", fix_norm(getScrollX()), fix_norm(getScrollY()));*/

	if(getStatus() == ATACANDO)
	{
		return;
	}

	if(getStatus() == LANCANDO_MAGIA)
	{
		return;
	}

	if(getStatus() == PARADO)
	{
		setStatus(ATACOU);
		return;
	}


	if(Stylus.Newpress)
		setDirecao(0);


	if(Stylus.Held) 
	{
		setStatus(ANDANDO);
		angulo = PA_GetAngle((fix_norm(getPosicaoTelaX())), (fix_norm(getPosicaoTelaY())), Stylus.X, Stylus.Y);
		vira(getAngulo());
		movimenta(getAngulo(), cenario->getReferencia());
	}
	else
	{
		pahra();
	}
	
	if(getStatus() == ATACOU)
	{
		pos_cenario[0] = 0;
		pos_cenario[1] = 0;
	}

	if(pos_cenario[0] > 127 || pos_cenario[1] > 96)
	{/*
		if (*direcao == 1 || *direcao == 2) // Cima e Baixo
			setScrollY(getScrollY() - PA_Sin(*angulo));
		if (*direcao == 3 || *direcao == 4) // Direita e Esquerda
			setScrollX(getScrollX() + PA_Cos(*angulo));*/
	}
	NF_EasyMoveSprite(0, getNome(), (fix_norm(getPosicaoTelaX())) - 32, (fix_norm(getPosicaoTelaY())) - 32);
	//PA_SetSpriteXY(0, 0, (fix_norm(getPosicaoTelaX())) - 32, (fix_norm(getPosicaoTelaY())) - 32);
	if (getTrocouCenario() > 0){
		pahra();
		setTrocouCenario(getTrocouCenario() + 1);
		if (getTrocouCenario() == 5){
			transicao_clarear();
			setTrocouCenario(0);
		}
	}
}

void Heroi::carregaSprite(u8 tipoSprite, u8 descarrega)
{
	if(descarrega != 1)
	{
		if(tipoSprite == 0)
		{
			NF_EasyLoadGfx ("heroi_andando", "heroi", 64, 64);
			NF_EasyLoadPal ("heroi_andando_paleta", "heroi");
			NF_EasyCreateSprite(0, "heroi_andando", "heroi_andando", "heroi_andando_paleta", fix_norm(getPosicaoTelaX()), fix_norm(getPosicaoTelaY()));
			NF_EasySetSpriteLayer(0, "heroi_andando", 1);
			enderecoHeroi = NF_EasyGetSpriteId(0, "heroi_andando");
			setNome("heroi_andando");
		}
		else if(tipoSprite == 1) // heroi com ataque
		{
			NF_EasyLoadGfx ("heroi_ataque", "heroiAtaque", 64, 64);
			NF_EasyLoadPal ("heroi_ataque_paleta", "heroiAtaque");
			NF_EasyCreateSprite(0, "heroi_ataque", "heroi_ataque", "heroi_ataque_paleta", fix_norm(getPosicaoTelaX()), fix_norm(getPosicaoTelaY()));
			NF_EasySetSpriteLayer(0, "heroi_ataque", 1);
			enderecoHeroi = NF_EasyGetSpriteId(0, "heroi_ataque");
			setNome("heroi_ataque");
		}
		else
		{
			NF_EasyLoadGfx ("heroi_mapa", "heroiMapa", 16, 16);
			NF_EasyLoadPal ("heroi_mapa_paleta", "heroiMapa");
			NF_EasyCreateSprite(0, "heroi_mapa", "heroi_mapa", "heroi_mapa_paleta", fix_norm(getPosicaoTelaX()), fix_norm(getPosicaoTelaY()));
			NF_EasySetSpriteLayer(0, "heroi_mapa", 1);
			enderecoHeroi = NF_EasyGetSpriteId(0, "heroi_mapa");
			setNome("heroi_mapa");
		}
	}

	if(descarrega == 1)
	{
		if(tipoSprite == 0)
		{
			NF_EasyDeleteSprite(0, "heroi_andando");
			NF_EasyDeleteGfx("heroi_andando");
			NF_EasyDeletePal("heroi_andando_paleta");
		}
		else if(tipoSprite == 1)
		{
			NF_EasyDeleteSprite(0, "heroi_ataque");
			NF_EasyDeleteGfx("heroi_ataque");
			NF_EasyDeletePal("heroi_ataque_paleta");
		}
		else
		{
			NF_EasyDeleteSprite(0, "heroi_mapa");
			NF_EasyDeleteGfx("heroi_mapa");
			NF_EasyDeletePal("heroi_mapa_paleta");
		}
	}
}

void Heroi::inicializa(s32 screenPosX, s32 screenPosY)
{
	PA_SetSpriteXY(0, 0, screenPosX, screenPosY);
	setPosicaoTelaX(norm_fix(screenPosX));
	setPosicaoTelaY(norm_fix(screenPosY));
	setPosicaoCenarioX(norm_fix(screenPosX));
	setPosicaoCenarioY(norm_fix(screenPosY));
	setContTomouDano(0);
	setTomouDano(false);
	setScrollX(norm_fix(0));
	setScrollY(norm_fix(0));
	setHp(100);
	setHpMax(100);
	setMp (30);
	setMpMax (30);
	setPtsAtaque(4);
	setPtsDefesa(2);
	setPtsEvasao(1);
	setPtsMagia (2);
	setExperiencia (0);
	setExperienciaMax (25);
	setXPMagia (0);
	setXPMagiaMax(50);
	setDinheiro (0);
	setNivel (1);
	setNivelMagia (1);
	setStatus(PARADO);
	setTrocouCenario(0);
	angulo = 0;
	setUsandoEspiritoDoFogo(false);
	setDuploClique(0);
	setReconhecendoCirc(false);
	setXReco(0);
	setYReco(0);
	mochila = new ListaLigada();
}
