/*=========================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	Broken Soul is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
============================================================================*/
#include "include/Inimigo.hpp"
#include "include/Sound.hpp"
#include "include/colisao.hpp"

char *Inimigo::getNomeArquivo(){
	return _nomeArquivo;
}

void Inimigo::setNomeArquivo(char nomeArquivo[]){
	strcpy(_nomeArquivo, nomeArquivo);
}

s32 Inimigo::getMp()
{
	return _sp;
}

void Inimigo::setHpMax(u16 hpMax)
{
	_hp_max = hpMax;
}

u16 Inimigo::getHpMax()
{
	return _hp_max;
}

void Inimigo::setMp(s32 sp)
{
	_sp = sp;
}

s32 Inimigo::getDinheiro()
{
	return _dinheiro;
}

void Inimigo::setDinheiro(s32 dinheiro)
{
	_dinheiro = dinheiro;
}

void Inimigo::setViradoPraDireita(bool virado){
	_direita = virado;
}

bool Inimigo::getViradoPraDireita(){
	return _direita;
}

void Inimigo::setTomouDano(bool tomou){
	_tomouDano = tomou;
}

bool Inimigo::getTomouDano(){
	return _tomouDano;
}

s32 Inimigo::getNivel()
{
	return _nivel;
}

void Inimigo::setNivel(s32 nivel)
{
	_nivel = nivel;
}

u16 Inimigo::getTamSprite (){
	return _tamanho_sprite;
}

void Inimigo::setTamSprite (u16 tam){
	_tamanho_sprite = tam;
}

s32 Inimigo::getXPMagia()
{
	return _xp_magia;
}

void Inimigo::setXPMagia(s32 xp_magia)
{
	_xp_magia = xp_magia;
}

s32 Inimigo::getNivelMagia()
{
	return _nivel_magia;
}

void Inimigo::setNivelMagia(s32 nivel_magia)
{
	_nivel_magia = nivel_magia;
}

u16 Inimigo::getFrameAnim ()
{
	return _frame;
}

void Inimigo::setFrameAnim (u16 frame)
{
	_frame = frame;
}

u16 Inimigo::getContTomouDano ()
{
	return _contTomouDano;
}

void Inimigo::setContTomouDano (u16 contTomouDano)
{
	_contTomouDano = contTomouDano;
}

bool Inimigo::getStatusAtacando ()
{
	return _atacando;
}

void Inimigo::setStatusAtacando (bool atacando)
{
	_atacando = atacando;
}

void Inimigo::setFatorVelocidade (int fator){
	_fatorVelocidade = fator;
}

void Inimigo::setComportamento (int tipoComportamento){
	_tipoComportamento = tipoComportamento;
}

bool Inimigo::getMorto (){
	return _morto;
}

void Inimigo::setDanoMagico(bool dano_magico){
	_dano_magico = dano_magico;
}

bool Inimigo::getDanoMagico(){
	return _dano_magico;
}

void Inimigo::setMorto (bool morto){
	_morto = morto;
}

int Inimigo::getFatorVelocidade (){
	return _fatorVelocidade;	
}

int Inimigo::getTipoComportamento (){
	return _tipoComportamento;
}

void Inimigo::iniciaEspinho(int i){
		setAtaque(3, 15);
		setHp(20);
		setHpMax(20);
		setMp(5);
		setExperiencia(13);
		setFrameAnim(0);
		setPosicaoCenarioX(norm_fix(100 + i*40));
		setPosicaoCenarioY(norm_fix(100));
		setFatorVelocidade(2);
		setContTomouDano(0);
		setViradoPraDireita(true);
		setTomouDano(false);
		setStatusAtacando(false);
		setTamSprite(32);
		setMorto(false);
		setComportamento(TRAICOEIRO);
		setDanoMagico(false);
}

void Inimigo::iniciaGelecaVerde(int i){
		setAtaque(3, 20);
		setHp(60);
		setHpMax(60);
		setMp(5);
		setExperiencia(8);
		setFrameAnim(0);
		setPosicaoCenarioX(norm_fix(100 + i*40));
		setPosicaoCenarioY(norm_fix(100));
		setFatorVelocidade(2);
		setContTomouDano(0);
		setViradoPraDireita(true);
		setTomouDano(false);
		setStatusAtacando(false);
		setTamSprite(32);
		setMorto(false);
		setComportamento(FUJAO);
		setDanoMagico(false);
}

void Inimigo::iniciaGelecaVermelho(int i){
		setAtaque(3, 10);
		setHp(30);
		setHpMax(30);
		setMp(5);
		setExperiencia(15);
		setFrameAnim(0);
		setPosicaoCenarioX(norm_fix(100 + i*40));
		setPosicaoCenarioY(norm_fix(100));
		setFatorVelocidade(3);
		setContTomouDano(0);
		setViradoPraDireita(true);
		setTomouDano(false);
		setStatusAtacando(false);
		setTamSprite(32);
		setMorto(false);
		setComportamento(AGRESSIVO);
		setDanoMagico(false);
}

void Inimigo::iniciaGelecaAzul(int i){
		setAtaque(3, 10);
		setHp(30);
		setHpMax(30);
		setMp(5);
		setExperiencia(11);
		setFrameAnim(0);
		setPosicaoCenarioX(norm_fix(100 + i*40));
		setPosicaoCenarioY(norm_fix(100));
		setFatorVelocidade(2);
		setContTomouDano(0);
		setViradoPraDireita(true);
		setTomouDano(false);
		setStatusAtacando(false);
		setTamSprite(32);
		setMorto(false);
		setComportamento(TRAICOEIRO);
		setDanoMagico(false);
}

void Inimigo::iniciaRocha(int i){
		setAtaque(3, 30);
		setHp(50);
		setHpMax(50);
		setMp(5);
		setExperiencia(15);
		setFrameAnim(0);
		setPosicaoCenarioX(norm_fix(100 + i*40));
		setPosicaoCenarioY(norm_fix(100));
		setFatorVelocidade(2);
		setContTomouDano(0);
		setViradoPraDireita(true);
		setTomouDano(false);
		setStatusAtacando(false);
		setTamSprite(32);
		setMorto(false);
		setComportamento(FUJAO);
		setDanoMagico(false);
}

void Inimigo::iniciaRocha2(int i){
		setAtaque(3, 10);
		setHp(40);
		setHpMax(40);
		setMp(5);
		setExperiencia(11);
		setFrameAnim(0);
		setPosicaoCenarioX(norm_fix(100 + i*40));
		setPosicaoCenarioY(norm_fix(100));
		setFatorVelocidade(3);
		setContTomouDano(0);
		setViradoPraDireita(true);
		setTomouDano(false);
		setStatusAtacando(false);
		setTamSprite(32);
		setMorto(false);
		setComportamento(TRAICOEIRO);
		setDanoMagico(false);
}

void Inimigo::anda(Heroi *heroi, char *nomeInimigo)
{
	s32 angulo;
	angulo = PA_GetAngle (fix_norm(heroi->getPosicaoCenarioX()) - 32, fix_norm(heroi->getPosicaoCenarioY()) - 32, fix_norm(getPosicaoCenarioX()) - 16, fix_norm(getPosicaoCenarioY()) - 16);

	//se o inimigo esta morrendo, mostra seu verdadeiro carater
	if (getHp() <= getHpMax() * 0.25){
		if (getTipoComportamento() == AGRESSIVO){
			agressivo (heroi, nomeInimigo, angulo);
		}
		else if (getTipoComportamento() == FUJAO){
			foge (heroi, nomeInimigo, angulo);		
		}
		else if (getTipoComportamento() == TRAICOEIRO){
			traicoeiro (heroi, nomeInimigo, angulo);
		}
	}
	else{
		setPosicaoCenarioX (getPosicaoCenarioX() - PA_Cos(angulo)/getFatorVelocidade());
		setPosicaoCenarioY (getPosicaoCenarioY() + PA_Sin(angulo)/getFatorVelocidade());
	}

	NF_EasyMoveSprite (0, nomeInimigo, fix_norm(getPosicaoCenarioX()) - (fix_norm(heroi->getScrollX())), fix_norm(getPosicaoCenarioY()) -  (fix_norm(heroi->getScrollY())));

}

void Inimigo::traicoeiro (Heroi *heroi, char *nomeInimigo, s32 angulo){
	s32 x_inimigo, x_heroi, y_inimigo, y_heroi;

	x_heroi = fix_norm(heroi->getPosicaoCenarioX());
	y_heroi = fix_norm(heroi->getPosicaoCenarioY());
	x_inimigo = fix_norm(getPosicaoCenarioX());
	y_inimigo = fix_norm(getPosicaoCenarioY());

	//calcula a area de visao do inimigo
	//se esta na area de visao, mas longe do heroi, foge
	if (PA_Distance(x_heroi-32, y_heroi-32, x_inimigo - (getTamSprite()/2), y_inimigo - (getTamSprite()/2)) <= 105*105){
		//se esta na area de alcance, inimigo vai atras do heroi de novo
		if (PA_Distance(x_heroi-32, y_heroi-32, x_inimigo - (getTamSprite()/2), y_inimigo - (getTamSprite()/2)) <= 50*50){
			agressivo (heroi, nomeInimigo, angulo);
		}
		else{
			foge (heroi, nomeInimigo, angulo);
		}
	}
}

void Inimigo::agressivo (Heroi *heroi, char *nomeInimigo, s32 angulo){
	setPosicaoCenarioX (getPosicaoCenarioX() - PA_Cos(angulo)/(getFatorVelocidade() / 1.5));
	setPosicaoCenarioY (getPosicaoCenarioY() + PA_Sin(angulo)/(getFatorVelocidade() / 1.5));
}

void Inimigo::foge (Heroi *heroi, char *nomeInimigo, s32 angulo){
	s32 x, y;

	x = getPosicaoCenarioX() + PA_Cos(angulo)/getFatorVelocidade();
	y = getPosicaoCenarioY() - PA_Sin(angulo)/getFatorVelocidade();

	//faz o inimigo fugir no eixo X do heroi
	if (fix_norm(x) <= 500 && fix_norm(x) >= 16)
		setPosicaoCenarioX (x);

	//faz o inimigo fugir no eixo Y do heroi
	if (fix_norm(y) >= 64 && fix_norm(y) <= 160)
		setPosicaoCenarioY (y);
	
//	NF_EasyMoveSprite (0, nomeInimigo, fix_norm(x) - fix_norm(heroi->getScrollX()), fix_norm(y) - fix_norm(heroi->getScrollY()));
}

//inimigo sendo jogado pra tras
void Inimigo::ehAcertado(Heroi *heroi, char *nomeInimigo){
	s32 angulo, x, y;

	angulo = PA_GetAngle (fix_norm(heroi->getPosicaoCenarioX()) - 32, fix_norm(heroi->getPosicaoCenarioY()) - 32, fix_norm(getPosicaoCenarioX()) - 16, fix_norm(getPosicaoCenarioY()) - 16);

 	x = getPosicaoCenarioX() + (2 * PA_Cos(angulo));
	y = getPosicaoCenarioY() - (2 * PA_Sin(angulo));

	//limites da tela "andavel" pro inimigo não ser empurrado pra fora dela
	if (fix_norm(x) <= 500 && fix_norm(x) >= 16)
		setPosicaoCenarioX (x);

	if (fix_norm(y) >= 64 && fix_norm(y) <= 160)
		setPosicaoCenarioY (y);

	NF_EasyMoveSprite (0, nomeInimigo, fix_norm(x) - fix_norm(heroi->getScrollX()), fix_norm(y) - fix_norm(heroi->getScrollY()));
}

bool Inimigo::colisaoComHeroi (Heroi *heroi){
	s32 x_heroi, y_heroi, x_inimigo, y_inimigo;

	x_heroi = fix_norm(heroi->getPosicaoCenarioX());
	y_heroi = fix_norm(heroi->getPosicaoCenarioY());
	x_inimigo =  fix_norm(getPosicaoCenarioX());
	y_inimigo =  fix_norm(getPosicaoCenarioY());

	if (PA_Distance(x_heroi - 32, y_heroi - 32, x_inimigo - (getTamSprite()/2), y_inimigo - (getTamSprite()/2)) <= 21*21)
		return true;

	return false;
}

void Inimigo::atualizaStatus (int id){
	PA_OutputText (1, 56, 5 + (6*id), "     ");
	PA_OutputText (1, 56, 7 + (6*id), "     ");
	PA_OutputText (1, 56, 5 + (6*id), "%c3%d", getHp());
	PA_OutputText (1, 56, 7 + (6*id), "%c3%d", getMp());
}

void Inimigo::comportamentoInimigo (Heroi *heroi, int flag_descarrega, int id_inimigo){

	if (getDanoMagico() == false){
		//se nao esta atacando, anda
		if (!getStatusAtacando()){
			//se colidir com o heroi, o inimigo ataca
			if (colisaoComHeroi(heroi)){
			//	PA_StartSpriteAnimEx  (0, NF_EasyGetSpriteId (0, getNomeArquivo()), 4, 7, 10, ANIM_LOOP, 1);
			//	setStatusAtacando (true);
			}
			else
				anda(heroi, getNomeArquivo());
		}
		//animacao do inimigo qndo ele esta atacando
		else if (getStatusAtacando() && flag_descarrega == 0){
			//qndo esta no ultimo frame, para o ataque
			if (getFrameAnim () == 7){
				PA_StartSpriteAnim (0, NF_EasyGetSpriteId (0, getNomeArquivo()), 0, 3, 5);
				setStatusAtacando(false);
			}
			//faz o scroll do inimigo qndo ele esta atacando
			NF_EasyMoveSprite (0, getNomeArquivo(), fix_norm(getPosicaoCenarioX()) - (fix_norm(heroi->getScrollX())), fix_norm(getPosicaoCenarioY()) -  (fix_norm(heroi->getScrollY())));
			setFrameAnim (PA_GetSpriteAnimFrame (0, NF_EasyGetSpriteId (0, getNomeArquivo())));
		}
		
		if (getContTomouDano() >= TEMPO_REPULSAO)
		{
			if(getHp() - heroi->getPtsAtaque() <= 0)
			{
				setHp(0);
			}
			else
			{
				setHp (getHp() - heroi->getPtsAtaque());
			}
	
			//atualiza o status depois de tomar porrada
			atualizaStatus(id_inimigo);
			setContTomouDano(0);
			PA_ClearTextBg(0);
			setTomouDano(false);
		}
		else if (getTomouDano() && getContTomouDano() < TEMPO_REPULSAO){
			setContTomouDano(getContTomouDano() + 1);
			ehAcertado(heroi, getNomeArquivo());
		}

		//verifica se morreu e desaparece com o sprite
		if (!getMorto() && (getHp() > 65000 || getHp() == 0)){
			setMorto (true);
			heroi->aumentaExperiencia(getExperiencia());
			NF_EasyMoveSprite (0, getNomeArquivo(), 900, 900);
			setHp(0);
			playEfeito("inimigoMorrendo");
		}
	}
	//nao se move se tomou a magia
	else{	
		NF_EasyMoveSprite (0, getNomeArquivo(), fix_norm(getPosicaoCenarioX()) - (fix_norm(heroi->getScrollX())), fix_norm(getPosicaoCenarioY()) -  (fix_norm(heroi->getScrollY())));
		setContTomouDano(getContTomouDano() + 1);
		if (getContTomouDano() >= 180){
			setContTomouDano (0);
			setDanoMagico (false);
		}
	}
}








