/*============================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        Broken Soul is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
============================================================================*/

#include "include/ListaLigada.hpp"

void ListaLigada::consertaId()
{
	u8 i;
	no *aux;

	aux = lista->prox;
	for(i = 0; i < qde; i++)
	{
		aux->item->setId(i);
		aux = aux->prox;
	}
}
// Construtor de classe
ListaLigada::ListaLigada()
{
	Item *itemTeste;

	lista = new no;
	lista->prox = NULL;
	lista->ant = NULL;
	lista->item = NULL;
	qde = 0;

	// MOCKUP
	/*itemTeste = new Item();
	itemTeste->setNome("Item HP");
	itemTeste->setAdicionaHp(50);
	itemTeste->setTipoItem(ITEM_HP);
	itemTeste->setQtde(1);
	adiciona(itemTeste);

	itemTeste = new Item();
	itemTeste->setNome("Item MP");
	itemTeste->setAdicionaHp(50);
	itemTeste->setTipoItem(ITEM_HP);
	itemTeste->setQtde(2);
	adiciona(itemTeste);*/
}

void ListaLigada::adiciona(Item *item)
{
	no *aux;

	aux = new no;
	aux->item = item;
	aux->prox = lista->prox;
	aux->ant = lista;

	if(lista->prox != NULL)
	{
		lista->prox->ant = aux;
	}

	lista->prox = aux;

	qde++;
	
	consertaId();
}

void ListaLigada::remove(u8 id)
{
	no *aux;

	aux = lista->prox;
	while(aux != NULL)
	{
		if(aux->item->getId() == id)
		{
			if(aux->ant != NULL)
			{
				aux->ant->prox = aux->prox;
			}

			if(aux->prox != NULL)
			{
				aux->prox->ant = aux->ant;
			}

			qde--;

			consertaId();
			free(aux);
			return;
		}
		aux = aux->prox;
	}
}

Item *ListaLigada::pegaItem(u8 id)
{
	no *aux;
	Item *itemRemovido;

	aux = lista->prox;
	while(aux != NULL)
	{
		if(aux->item->getId() == id)
		{
			return aux->item;
		}
		aux = aux->prox;
	}
}

bool ListaLigada::listaVazia()
{
	if(lista->prox == NULL)
		return true;

	return false;
}

void ListaLigada::listaItens()
{
	no *aux;
	u8 i;

	i = 0;
	if(!listaVazia())
	{
		aux = lista->prox;
		while(aux != NULL)
		{
			PA_OutputText (1, 11, 8 + i, "%s", aux->item->getNome());
			i++;
			aux = aux->prox;
		}
	}
}
