#include "include/Magia.hpp"
#include "include/comumLib.hpp"

#include <malloc.h>

bool Magia::getVivo(){
	return _vivo;
}

u16 Magia::getContMagiaVivo(){
	return _cont;
}

void Magia::setVivo(bool vivo){
	_vivo = vivo;
}

void Magia::setAngulo(u16 angulo){
	_angulo = angulo;
}

void Magia::setXInicial(s16 x){
	_x_inicial = x;
}

void Magia::setYInicial(s16 y){
	_y_inicial = y;
}

void Magia::setXFinal(s16 x){
	_x_final = x;
}

void Magia::setYFinal(s16 y){
	_y_final = y;
}

void Magia::setXMagia(s32 x){
	_x_magia = x;
}

void Magia::setYMagia(s32 y){
	_y_magia = y;
}

void Magia::setAtivado(bool ativo){
	_ativo = ativo;
}

void Magia::setRecoAtivado(bool ativado){
	_reco_ativado = ativado;
}

void Magia::setContMagiaVivo(u16 cont){
	_cont = cont;
}

void Magia::setColidiu(bool colidiu){
	_colidiu = colidiu;
}

u16 Magia::getAngulo(){
	return _angulo;
}

s32 Magia::getXMagia(){
	return _x_magia;
}

s32	Magia::getYMagia(){
	return _y_magia;
}

s16 Magia::getXInicial(){
	return _x_inicial;
}

s16	Magia::getYInicial(){
	return _y_inicial;
}

s16 Magia::getXFinal(){
	return _x_final;
}

s16	Magia::getYFinal(){
	return _y_final;
}

bool Magia::getAtivado(){
	return _ativo;
}

bool Magia::getRecoAtivado(){
	return _reco_ativado;
}

bool Magia::getColidiu(){
	return _colidiu;
}

void Magia::iniciaMagia(s32 heroiX, s32 heroiY, u16 angulo, u16 direcao){

	setColidiu(false);

	if (direcao == CIMA){
		setXMagia (heroiX - norm_fix(16));
		setYMagia (heroiY - norm_fix(32));
	}
	else if (direcao == BAIXO){
		setXMagia (heroiX);
		setYMagia (heroiY);
	}
	else if (direcao == LADO_ESQUERDO){
		setXMagia (heroiX - norm_fix(32));
		setYMagia (heroiY - norm_fix(16));
	}
	else if (direcao == LADO_DIREITO){
		setXMagia (heroiX);
		setYMagia (heroiY - norm_fix(16));
	}
	carregaSprite (0, "bola_de_fogo",
				  fix_norm(getXMagia()),
				  fix_norm(getYMagia()),
				  0, 32, 32, 0, 3, 16);
	NF_EasySetSpriteLayer(0, "bola_de_fogo", 2);
}

void Magia::atualizaMagia(u8 tela, s32 heroiScrollX, s32 heroiScrollY){
	s32 x, y;

	x = getXMagia() + PA_Cos(getAngulo());
	y = getYMagia() - PA_Sin(getAngulo());

	setXMagia(x);
	setYMagia(y);

	NF_EasyMoveSprite (0, "bola_de_fogo", fix_norm(getXMagia()) - fix_norm(heroiScrollX), fix_norm(getYMagia()) -  (fix_norm(heroiScrollY)));

	if (fix_norm(getXMagia()) >= 510 || fix_norm(getXMagia()) <= 5)
		setContMagiaVivo(151);

	if (fix_norm(getYMagia()) <= 10 || fix_norm(getYMagia()) >= 180)
		setContMagiaVivo(151);
}

void Magia::apagaMagia(){
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "bola_de_fogo"));
	descarregaSprite ("bola_de_fogo", 0);
}

bool Magia::colideMagia(s32 inimigoX, s32 inimigoY, u16 tam_sprite){

	if (PA_Distance(fix_norm(getXMagia()) - 8,
					fix_norm(getYMagia()) - 8,	
					fix_norm(inimigoX) - (tam_sprite/2),
					fix_norm(inimigoY) - (tam_sprite/2)) <= 13*13){
		setColidiu(true);
		return true;
	}

	return false;
}
	
void Magia::pegaFogo(){
	PA_StartSpriteAnim(0, NF_EasyGetSpriteId(0, "bola_de_fogo"), 4, 7, 10);
}

bool Magia::controlaMagia(s32 heroiScrollX, s32 heroiScrollY, s32 inimigoPosX, s32 inimigoPosY, u8 tamSprite, int atualizouPosicao){
	bool colide_magia = false;

	if (getColidiu() == false){
		if (atualizouPosicao == 0)
			atualizaMagia(0, heroiScrollX, heroiScrollY);

		//FAZER VERIFICACAO PRA COLIDIR COM TODOS OS INIMIGOS	
		colide_magia = colideMagia(inimigoPosX, inimigoPosY, tamSprite);

		if (colide_magia){
			pegaFogo();
		}
	}
	else{
		NF_EasyMoveSprite ( 0, "bola_de_fogo",
							fix_norm(getXMagia()) - fix_norm(heroiScrollX),
							fix_norm(getYMagia()) -  fix_norm(heroiScrollY));
	}


	return colide_magia;
}

void Magia::tempoDeVidaMagia(){
	setContMagiaVivo(getContMagiaVivo() + 1);
	if (getContMagiaVivo() >= 120){
		setVivo(false);
		apagaMagia();
	}
}








