/*=========================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	Broken Soul is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
=========================================================================*/

#include "include/NPC.hpp"

/*matriz que guarda as posicoes e quanto cada NPC anda ate inverter seu percurso*/
s16 pos_sprite_cidade[10][3];
int tempo = 0;
bool atualiza[10] = {true, true, true, true, true, true, true, true, true, true};
bool inverte[10] = {false, false, false, false, false, false, false, false, false, false};
bool sprite_cidade_carregado[10] = {true, true, true, true, true, true, true, true, true, true};
int tempo_espera[9];

s16 pos_sprite_floresta[3][3];
bool atualiza_sprite_floresta[3] = {true, true, true};
bool inverte_sprite_floresta[3] = {false, false, false};
int espera_sprite_floresta[3];

s16 pos_sprite_castelo[3][3];
bool atualiza_sprite_castelo[3] = {true, true, true};

s16 pos_sprite_caverna[2][2];

s16 pos_sprite_deserto[1][2];

void iniciaSpriteDeserto(){
	pos_sprite_deserto[CARA_DO_DESERTO_ID][0] = CARA_DO_DESERTO_X;
	pos_sprite_deserto[CARA_DO_DESERTO_ID][1] = CARA_DO_DESERTO_Y;
}

void carregaSpriteDeserto(){
	iniciaSpriteDeserto();
	carregaSprite (0, "cara_do_deserto", pos_sprite_deserto[CARA_DO_DESERTO_ID][0], pos_sprite_deserto[CARA_DO_DESERTO_ID][1], 0, 32, 32, 0, 3, 4);
}

void descarregaSpriteDeserto(){
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "cara_do_deserto"));
	descarregaSprite("cara_do_deserto", 0);
}

void scrollSpriteDeserto(Heroi *heroi, u8 tipo){
	scrollSprite (0, "cara_do_deserto", pos_sprite_deserto[CARA_DO_DESERTO_ID][0], pos_sprite_deserto[CARA_DO_DESERTO_ID][1], heroi);
}

void iniciaSpriteCastelo (){
	pos_sprite_castelo[REI_ID][0] = REI_X;
	pos_sprite_castelo[REI_ID][1] = REI_Y;
	pos_sprite_castelo[RAINHA_ID][0] = RAINHA_X;
	pos_sprite_castelo[RAINHA_ID][1] = RAINHA_Y;
	pos_sprite_castelo[MAGO_ID][0] = MAGO_X;
	pos_sprite_castelo[MAGO_ID][1] = MAGO_Y;
}

void iniciaSpriteCidade (){
	pos_sprite_cidade[GOKU_ID][0] = GOKU_X;
	pos_sprite_cidade[GOKU_ID][1] = GOKU_Y;
	pos_sprite_cidade[GOKU_ID][2] = 50;
	tempo_espera[GOKU_ID] = 500;

	pos_sprite_cidade[SENHORA_AZUL_ID][0] = SENHORA_AZUL_X;
	pos_sprite_cidade[SENHORA_AZUL_ID][1] = SENHORA_AZUL_Y;
	pos_sprite_cidade[SENHORA_AZUL_ID][2] = 70;
	tempo_espera[SENHORA_AZUL_ID] = 800;

	pos_sprite_cidade[IRMA_ID][0] = IRMA_X;
	pos_sprite_cidade[IRMA_ID][1] = IRMA_Y;
	
	pos_sprite_cidade[GIRL_ID][0] = GIRL_X;
	pos_sprite_cidade[GIRL_ID][1] = GIRL_Y;
	
	pos_sprite_cidade[BOY_ID][0] = BOY_X;
	pos_sprite_cidade[BOY_ID][1] = BOY_Y;
	
	pos_sprite_cidade[SENHORA_BRANCO_ID][0] = SENHORA_BRANCO_X;
	pos_sprite_cidade[SENHORA_BRANCO_ID][1] = SENHORA_BRANCO_Y;
	pos_sprite_cidade[SENHORA_BRANCO_ID][2] = 40;
	tempo_espera[SENHORA_BRANCO_ID] = 900;
	
	pos_sprite_cidade[FAZENDEIRO_MORENO_ID][0] = FAZENDEIRO_MORENO_X;
	pos_sprite_cidade[FAZENDEIRO_MORENO_ID][1] = FAZENDEIRO_MORENO_Y;

	pos_sprite_cidade[GALINHA_ID][0] = GALINHA_X;
	pos_sprite_cidade[GALINHA_ID][1] = GALINHA_Y;
	pos_sprite_cidade[GALINHA_ID][2] = 40;
	tempo_espera[GALINHA_ID] = 100;

	pos_sprite_cidade[FAZENDEIRO_LOIRO_ID][0] = FAZENDEIRO_LOIRO_X;
	pos_sprite_cidade[FAZENDEIRO_LOIRO_ID][1] = FAZENDEIRO_LOIRO_Y;

	pos_sprite_cidade[SENHOR_ID][0] = SENHOR_X;
	pos_sprite_cidade[SENHOR_ID][1] = SENHOR_Y;
	pos_sprite_cidade[SENHOR_ID][3] = 50;

}

void inicializaBau()
{
	pos_sprite_caverna[1][0] = 29;
	pos_sprite_caverna[1][1] = 232;
}

void carregaSpriteBau(u8 frameBau)
{	
	inicializaBau();

	carregaSpriteNaoAnimado(0, "bau", pos_sprite_caverna[1][0], pos_sprite_caverna[1][1], 16, 16);
	NF_EasySetSpriteFrame(0, "bau", frameBau);
	NF_EasySetSpriteLayer(0, "bau", 3);

}

void descarregaSpriteBau()
{
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "bau"));
	descarregaSprite("bau", 0);
}

void scrollItemBau(Heroi *heroi)
{
	scrollSprite (0, "bau", pos_sprite_caverna[1][0], pos_sprite_caverna[1][1], heroi);
}

void carregaSpriteCastelo(){
	iniciaSpriteCastelo();

	carregaSprite (0, "rei", pos_sprite_castelo[REI_ID][0], pos_sprite_castelo[REI_ID][1], 0, 32, 32, 0, 3, 4);
	carregaSprite (0, "rainha", pos_sprite_castelo[RAINHA_ID][0], pos_sprite_castelo[RAINHA_ID][1], 0, 32, 32, 0, 3, 4);
	carregaSprite (0, "magoVelho", pos_sprite_castelo[MAGO_ID][0], pos_sprite_castelo[MAGO_ID][1], 0, 32, 32, 8, 11, 4);
}

void descarregaSpriteCastelo()
{
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "rei"));
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "rainha"));
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "magoVelho"));
	
	descarregaSprite("rei", 0);
	descarregaSprite("rainha", 0);
	descarregaSprite("magoVelho", 0);
}

void scrollNPCCastelo(Heroi *heroi, u8 tipo){
	scrollSprite (0, "rei", pos_sprite_castelo[REI_ID][0], pos_sprite_castelo[REI_ID][1], heroi);
	scrollSprite (0, "rainha", pos_sprite_castelo[RAINHA_ID][0], pos_sprite_castelo[RAINHA_ID][1], heroi);
	scrollSprite (0, "magoVelho", pos_sprite_castelo[MAGO_ID][0], pos_sprite_castelo[MAGO_ID][1], heroi);
}

void iniciaSpriteFloresta(){
/*	pos_sprite_floresta[BORBOLETA1_ID][0] = ;
	pos_sprite_floresta[BORBOLETA1_ID][1] = ;
	pos_sprite_floresta[BORBOLETA1_ID][2] = ;
	espera_sprite_floresta[BORBOLETA1_ID] = ;

	pos_sprite_floresta[BORBOLETA2_ID][0] = ;
	pos_sprite_floresta[BORBOLETA2_ID][1] = ;
	pos_sprite_floresta[BORBOLETA2_ID][2] = ;
	espera_sprite_floresta[BORBOLETA2_ID] = ;*/

	pos_sprite_floresta[CARA_FLORESTA_ID][0] = CARA_FLORESTA_X;
	pos_sprite_floresta[CARA_FLORESTA_ID][1] = CARA_FLORESTA_Y;
//	pos_sprite_floresta[CARA_FLORESTA][2] = ;

}

void carregaSpriteFloresta(){
	iniciaSpriteFloresta();

	carregaSprite (0, "cara_da_floresta", pos_sprite_floresta[CARA_FLORESTA_ID][0]-16, pos_sprite_floresta[CARA_FLORESTA_ID][1]-16, 0, 32, 32, 0, 3, 4);
	PA_SetSpriteHflip(0, NF_EasyGetSpriteId(0, "cara_da_floresta"), 1);
}

void scrollNPCFloresta (Heroi *hero, u8 tipo){
	scrollSprite (0, "cara_da_floresta", pos_sprite_floresta[CARA_FLORESTA_ID][0], pos_sprite_floresta[CARA_FLORESTA_ID][1], hero);
}

void carregaSpriteCidade (Heroi *hero){
	//carregaSprite(u8 tela, char *nomeArquivo, s16 posicaoX, s16 posicaoY, u16 frame, u8 tamanhoX, u8 tamanhoY, s16 iniAnim, s16 fimAnim, s16 velAnim);

	iniciaSpriteCidade();
	
	
	carregaSprite(0, "gokussj2", pos_sprite_cidade[GOKU_ID][0], pos_sprite_cidade[GOKU_ID][1], 5, 32, 32, 4, 7, 4);
	carregaSprite(0, "boy",  pos_sprite_cidade[BOY_ID][0],  pos_sprite_cidade[BOY_ID][1], 5, 32, 32, 4, 7, 2);
	carregaSprite(0, "irma",  pos_sprite_cidade[IRMA_ID][0],  pos_sprite_cidade[IRMA_ID][1], 5, 32, 32, 4, 7, 2);
	carregaSprite(0, "fazendeiroMoreno",  pos_sprite_cidade[FAZENDEIRO_MORENO_ID][0],  pos_sprite_cidade[FAZENDEIRO_MORENO_ID][1], 5, 32, 32, 0, 1, 1);
	carregaSprite(0, "fazendeiroLoiro",  pos_sprite_cidade[FAZENDEIRO_LOIRO_ID][0],  pos_sprite_cidade[FAZENDEIRO_LOIRO_ID][1], 5, 32, 32, 0, 1, 1);
	
	carregaSprite(0, "senhoraBranco",  pos_sprite_cidade[SENHORA_BRANCO_ID][0],  pos_sprite_cidade[SENHORA_BRANCO_ID][1], 5, 32, 32, 8, 11, 2);
	PA_SetSpriteHflip(0, NF_EasyGetSpriteId(0, "senhoraBranco"), 1);
	
	carregaSprite(0, "galinha",  pos_sprite_cidade[GALINHA_ID][0],  pos_sprite_cidade[GALINHA_ID][1], 5, 16, 16, 0, 1, 2);
	PA_SetSpriteHflip(0, NF_EasyGetSpriteId(0, "galinha"), 1);

	carregaSprite(0, "girl",  pos_sprite_cidade[GIRL_ID][0],  pos_sprite_cidade[GIRL_ID][1], 5, 32, 32, 8, 11, 2);
	PA_SetSpriteHflip(0, NF_EasyGetSpriteId(0, "girl"), 1);

	carregaSprite(0, "senhoraAzul",  pos_sprite_cidade[SENHORA_AZUL_ID][0],  pos_sprite_cidade[SENHORA_AZUL_ID][1], 5, 32, 32, 8, 11, 2);

	carregaSprite(0, "senhor", pos_sprite_cidade[SENHOR_ID][0], pos_sprite_cidade[SENHOR_ID][1], 5, 32, 32, 4, 7, 4);

	PA_SetSpriteHflip(0, NF_EasyGetSpriteId(0, "senhoraAzul"), 1);
}

void descarregaSpriteCidade()
{
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "senhoraAzul"));
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "girl"));
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "galinha"));
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "senhoraBranco"));
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "fazendeiroLoiro"));
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "fazendeiroMoreno"));
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "irma"));
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "boy"));
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "gokussj2"));
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "senhor"));

	
	descarregaSprite("senhoraAzul", 0);
	descarregaSprite("girl", 0);
	descarregaSprite("galinha", 0);
	descarregaSprite("senhoraBranco", 0);
	descarregaSprite("fazendeiroLoiro", 0);
	descarregaSprite("fazendeiroMoreno", 0);
	descarregaSprite("irma", 0);
	descarregaSprite("boy", 0);
	descarregaSprite("gokussj2", 0);
	descarregaSprite("senhor", 0);
}

void descarregaSpriteFloresta(){
	PA_StopSpriteAnim (0, NF_EasyGetSpriteId(0, "cara_da_floresta"));
	descarregaSprite ("cara_da_floresta", 0);
}

void iniciaSpriteCaverna(){
	pos_sprite_caverna[CARA_DA_CAVERNA_ID][0] = CARA_DA_CAVERNA_X;
	pos_sprite_caverna[CARA_DA_CAVERNA_ID][1] = CARA_DA_CAVERNA_Y;
}

void carregaSpriteCaverna(u8 frameBau){
	iniciaSpriteCaverna();
	carregaSprite (0, "cara_da_caverna", pos_sprite_caverna[CARA_DA_CAVERNA_ID][0], pos_sprite_caverna[CARA_DA_CAVERNA_ID][1], 0, 32, 32, 0, 3, 4);
	PA_SetSpriteHflip(0, NF_EasyGetSpriteId(0, "cara_da_caverna"), 1);

	carregaSpriteBau(frameBau);
}

void descarregaSpriteCaverna(){
	PA_StopSpriteAnim (0, NF_EasyGetSpriteId(0, "cara_da_caverna"));
	descarregaSprite ("cara_da_caverna", 0);

	descarregaSpriteBau();
}

void scrollSpriteCaverna(Heroi *heroi, u8 tipo){
	scrollSprite (0, "cara_da_caverna", pos_sprite_caverna[CARA_DA_CAVERNA_ID][0]-16, pos_sprite_caverna[CARA_DA_CAVERNA_ID][1]-16, heroi);
}

void moveNPC(char *NPC, int NPC_ID, int direcao, s16 pos_original){
	if (direcao == 0) andaNPCHorizontal(NPC, NPC_ID, direcao, pos_original);
	else andaNPCVertical(NPC, NPC_ID, direcao, pos_original);
}

void andaNPCHorizontal(char *NPC, int NPC_ID, int direcao, s16 pos_original){
	if (inverte[NPC_ID] == false){
		/*se ainda nao andou o q deveria andar, anda*/
		if (atualiza[NPC_ID] && pos_sprite_cidade[NPC_ID][direcao] <= pos_sprite_cidade[NPC_ID][2] + pos_original){
			pos_sprite_cidade[NPC_ID][direcao]++;
			atualiza[NPC_ID] = false;//delay pra atualizacao da posicao
			PA_SetSpriteHflip(0, NF_EasyGetSpriteId(0, NPC), 1);
		}
		else{
			/*se ja andou ate onde deveria andar, troca de direcao e espera um tempo ate atualizar a posicao do npc de novo*/
			if (pos_sprite_cidade[NPC_ID][direcao] >= pos_sprite_cidade[NPC_ID][2] + pos_original){
				/*espera um tempo pra ele andar de novo*/
				if (tempo % tempo_espera[NPC_ID] == 0){
					inverte[NPC_ID] = true;
					pos_sprite_cidade[NPC_ID][2] = -pos_sprite_cidade[NPC_ID][2];
				}
			}
			else
				atualiza[NPC_ID] = true;
		}
	}
	else{
		if (atualiza[NPC_ID] && pos_sprite_cidade[NPC_ID][1] > pos_sprite_cidade[NPC_ID][2] + pos_original){
			pos_sprite_cidade[NPC_ID][direcao]--;
			atualiza[NPC_ID]= false;
			PA_SetSpriteHflip(0, NF_EasyGetSpriteId(0, NPC), 0);
		}
		else{
			/*se ja andou ate onde deveria andar, troca de direcao*/
			if (pos_sprite_cidade[NPC_ID][direcao] <= pos_original){
				/*espera um tempo para ele andar de novo*/
				if(tempo % tempo_espera[NPC_ID] == 0){
					inverte[NPC_ID] = false;
					pos_sprite_cidade[NPC_ID][2] = -pos_sprite_cidade[NPC_ID][2];
				}
			}
			else
				atualiza[NPC_ID] = true;
		}
	}
}

void andaNPCVertical (char *NPC, int NPC_ID, int direcao, s16 pos_original){
	if (inverte[NPC_ID] == false){
		/*se ainda nao andou o q deveria andar, anda*/
		if (atualiza[NPC_ID] && pos_sprite_cidade[NPC_ID][direcao] <= pos_sprite_cidade[NPC_ID][2] + pos_original){
			pos_sprite_cidade[NPC_ID][direcao]++;
			atualiza[NPC_ID] = false;//delay pra atualizacao da posicao
		}
		else{
			/*se ja andou ate onde deveria andar, troca de direcao e espera um tempo ate atualizar a posicao do npc de novo*/
			if (pos_sprite_cidade[NPC_ID][direcao] >= pos_sprite_cidade[NPC_ID][2] + pos_original){
				/*espera um tempo pra ele andar de novo*/
				if (tempo % tempo_espera[NPC_ID] == 0){
					inverte[NPC_ID] = true;
					pos_sprite_cidade[NPC_ID][2] = -pos_sprite_cidade[NPC_ID][2];
					PA_StartSpriteAnim(0, NF_EasyGetSpriteId(0, NPC), 0, 3, 4);
				}
			}
			else
				atualiza[NPC_ID] = true;
		}
	}
	else{
		if (atualiza[NPC_ID] && pos_sprite_cidade[NPC_ID][1] > pos_sprite_cidade[NPC_ID][2] + pos_original){
			pos_sprite_cidade[NPC_ID][direcao]--;
			atualiza[NPC_ID]= false;
		}
		else{
			/*se ja andou ate onde deveria andar, troca de direcao*/
			if (pos_sprite_cidade[NPC_ID][direcao] <= pos_original){
				/*espera um tempo para ele andar de novo*/
				if(tempo % tempo_espera[NPC_ID] == 0){
					inverte[NPC_ID] = false;
					pos_sprite_cidade[NPC_ID][2] = -pos_sprite_cidade[NPC_ID][2];
					PA_StartSpriteAnim(0, NF_EasyGetSpriteId(0, NPC), 4, 7, 4);
				}
			}
			else
				atualiza[NPC_ID] = true;
		}
	}
}

u8 distanciaFalaHeroiNPC(s32 heroiX, s32 heroiY, char *npcNome)
{	
	s32 npcX, npcY;

	npcX = npcY = 100;
	if(strcmp(npcNome, "goku") == 0)
	{
		npcX = pos_sprite_cidade[GOKU_ID][0] + 16;
		npcY = pos_sprite_cidade[GOKU_ID][1] + 16;
	}
	else if(strcmp(npcNome, "boy") == 0)
	{
		npcX = pos_sprite_cidade[BOY_ID][0] + 16;
		npcY = pos_sprite_cidade[BOY_ID][1] + 16;
	}
	else if(strcmp(npcNome, "irma") == 0)
	{
		npcX = pos_sprite_cidade[IRMA_ID][0] + 16;
		npcY = pos_sprite_cidade[IRMA_ID][1] + 16;
	}
	else if(strcmp(npcNome, "fMoreno") == 0)
	{
		npcX = pos_sprite_cidade[FAZENDEIRO_MORENO_ID][0] + 16;
		npcY = pos_sprite_cidade[FAZENDEIRO_MORENO_ID][1] + 16;
	}
	else if(strcmp(npcNome, "fLoiro") == 0)
	{
		npcX = pos_sprite_cidade[FAZENDEIRO_LOIRO_ID][0] + 16;
		npcY = pos_sprite_cidade[FAZENDEIRO_LOIRO_ID][1] + 16;
	}
	else if(strcmp(npcNome, "sBranco") == 0)
	{
		npcX = pos_sprite_cidade[SENHORA_BRANCO_ID][0] + 16;
		npcY = pos_sprite_cidade[SENHORA_BRANCO_ID][1] + 16;
	}
	else if(strcmp(npcNome, "galinha") == 0)
	{
		npcX = pos_sprite_cidade[GALINHA_ID][0] + 16;
		npcY = pos_sprite_cidade[GALINHA_ID][1] + 16;
	}
	else if(strcmp(npcNome, "girl") == 0)
	{
		npcX = pos_sprite_cidade[GIRL_ID][0] + 16;
		npcY = pos_sprite_cidade[GIRL_ID][1] + 16;
	}
	else if(strcmp(npcNome, "sAzul") == 0)
	{
		npcX = pos_sprite_cidade[SENHORA_AZUL_ID][0] + 16;
		npcY = pos_sprite_cidade[SENHORA_AZUL_ID][1] + 16;
	}
	else if(strcmp(npcNome, "senhor") == 0)
	{
		npcX = pos_sprite_cidade[SENHOR_ID][0] + 16;
		npcY = pos_sprite_cidade[SENHOR_ID][1] + 16;
	}
	else if(strcmp(npcNome, "rainha") == 0)
	{
		npcX = pos_sprite_castelo[RAINHA_ID][0] + 16;
		npcY = pos_sprite_castelo[RAINHA_ID][1] + 16;
	}
	else if(strcmp(npcNome, "rei") == 0)
	{
		npcX = pos_sprite_castelo[REI_ID][0] + 16;
		npcY = pos_sprite_castelo[REI_ID][1] + 16;
	}
	else if(strcmp(npcNome, "magoVelho") == 0)
	{
		npcX = pos_sprite_castelo[MAGO_ID][0] + 16;
		npcY = pos_sprite_castelo[MAGO_ID][1] + 16;
	}
	else if(strcmp(npcNome, "cara_do_deserto") == 0)
	{
		npcX = pos_sprite_deserto[CARA_DO_DESERTO_ID][0] + 16;
		npcY = pos_sprite_deserto[CARA_DO_DESERTO_ID][1] + 16;
	}
	else if(strcmp(npcNome, "cara_da_floresta") == 0)
	{
		npcX = pos_sprite_floresta[CARA_FLORESTA_ID][0] + 16;
		npcY = pos_sprite_floresta[CARA_FLORESTA_ID][1] + 16;
	}
	else if(strcmp(npcNome, "cara_da_caverna") == 0)
	{
		npcX = pos_sprite_caverna[CARA_DA_CAVERNA_ID][0];
		npcY = pos_sprite_caverna[CARA_DA_CAVERNA_ID][1];
	}
	else if(strcmp(npcNome, "itemBau") == 0)
	{
		npcX = pos_sprite_caverna[1][0] + 8;
		npcY = pos_sprite_caverna[1][1] + 8;
	}
	
	if(PA_Distance(fix_norm(heroiX), fix_norm(heroiY), npcX, npcY) <= 30*30)
	{
		return 1;
	}

	return 0;
}

u8 distanciaHeroiNPC(s32 heroiX, s32 heroiY, s16 npcX, s16 npcY, s8 raioHeroi, s8 raioNPC)
{
	if(PA_Distance(heroiX, heroiY, npcX, npcY) <= ((raioHeroi + raioNPC)*(raioHeroi + raioNPC)))
	{
		return 1;
	}

	return 0;
}

u8 colisaoHeroiNPC(Heroi *heroi, u8 tipo, u8 tamanho)
{
	s32 heroiX, heroiY, npcX, npcY;
	u8 i;

	heroiX = fix_norm(heroi->getPosicaoCenarioX());
	heroiY = fix_norm(heroi->getPosicaoCenarioY());

	for(i = 0; i < tamanho; i++)
	{
		if(tipo == CIDADE)
		{
			npcX = pos_sprite_cidade[i][0] + 16;
			npcY = pos_sprite_cidade[i][1] + 16;
		}
		else if(tipo == FLORESTA1 || tipo == FLORESTA2)
		{
			npcX = pos_sprite_floresta[i][0] + 16;
			npcY = pos_sprite_floresta[i][1] + 16;
		}
		else if(tipo == CASTELO)
		{
			npcX = pos_sprite_castelo[i][0] + 16;
			npcY = pos_sprite_castelo[i][1] + 16;
		}
		else if(tipo == CAVERNA1 || tipo == CAVERNA2 || tipo == CAVERNA3)
		{
			npcX = pos_sprite_caverna[i][0];
			npcY = pos_sprite_caverna[i][1];
		}
		else if(tipo == DESERTO1 || tipo == DESERTO2)
		{
			npcX = pos_sprite_deserto[i][0] + 16;
			npcY = pos_sprite_deserto[i][1] + 16;
		}

		if(distanciaHeroiNPC(heroiX, heroiY, npcX, npcY, 10, 10))
		{
			return i + 1;
		}
	}

	return 0;
}


u8 scrollNPCCidade (Heroi *hero, u8 tipo){

	if(tipo != 1)
	{
		scrollSprite(0, "gokussj2", pos_sprite_cidade[GOKU_ID][0], pos_sprite_cidade[GOKU_ID][1], hero);
		moveNPC("gokussj2", GOKU_ID, 1, GOKU_Y);
	}
	if(tipo != 2)
	{
		scrollSprite(0, "senhoraAzul",  pos_sprite_cidade[SENHORA_AZUL_ID][0],  pos_sprite_cidade[SENHORA_AZUL_ID][1], hero);
		moveNPC("senhoraAzul", SENHORA_AZUL_ID, 0, SENHORA_AZUL_X);
	}
	if(tipo != 3)
		scrollSprite(0, "irma",  pos_sprite_cidade[IRMA_ID][0],  pos_sprite_cidade[IRMA_ID][1], hero);
	if(tipo != 4)
		scrollSprite(0, "girl",  pos_sprite_cidade[GIRL_ID][0],  pos_sprite_cidade[GIRL_ID][1], hero);
	if(tipo != 5)
		scrollSprite(0, "fazendeiroMoreno",  pos_sprite_cidade[FAZENDEIRO_MORENO_ID][0],  pos_sprite_cidade[FAZENDEIRO_MORENO_ID][1], hero);
	if(tipo != 6)
		scrollSprite(0, "boy",  pos_sprite_cidade[BOY_ID][0],  pos_sprite_cidade[BOY_ID][1], hero);
	if(tipo != 7)
	{
		scrollSprite(0, "senhoraBranco",  pos_sprite_cidade[SENHORA_BRANCO_ID][0],  pos_sprite_cidade[SENHORA_BRANCO_ID][1], hero);
		moveNPC("senhoraBranco", SENHORA_BRANCO_ID, 0, SENHORA_BRANCO_X);
	}
	if(tipo != 8)
		scrollSprite(0, "fazendeiroLoiro",  pos_sprite_cidade[FAZENDEIRO_LOIRO_ID][0],  pos_sprite_cidade[FAZENDEIRO_LOIRO_ID][1], hero);
	if(tipo != 9)
	{
		scrollSprite(0, "galinha",  pos_sprite_cidade[GALINHA_ID][0],  pos_sprite_cidade[GALINHA_ID][1], hero);
		moveNPC("galinha", GALINHA_ID, 0, GALINHA_X);
	}

	if(tipo != 10)
		scrollSprite(0, "senhor", pos_sprite_cidade[SENHOR_ID][0], pos_sprite_cidade[SENHOR_ID][1], hero);

	tempo++;
	if (tempo == 5000) tempo = 0;

	return tipo;
}
