/*=========================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	Broken Soul is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
============================================================================*/
#include <stdlib.h>
#include "include/Numero.hpp"


void Numero::setY (s32 x){
	_x = x;
}

void Numero::setX (s32 y){
	_y = y;
}

void Numero::setDano (int dano){
	_dano = dano;
}

void Numero::setContSubiu (int cont){
	_cont_subiu = cont;
}

void Numero::setAtivo(bool ativo){
	_ativo = ativo;
}

int Numero::getDano(){
	return _dano;
}

int Numero::getContSubiu (){
	return _cont_subiu;
}

s32 Numero::getX (){
	return _x;
}

s32 Numero::getY (){
	return _y;
}

bool Numero::getAtivo (){
	return _ativo;
}

char *Numero::getNomeArquivo(){
	return _nomeArquivo;
}

void Numero::setNomeArquivo(char nomeArquivo[]){
	strcpy(_nomeArquivo, nomeArquivo);
}

void Numero::setId (int id){
	_id = id;
}

int Numero::getId (){
	return _id;
}

//X e Y sao as coordenadas do inimigo
//carrega a imagem relacionada ao dano
//transforma um int em string
void Numero::carregaNum (){
	char numero[4];
	char nomeArquivo[20];
	int buf = 1;
	int valor = getDano();
	int aux = valor;
	int len = 0, n_algarismos;

	setContSubiu(0);

	setX (900);
	setY (900);

	//calcula o numero de algarismos no numero
	while (len < 3){
		aux = aux / 10;
		len++;
		if (aux == 0)
			break;
	}

	n_algarismos = len;
	len++;
	numero[3] = '\0';
	
	//transforma int em str
	while (len > 0){
		buf = valor % 10;
		len--;
		numero[len-1] = '0' + buf;
		if (valor > 10)
			valor = valor / 10;
	}

	switch(n_algarismos){
		case 1:
			if (getId() == INIMIGO1)
				strcpy (nomeArquivo,"numIni1000");
			else if (getId() == INIMIGO2)
				strcpy (nomeArquivo,"numIni2000");	
			else if (getId() == INIMIGO3)
				strcpy (nomeArquivo,"numIni3000");
			else if (getId() == HEROI)
				strcpy (nomeArquivo,"numHeroi000");
			else if (getId() == NUM_VERDE)
				strcpy (nomeArquivo,"numVerde000");
			break;

		case 2:
			if (getId() == INIMIGO1)
				strcpy (nomeArquivo,"numIni100");
			else if (getId() == INIMIGO2)
				strcpy (nomeArquivo,"numIni200");
			else if (getId() == INIMIGO3)
				strcpy (nomeArquivo,"numIni300");
			else if (getId() == HEROI)
				strcpy (nomeArquivo,"numHeroi00");
			else if (getId() == NUM_VERDE)
				strcpy (nomeArquivo,"numVerde00");
			break;

		case 3:
			if (getId() == INIMIGO1)
				strcpy (nomeArquivo,"numIni10");
			else if (getId() == INIMIGO2)
				strcpy (nomeArquivo,"numIni20");
			else if (getId() == INIMIGO3)
				strcpy (nomeArquivo,"numIni30");
			else if (getId() == HEROI)
				strcpy (nomeArquivo,"numHeroi0");
			else if (getId() == NUM_VERDE)
				strcpy (nomeArquivo,"numVerde0");
			break;

		default:
			break;
	}

	strcat(nomeArquivo, numero);
	setNomeArquivo(nomeArquivo);
	
	if (n_algarismos == 1)
		carregaSpriteNaoAnimado(0, nomeArquivo, getX(), getY(), 8, 8);
	if (n_algarismos == 2)
		carregaSpriteNaoAnimado(0, nomeArquivo, getX(), getY(), 16, 8);
	else
		carregaSpriteNaoAnimado(0, nomeArquivo, getX(), getY(), 32, 8);
}

//X, Y coordenadas do inimigo
void Numero::posiciona (int i, s32 X, s32 Y){
	X = fix_norm (X) - 16 - (i * 8);
	setX (X);
	setY (fix_norm(Y) - 16);
}

void Numero::atualizaPosicao (){
	setY(getY() - 1);
	setContSubiu(getContSubiu() + 1);

	if (getContSubiu() >= 50)
		setX(900);
}




































