/*============================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        Broken Soul is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
============================================================================*/

#include "include/Status.hpp"

u8 posicaoSeta;

void Status::set_x_seta (u8 x)
{
	_x_seta = x;
}

void Status::set_y_seta (u8 y)
{
	_y_seta = y;
}

void Status::set_x_seta_item (u8 x)
{
	_x_seta_item = x;
}

void Status::set_y_seta_item (u8 y)
{
	_y_seta_item = y;
}

void Status::set_endereco_seta(u16 endereco)
{
	_endereco_seta = endereco;
}

void Status::set_endereco_seta_item(u16 endereco)
{
	_endereco_seta_item = endereco;
}

u16 Status::get_endereco_seta()
{
	return _endereco_seta;
}

u16 Status::get_endereco_seta_item()
{
	return _endereco_seta_item;
}

u8 Status::get_x_seta()
{
	return _x_seta;
}

u8 Status::get_y_seta()
{
	return _y_seta;
}

u8 Status::get_x_seta_item()
{
	return _x_seta_item;
}

u8 Status::get_y_seta_item()
{
	return _y_seta_item;
}

void Status::inicia_status(){
	esta_menu_pai = true;
	
	NF_LoadFatBg("template", "template");
	NF_LoadRamBg(1, 3, "template");

	/*guarda endereco e seta a posicao da seta*/
	set_x_seta (POS_X_SETA);
	set_y_seta (POS_Y_SETA_1);
	carregaSpriteNaoAnimado (1, "seta",  get_x_seta(), get_y_seta(), 16, 16);
	NF_EasySetSpriteLayer (1, "seta", 1);
	
	/*guarda endereco e seta a posicao da seta do menu de itens*/
	set_x_seta_item (POS_X_SETA_ITEM);
	set_y_seta_item (POS_Y_SETA_ITEM_1);
	carregaEfeito("efeitoSetaMenu", "confirma_menu");
	posicaoSeta = 0;
}

void Status::mostra_status (Heroi *heroi){
	PA_ClearTextBg(1);
	//HP
	PA_OutputText (1, 18, 2, "%c3%d/%d", heroi->getHp(), heroi->getHpMax());
	//Pts de ataque
	PA_OutputText (1, 20, 4, "%c3%d", heroi->getPtsAtaque());
	//Pts de Evasao
	PA_OutputText (1, 28, 4, "%c3%d", heroi->getPtsEvasao());
	//Pts de Evasao
	PA_OutputText (1, 28, 6, "%c3%d", heroi->getPtsMagia());
	//Pts de defesa
	PA_OutputText (1, 20, 6, "%c3%d", heroi->getPtsDefesa());
	//nivel do heroi
	PA_OutputText (1, 19, 10, "%c3%d", heroi->getNivel());
	//MP
	PA_OutputText (1, 18, 17, "%c3%d/%d", heroi->getMp(), heroi->getMpMax());
	//nivel da magia
	PA_OutputText (1, 19, 20, "%c3%d", heroi->getNivelMagia());
	//experiencia normal
	PA_OutputText (1, 25, 10, "%c3%d/%d", heroi->getExperiencia(), heroi->getExperienciaMax());
	//experiencia magia
	PA_OutputText (1, 25, 20, "%c3%d/%d", heroi->getXPMagia(), heroi->getXPMagiaMax());
}

void Status::posiciona_seta(){
	u8 x, y;

	x = get_x_seta();
	y = get_y_seta();

	if (Pad.Newpress.Up){
		playEfeito("efeitoSetaMenu");
		PA_WaitForVBL();
		PA_WaitForVBL();
		if (y == POS_Y_SETA_1) return;
		else
		{
			switch (y){
				case POS_Y_SETA_2: set_y_seta(POS_Y_SETA_1); break;
				case POS_Y_SETA_3: set_y_seta(POS_Y_SETA_2); break;
				case POS_Y_SETA_4: set_y_seta(POS_Y_SETA_3); break;
				default: break;
			}
			
			PA_WaitForVBL();	
			NF_EasyMoveSprite (1, "seta", get_x_seta(), get_y_seta());
		}
	}
	if (Pad.Newpress.Down){
		playEfeito("efeitoSetaMenu");
		PA_WaitForVBL();
		PA_WaitForVBL();
		if (y == POS_Y_SETA_4)
		{ 
			return;
		}
		else
		{
			switch (y){
				case POS_Y_SETA_3: 
					set_y_seta(POS_Y_SETA_4); 
					break;
				case POS_Y_SETA_2: set_y_seta(POS_Y_SETA_3); break;
				case POS_Y_SETA_1: set_y_seta(POS_Y_SETA_2); break;
				default: break;
			}
			
			PA_WaitForVBL();
			NF_EasyMoveSprite (1, "seta", get_x_seta(), get_y_seta());
		}
	}
}

//TODO Defiinir os itens
void Status::usar_item_selecionado(Heroi *heroi, Item *item)
{
	switch(item->getTipoItem())
	{
		case ITEM_HP:
			heroi->aumentaHp(item->getAdicionaHp());
			break;
		case ITEM_MP:
			break;
		case ITEM_DEF:
			break;
		default: break;
	}

	mostra_status(heroi);
}

u8 Status::posiciona_seta_item (Heroi *heroi, u8 tipoMenu){
        u8 x, y;
		Item *itemSelecionado;
			
        x = get_x_seta_item();
        y = get_y_seta_item();

		if (Pad.Newpress.Up){
			playEfeito("efeitoSetaMenu");
			PA_WaitForVBL();
			PA_WaitForVBL();

			switch (y){
				case POS_Y_SETA_ITEM_1:
					//posicaoSeta = 0;
					break;
				case POS_Y_SETA_ITEM_2: 
					set_y_seta_item(POS_Y_SETA_ITEM_1); 
					posicaoSeta = 0;
					break;
				case POS_Y_SETA_ITEM_3: 
					set_y_seta_item(POS_Y_SETA_ITEM_2); 
					posicaoSeta = 1;
					break;
				case POS_Y_SETA_ITEM_4: 
					set_y_seta_item(POS_Y_SETA_ITEM_3); 
					posicaoSeta = 2;
					break;
				case POS_Y_SETA_ITEM_5: 
					set_y_seta_item(POS_Y_SETA_ITEM_4); 
					posicaoSeta = 3;
					break;
				case POS_Y_SETA_ITEM_6: 
					set_y_seta_item(POS_Y_SETA_ITEM_5); 
					posicaoSeta = 4;
					break;
				case POS_Y_SETA_ITEM_7: 
					set_y_seta_item(POS_Y_SETA_ITEM_6); 
					posicaoSeta = 5;
					break;
				case POS_Y_SETA_ITEM_8: 
					set_y_seta_item(POS_Y_SETA_ITEM_7); 
					posicaoSeta = 6;
					break;
				case POS_Y_SETA_ITEM_9: 
					set_y_seta_item(POS_Y_SETA_ITEM_8); 
					posicaoSeta = 7;
					break;
				case POS_Y_SETA_ITEM_10: 
					set_y_seta_item(POS_Y_SETA_ITEM_9); 
					posicaoSeta = 8;
					break;
				default: break;
			}

			PA_WaitForVBL();
			NF_EasyMoveSprite (1, "seta_item", get_x_seta_item(), get_y_seta_item());
		}
        else if (Pad.Newpress.Down){
				playEfeito("efeitoSetaMenu");
				PA_WaitForVBL();
				PA_WaitForVBL();

				switch (y){
					case POS_Y_SETA_ITEM_1: 
						set_y_seta_item(POS_Y_SETA_ITEM_2); 
						posicaoSeta = 1;
						break;
					case POS_Y_SETA_ITEM_2: 
						set_y_seta_item(POS_Y_SETA_ITEM_3); 
						posicaoSeta = 2;
						break;
					case POS_Y_SETA_ITEM_3: 
						set_y_seta_item(POS_Y_SETA_ITEM_4); 
						posicaoSeta = 3;
						break;
					case POS_Y_SETA_ITEM_4: 
						set_y_seta_item(POS_Y_SETA_ITEM_5);
						posicaoSeta = 4;
						break;
					case POS_Y_SETA_ITEM_5: 
						set_y_seta_item(POS_Y_SETA_ITEM_6); 
						posicaoSeta = 5;
						break;
					case POS_Y_SETA_ITEM_6: 
						set_y_seta_item(POS_Y_SETA_ITEM_7); 
						posicaoSeta = 6;
						break;
					case POS_Y_SETA_ITEM_7: 
						set_y_seta_item(POS_Y_SETA_ITEM_8);
						posicaoSeta = 7;
						break;
					case POS_Y_SETA_ITEM_8: 
						set_y_seta_item(POS_Y_SETA_ITEM_9); 
						posicaoSeta = 8;
						break;
					case POS_Y_SETA_ITEM_9: 
						set_y_seta_item(POS_Y_SETA_ITEM_10);
						posicaoSeta = 9;
						break;
					case POS_Y_SETA_ITEM_10:
						//posicaoSeta = 9;
						break;
					default: break;

				}
                        
				PA_WaitForVBL();
				NF_EasyMoveSprite (1, "seta_item", get_x_seta_item(), get_y_seta_item());
        }

		if(tipoMenu == 0)
		{
			if(Pad.Newpress.A)
			{
				/*PA_OutputText (0, 0, 20, "                                                           ");
				PA_OutputText (0, 0, 20, "Item Sele: %d %s",  posicaoSeta, heroi->getMochila()->pegaItem(posicaoSeta)->getNome());*/
				if(heroi->getMochila()->pegaItem(posicaoSeta)->getQtde() == 1)
				{
					
					// TODO remover
					//itemSelecionado = heroi->getMochila()->remove(posicaoSeta);
					//TODO usar o item
					itemSelecionado = heroi->getMochila()->pegaItem(posicaoSeta);
					usar_item_selecionado(heroi, itemSelecionado);
					heroi->getMochila()->remove(posicaoSeta);
					//free(itemSelecionado);
				}
				else
				{
					// TODO usar
					//itemSelecionado = heroi->getMochila()->pegaItem(posicaoSeta);
					// Atribuir para os stats
				}

				esta_menu_pai = true;

				PA_ClearTextBg(1);
		
				PA_DeleteBg (1, 1);
				NF_UnloadBg("itens_menu");

				/*apaga o sprite e tira da RAM*/
				NF_EasyDeleteSprite (1, "seta_item");
				NF_EasyDeleteGfx("seta_item_sprite");
				NF_EasyDeletePal("seta_item_paleta");

				set_y_seta_item (POS_Y_SETA_ITEM_1);
				mostra_status(heroi);
				return 1;
			}
		}
		return 0;
}

void apaga_para_mostrar_menu (){
	//Pts de defesa
	PA_OutputText (1, 18, 6, "        ");
	//nivel do heroi
	PA_OutputText (1, 19, 10, "       ");
	//MP
	PA_OutputText (1, 18, 17, "       ");
}

/*esta funcao direciona para a funcao certa do menu que se quer*/
int Status::abrir_menu(Item *item, int menu, Heroi *heroi, u8 *botaoStart, u8 *carregaPaused)
{
	if (get_y_seta() == POS_Y_SETA_1) 
		return abrir_menu_item(item, menu, heroi);
	else if(get_y_seta() == POS_Y_SETA_4) 
		return menu_sair(menu, botaoStart, carregaPaused);
	return menu;
}

int Status::menu_sair(int menu, u8 *botaoStart, u8 *carregaPaused)
{
	if(Pad.Newpress.A)
	{
		*botaoStart = 0;
		*carregaPaused = 0;
		PA_DeleteBg(0, 1);
		NF_UnloadBg("palavraPaused");
		AS_MP3Unpause();
		return ESTA_MENU_PAI;
	}

	return menu;
}

int Status::abrir_menu_item(Item *item, int menu, Heroi *heroi)
{
	if (Pad.Newpress.A && esta_menu_pai){
		esta_menu_pai = false;
		
		apaga_para_mostrar_menu();

		NF_LoadFatBg("itens_menu", "itens_menu");
		NF_LoadRamBg(1, 1, "itens_menu");

		NF_EasyLoadGfx ("seta_item_sprite", "seta_item", 16, 16);
		NF_EasyLoadPal ("seta_item_paleta", "seta_item");
		NF_EasyCreateSprite (1, "seta_item", "seta_item_sprite", "seta_item_paleta", get_x_seta_item(), get_y_seta_item());

		if (get_y_seta() == POS_Y_SETA_2){
			/*carrega o sprite comos dizeres espirito*/
		}
		//item->listaItem();
		heroi->getMochila()->listaItens();
		posicaoSeta = 0;
		return ESTA_MENU_ITEM;
	}
	if (Pad.Newpress.B && !esta_menu_pai){
		esta_menu_pai = true;

		//item->apagaListagemItem();
		PA_ClearTextBg(1);
		
		PA_DeleteBg (1, 1);
		NF_UnloadBg("itens_menu");

		/*apaga o sprite e tira da RAM*/
		NF_EasyDeleteSprite (1, "seta_item");
		NF_EasyDeleteGfx("seta_item_sprite");
		NF_EasyDeletePal("seta_item_paleta");

		set_y_seta_item (POS_Y_SETA_ITEM_1);
		mostra_status(heroi);

		return ESTA_MENU_PAI;
	}

	return menu;
}

void Status::carrega_template_batalha (){
	
	transicao_fechar();

	PA_DeleteBg (1, 2);
	NF_UnloadBg ("template");
	PA_DeleteBg (1, 3);
	PA_DeleteBg (1, 1);
	PA_DeleteBg (1, 0);
	PA_ClearTextBg (1);
	PA_InitText (1, 0);

	//PA_DeleteSprite (1, NF_EasyGetSpriteId(1, "seta"));
	NF_LoadFatBg("template_batalha", "template_batalha");
	NF_LoadRamBg(1, 2, "template_batalha");

	descarregaSprite("seta", 1);
	transicao_abrir();
}

//carrega as fotos e seta a transparencia pras fotos.
void Status::carregaInimigoStatus(Inimigo **inimigo, u8 n_inimigos){
/*	PA_SetSpriteMode(0, // Screen
					 0, // Sprite
					 1); // Alphablending*/

	if (n_inimigos > 0){
		carregaSpriteNaoAnimado (1, inimigo[0]->getNome(), 126, 42, 32, 32);
//		PA_SetSpriteMode(0,	NF_EasyGetSpriteId(1, inimigo[0]->getNome()), 1);
	}
	if (n_inimigos > 1){
		carregaSpriteNaoAnimado (1, inimigo[1]->getNome(), 126, 90, 32, 32);
//		PA_SetSpriteMode(0,	NF_EasyGetSpriteId(1, inimigo[1]->getNome()), 1);
	}
	if (n_inimigos > 2){
		carregaSpriteNaoAnimado (1, inimigo[2]->getNome(), 126, 140, 32, 32);
//		PA_SetSpriteMode(0,	NF_EasyGetSpriteId(1, inimigo[2]->getNome()), 1);
	}
}

void Status::descarrega_template_batalha(){
	transicao_fechar();
	
	PA_ClearTextBg (1);
	PA_InitText (1, 0);
	
	PA_DeleteBg (1, 2);
	NF_UnloadBg ("template_batalha");
	//PA_ClearBg (1, 2);

	NF_LoadFatBg ("template", "template");
	NF_LoadRamBg (1, 2, "template");

	transicao_abrir();
}
