/*============================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        Broken Soul is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
============================================================================*/

#include "gfx/text_box.c"
#include "gfx/text_box.pal.c"
#include "include/Texto.hpp"
#include "include/efs_lib.h"         // EFS
#include "include/nf_lib.h"              // NightFox's libs
#include "include/nf_easylib.h"

void Texto::carrega_arquivo_texto(char *nomeArquivoTexto)
{
	char *filename;

	filename = (char *)malloc(255 * sizeof(char));
	sprintf(filename, "data/%s.txt", nomeArquivoTexto);
	nomeArquivo = fopen(filename, "r+");
	PA_WaitForVBL();

	fgetpos(nomeArquivo, &posicaoArquivo);
	free(filename);
	PA_WaitForVBL();
	_qdeFala = 0;
}

void Texto::descarrega_arquivo_texto()
{
	fclose(nomeArquivo);
	PA_WaitForVBL();
}

void Texto::pega_texto_arquivo()
{
	int tamanho;

	//fsetpos(nomeArquivo, &posicaoArquivo);
	fscanf(nomeArquivo, "%d", &tamanho);
	PA_WaitForVBL();

	fgets(texto, tamanho, nomeArquivo);
	//fgetpos(nomeArquivo, &posicaoArquivo);
	PA_WaitForVBL();
}

void Texto::inicia_box ()
{
	//int alpha1, alpha2;

	alpha1 = 10;
	alpha2 = 16;

	//habilita o efeito de alpha blending
	PA_EnableSpecialFx(0, SFX_ALPHA, SFX_BG1 | SFX_BD, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
}

void Texto::carrega_texto_box()
{
	PA_EasyBgLoad (0, 1, text_box);
	PA_SetSFXAlpha(0, alpha1, alpha2);

	NF_EasyLoadGfx("seta_conversa_continue", "seta_conversa_continue", 16, 16);
	NF_EasyLoadPal("seta_conversa_continue_paleta", "seta_conversa_continue");
	NF_EasyCreateSprite(0, "seta_conversa_continue", "seta_conversa_continue", "seta_conversa_continue_paleta", 230, 170);
	NF_EasySetSpriteLayer(0, "seta_conversa_continue", 1);

	PA_StartSpriteAnim(0, NF_EasyGetSpriteId(0, "seta_conversa_continue"), 0, 12, 20);
}

void Texto::apaga_text_box()
{
	PA_StopSpriteAnim(0, NF_EasyGetSpriteId(0, "seta_conversa_continue"));

	NF_EasyDeleteSprite(0, "seta_conversa_continue");
	NF_EasyDeleteGfx("seta_conversa_continue");
	NF_EasyDeletePal("seta_conversa_continue_paleta");

	PA_DeleteBg (0, 1);	//apaga a caixa de texto 	
}

void Texto::apaga_texto_text_box()
{
	PA_ClearTextBg(0);
}

/*capacidade de 104 caracteres*/
void Texto::escreve_texto ()
{
	u32 nletras = 0; 	//numero de letras a escrever
	u32 letras = 0;

	char *palavra;
	palavra = (char *)malloc(255 * sizeof(char));
	sprintf(palavra,"%s", "%c1");
	strcat(palavra, texto);

	while (letras == nletras){
		++nletras; //escreve uma letra de cada vez
		letras = PA_BoxText (0, 2, 16, 29, 25, palavra, nletras);
		PA_WaitForVBL(); 	//essa funcao mais vezes escrita diminui a velocidade do texto
		
	}

	while(1){
		if (Pad.Newpress.A || Stylus.Newpress){
			break;
		}
		PA_WaitForVBL();
	}

	free(palavra);
	PA_WaitForVBL();
}

void Texto::pega_qde_fala()
{
	fscanf(nomeArquivo, "%d", &_qdeFala);
	fgetpos(nomeArquivo, &posicaoArquivo);
}

void Texto::fala_personagem()
{
	u8 i;
	fsetpos(nomeArquivo, &posicaoArquivo);
	for(i = 0; i < _qdeFala; i++)
	{
		pega_texto_arquivo();
		escreve_texto();
		PA_ClearTextBg(0);
	}
}

void Texto::pula_proxima_fala()
{
	u8 i;
	fsetpos(nomeArquivo, &posicaoArquivo);
	for(i = 0; i < _qdeFala; i++)
	{
		pega_texto_arquivo();
	}
	pega_qde_fala();
}


















