#include <PA9.h>
#include "include/apresentacao.hpp"
#include "include/transicao.hpp"
#include "include/Texto.hpp"
#include "include/Sound.hpp"

void telaLago(Texto *texto)
{
	//efeitoFadeDualScreen(3, "campo_lagoTop", "campo_lagoBot");
	PA_ResetBgSys();
	PA_InitText(1, 0);
	PA_InitText(0, 0);

	// Tudo preto
	PA_SetBrightness(0, -31);
	PA_SetBrightness(1, -31);
	
	// Load splash from fat
	NF_LoadFatBg("top", "campo_lagoTop");
	NF_LoadRamBg(1, 3, "top");

	NF_LoadFatBg("bot", "campo_lagoBot");
	NF_LoadRamBg(0, 3, "bot");

	// Volta ao brilho normal
	brilhoNormalDualScreen();

	texto->inicia_box();
	texto->carrega_texto_box();
	texto->pega_texto_arquivo();
	texto->escreve_texto();
	texto->apaga_texto_text_box();

	texto->apaga_text_box();

	// Espera 5 segundos = 300 frames
	//busyWait();

	// Escurece a tela
	escureceBrilhoDualScreen();

	NF_UnloadBg("top");
	NF_UnloadBg("bot");
	PA_SetBrightness(0, 0);
	PA_SetBrightness(1, 0);
	PA_ResetBgSys();
}

void telaCidadeFundo(Texto *texto)
{
	//efeitoFadeDualScreen(3, "cidadeFundoTop", "cidadeFundoBot");
	PA_ResetBgSys();
	PA_InitText(1, 0);
	PA_InitText(0, 0);
	// Tudo preto
	PA_SetBrightness(0, -31);
	PA_SetBrightness(1, -31);
	
	// Load splash from fat
	NF_LoadFatBg("top", "cidadeFundoTop");
	NF_LoadRamBg(1, 3, "top");

	NF_LoadFatBg("bot", "cidadeFundoBot");
	NF_LoadRamBg(0, 3, "bot");

	// Volta ao brilho normal
	brilhoNormalDualScreen();

	// Espera 5 segundos = 300 frames
	texto->inicia_box();
	texto->carrega_texto_box();
	texto->pega_texto_arquivo();
	texto->escreve_texto();
	texto->apaga_texto_text_box();

	texto->apaga_text_box();

	// Escurece a tela
	escureceBrilhoDualScreen();

	NF_UnloadBg("top");
	NF_UnloadBg("bot");
	PA_SetBrightness(0, 0);
	PA_SetBrightness(1, 0);
	PA_ResetBgSys();
}


void telaBebe(Texto *texto)
{
	//efeitoFadeDualScreen(3, "bebe", "cidadeDentro");
	PA_ResetBgSys();
	PA_InitText(1, 0);
	PA_InitText(0, 0);

	// Tudo preto
	PA_SetBrightness(0, -31);
	PA_SetBrightness(1, -31);
	
	// Load splash from fat
	NF_LoadFatBg("top", "bebe");
	NF_LoadRamBg(1, 3, "top");

	NF_LoadFatBg("bot", "cidadeDentro");
	NF_LoadRamBg(0, 3, "bot");

	// Volta ao brilho normal
	brilhoNormalDualScreen();

	// Espera 5 segundos = 300 frames
	texto->inicia_box();
	texto->carrega_texto_box();

	for(u8 i = 0; i < 1; i++)
	{
		texto->pega_texto_arquivo();
		texto->escreve_texto();
		texto->apaga_texto_text_box();
	}

	texto->apaga_text_box();

	// Escurece a tela
	escureceBrilhoDualScreen();

	NF_UnloadBg("top");
	NF_UnloadBg("bot");
	PA_SetBrightness(0, 0);
	PA_SetBrightness(1, 0);
	PA_ResetBgSys();
}

void telaHeroi(Texto *texto)
{
	//fadeScrollDualScreen(3, "heroiApTop", "heroiApBot");
	s16 i;
	PA_ResetBgSys();
	PA_InitText(1, 0);
	PA_InitText(0, 0);

	// Tudo preto
	PA_SetBrightness(0, -31);
	PA_SetBrightness(1, -31);
	
	// Load splash from fat
	NF_LoadFatBg("top", "heroiApTop");
	NF_LoadRamBg(1, 3, "top");
	PA_InitParallaxY(1, 0, 256, 128, 128);

	NF_LoadFatBg("bot", "heroiApBot");
	NF_LoadRamBg(0, 3, "bot");
	PA_InitParallaxY(0, 0, 256, 128, 128);
	
	PA_ParallaxScrollY(1, 600);
	PA_ParallaxScrollY(0, 600);

	// Volta ao brilho normal
	brilhoNormalDualScreen();

	// Espera 5 segundos = 300 frames
	s32 scroll = 0;
	for(i = 600; i >= 0; i--)
	{
		if(Pad.Newpress.Anykey || Stylus.Newpress)
			break;
		scroll += 1;

		PA_ParallaxScrollY(1, i);
		PA_ParallaxScrollY(0, i);

		PA_WaitForVBL();
	}
	
	
	texto->inicia_box();
	texto->carrega_texto_box();

	for(i = 0; i < 2; i++)
	{
		texto->pega_texto_arquivo();
		texto->escreve_texto();
		texto->apaga_texto_text_box();
	}

	// Escurece a tela
	escureceBrilhoDualScreen();

	NF_UnloadBg("top");
	NF_UnloadBg("bot");
	PA_SetBrightness(0, 0);
	PA_SetBrightness(1, 0);
	PA_ResetBgSys();
}

void telaHeroiEscolhido(Texto * texto)
{
	s16 i;
	PA_ResetBgSys();
	PA_InitText(1, 0);
	PA_InitText(0, 0);

	// Tudo preto
	PA_SetBrightness(0, -31);
	PA_SetBrightness(1, -31);
	
	// Load splash from fat
	NF_LoadFatBg("top", "heroiEmPeTop");
	NF_LoadRamBg(1, 3, "top");
	PA_InitParallaxY(1, 0, 256, 128, 128);

	NF_LoadFatBg("bot", "heroiEmPeBot");
	NF_LoadRamBg(0, 3, "bot");
	PA_InitParallaxY(0, 0, 256, 128, 128);
	
	//PA_ParallaxScrollY(1, 0);
	//PA_ParallaxScrollY(0, 0);

	// Volta ao brilho normal
	brilhoNormalDualScreen();

	// Espera 5 segundos = 300 frames
	s32 scroll = 0;
	for(i = 0; i < 701; i++)
	{
		if(Pad.Newpress.Anykey || Stylus.Newpress)
			break;
		scroll += 1;

		PA_ParallaxScrollY(1, i);
		PA_ParallaxScrollY(0, i);

		PA_WaitForVBL();
	}
	
	
	texto->inicia_box();
	texto->carrega_texto_box();

	for(i = 0; i < 2; i++)
	{
		texto->pega_texto_arquivo();
		texto->escreve_texto();
		texto->apaga_texto_text_box();
	}

	texto->apaga_text_box();

	// Escurece a tela
	escureceBrilhoDualScreen();

	NF_UnloadBg("top");
	NF_UnloadBg("bot");
	PA_SetBrightness(0, 0);
	PA_SetBrightness(1, 0);
	PA_ResetBgSys();
}

void telaMago(Texto *texto)
{
	//fadeSlideToRightScrollDualScreen(3, "magoApTop", "magoApBot");
	s16 i;
	PA_ResetBgSys();
	PA_InitText(1, 0);
	PA_InitText(0, 0);

	// Tudo preto
	PA_SetBrightness(0, -31);
	PA_SetBrightness(1, -31);
	
	// Load splash from fat
	NF_LoadFatBg("top", "magoApTop");
	NF_LoadRamBg(1, 3, "top");
	PA_InitParallaxX(1, 0, 256, 128, 128);

	NF_LoadFatBg("bot", "magoApBot");
	NF_LoadRamBg(0, 3, "bot");
	PA_InitParallaxX(0, 0, 256, 128, 128);
	
	PA_ParallaxScrollX(1, 500);
	PA_ParallaxScrollX(0, 500);

	// Volta ao brilho normal
	brilhoNormalDualScreen();

	// Espera 5 segundos = 300 frames
	s32 scroll = 0;
	for(i = 500; i >= 0; i--)
	{
		if(Pad.Newpress.Anykey || Stylus.Newpress)
			break;
		scroll += 1;

		PA_ParallaxScrollX(1, i);
		PA_ParallaxScrollX(0, i);

		PA_WaitForVBL();
	}
	
	texto->inicia_box();
	texto->carrega_texto_box();

	for(i = 0; i < 2; i++)
	{
		texto->pega_texto_arquivo();
		texto->escreve_texto();
		texto->apaga_texto_text_box();
	}

	texto->apaga_text_box();

	// Escurece a tela
	escureceBrilhoDualScreen();

	NF_UnloadBg("top");
	NF_UnloadBg("bot");
	PA_SetBrightness(0, 0);
	PA_SetBrightness(1, 0);
	PA_ResetBgSys();
}

void telaVilaNoite(Texto *texto)
{
	//efeitoFadeDualScreen(3, "vilaNoiteTop", "vilaNoiteBot");
	PA_ResetBgSys();
	PA_InitText(1, 0);
	PA_InitText(0, 0);

	// Tudo preto
	PA_SetBrightness(0, -31);
	PA_SetBrightness(1, -31);
	
	// Load splash from fat
	NF_LoadFatBg("top", "vilaNoiteTop");
	NF_LoadRamBg(1, 3, "top");

	NF_LoadFatBg("bot", "vilaNoiteBot");
	NF_LoadRamBg(0, 3, "bot");

	// Volta ao brilho normal
	brilhoNormalDualScreen();

	// Espera 5 segundos = 300 frames
	texto->inicia_box();
	texto->carrega_texto_box();

	for(u8 i = 0; i < 1; i++)
	{
		texto->pega_texto_arquivo();
		texto->escreve_texto();
		texto->apaga_texto_text_box();
	}

	texto->apaga_text_box();

	// Escurece a tela
	escureceBrilhoDualScreen();

	NF_UnloadBg("top");
	NF_UnloadBg("bot");
	PA_SetBrightness(0, 0);
	PA_SetBrightness(1, 0);
	PA_ResetBgSys();
}

void telaMagoMagia(Texto *texto)
{
	PA_ResetBgSys();
	PA_InitText(1, 0);
	PA_InitText(0, 0);

	// Tudo preto
	PA_SetBrightness(0, -31);
	PA_SetBrightness(1, -31);
	
	// Load splash from fat
	NF_LoadFatBg("top", "magoMagiaTop");
	NF_LoadRamBg(1, 3, "top");

	NF_LoadFatBg("bot", "magoMagiaBot");
	NF_LoadRamBg(0, 3, "bot");

	// Volta ao brilho normal
	brilhoNormalDualScreen();

	// Espera 5 segundos = 300 frames
	texto->inicia_box();
	texto->carrega_texto_box();

	for(u8 i = 0; i < 4; i++)
	{
		texto->pega_texto_arquivo();
		texto->escreve_texto();
		texto->apaga_texto_text_box();
	}

	texto->apaga_text_box();

	// Escurece a tela
	escureceBrilhoDualScreen();

	NF_UnloadBg("top");
	NF_UnloadBg("bot");
	PA_SetBrightness(0, 0);
	PA_SetBrightness(1, 0);
	PA_ResetBgSys();
}

void telaVilaNoiteDormindo()
{
	//efeito
	// carrega vilaNoiteDormindo
	//espera
	// efeito
	// descarrega vilaNoiteDomindo
}

void telaLuta(Texto *texto)
{
	PA_ResetBgSys();
	PA_InitText(1, 0);
	PA_InitText(0, 0);

	// Tudo preto
	PA_SetBrightness(0, -31);
	PA_SetBrightness(1, -31);
	
	// Load splash from fat
	NF_LoadFatBg("top", "luta");
	NF_LoadRamBg(1, 3, "top");

	// Volta ao brilho normal
	brilhoNormalDualScreen();

	// Espera 5 segundos = 300 frames
	texto->inicia_box();
	texto->carrega_texto_box();

	for(u8 i = 0; i < 5; i++)
	{
		texto->pega_texto_arquivo();
		texto->escreve_texto();
		texto->apaga_texto_text_box();
	}

	texto->apaga_text_box();

	// Escurece a tela
	escureceBrilhoDualScreen();

	NF_UnloadBg("top");
	PA_SetBrightness(0, 0);
	PA_SetBrightness(1, 0);
	PA_ResetBgSys();
}

void textoApresentacao()
{
	PA_ResetBgSys();

	PA_SetBrightness(0, -31); // all black
	PA_SetBrightness(1, -31); // all black
	
	// Load splash from fat
	NF_LoadFatBg("introTexto", "introTexto");
	NF_LoadRamBg(1, 3, "introTexto");

	brilhoNormalDualScreen();

	// Espera 5 segundos = 300 frames
	busyWait();

	escureceBrilhoDualScreen();

	NF_UnloadBg("introTexto");
	PA_ResetBgSys();
}

void apresentacao()
{
	s16 i;
	Texto *texto = new Texto();
	texto->carrega_arquivo_texto("apresentacao");

	playMP3("apFesta");
	AS_SetMP3Loop(true);

	telaLago(texto);
	telaCidadeFundo(texto);
	telaBebe(texto);
	telaHeroiEscolhido(texto);

	for(i = 126; i >= 0; i--)
	{
		PA_SetSoundVol(i);
		PA_WaitForVBL();
	}
	
	stopMP3();
	for(i = 0; i < 25; i++)
		PA_WaitForVBL();


	playMP3("apLuta");
	AS_SetMP3Loop(true);


	for(i = 0; i < 127; i++)
	{
		PA_SetSoundVol(i);
		PA_WaitForVBL();
	}

	telaVilaNoite(texto);
	telaMago(texto);
	telaMagoMagia(texto);
	telaHeroi(texto);
	telaLuta(texto);
	texto->descarrega_arquivo_texto();
	free(texto);

	for(i = 126; i >= 0; i--)
	{
		PA_SetSoundVol(i);
		PA_WaitForVBL();
	}
	stopMP3();
	for(i = 0; i < 50; i++)
		PA_WaitForVBL();


	PA_SetSoundVol(127);
	NF_EasyClearAll();
	NF_FreeBuffers();
}
