#include "include/comumLib.hpp"

typedef struct _spriteGifAnimado
{
	char *buffer;
}gifAnimado;

gifAnimado SLOT_GIF_ANIMADO[1];

void carregaSpriteNaoAnimado (u8 tela, char *nomeArquivo, s16 posicaoX, s16 posicaoY, u8 tamanhoX, u8 tamanhoY){
	char *nome_paleta;
	nome_paleta = (char *)malloc(256 * sizeof(char));
	sprintf(nome_paleta, "%sPal", nomeArquivo);
	NF_EasyLoadGfx (nomeArquivo, nomeArquivo, tamanhoX, tamanhoY);
	NF_EasyLoadPal (nome_paleta, nomeArquivo);
	NF_EasyCreateSprite(tela, nomeArquivo, nomeArquivo, nome_paleta, posicaoX, posicaoY);
	free(nome_paleta);
}

void carregaSprite(u8 tela, char *nomeArquivo, s16 posicaoX, s16 posicaoY, u16 frame, u8 tamanhoX, u8 tamanhoY, s16 iniAnim, s16 fimAnim, s16 velAnim)
{
	char *nome_paleta;
	nome_paleta = (char *)malloc(256 * sizeof(char));
	sprintf(nome_paleta, "%sPal", nomeArquivo);
	NF_EasyLoadGfx (nomeArquivo, nomeArquivo, tamanhoX, tamanhoY);
	NF_EasyLoadPal (nome_paleta, nomeArquivo);
	NF_EasyCreateSprite(tela, nomeArquivo, nomeArquivo, nome_paleta, posicaoX, posicaoY);
	NF_EasySetSpriteFrame(tela, nomeArquivo, frame);
	NF_EasySetSpriteLayer(tela, nomeArquivo, 3);
	PA_StartSpriteAnim(0, NF_EasyGetSpriteId(tela, nomeArquivo), iniAnim, fimAnim, velAnim);
	free(nome_paleta);
}


void descarregaSprite(const char *nomeArquivo, int tela)
{
	char *nome_paleta;
	nome_paleta = (char *)malloc(256 * sizeof(char));
	sprintf(nome_paleta, "%sPal", nomeArquivo);
	NF_EasyDeleteSprite(tela, nomeArquivo);
	NF_EasyDeleteGfx(nomeArquivo);
	NF_EasyDeletePal(nome_paleta);
	free(nome_paleta);
}

void scrollSprite(u8 tela, char *nomeArquivo, s16 posicaoX, s16 posicaoY, Heroi *heroi)
{
	PA_SetSpriteXY (tela, NF_EasyGetSpriteId(tela, nomeArquivo), posicaoX - (fix_norm(heroi->getScrollX())), posicaoY - fix_norm(heroi->getScrollY()));
	if (posicaoY - fix_norm(heroi->getScrollY()) <= -64 || posicaoY - fix_norm(heroi->getScrollY()) >= 192)
	{
		//NF_EasyDeleteSprite(tela, nomeArquivo);
		PA_SetSpriteXY (tela, NF_EasyGetSpriteId(tela, nomeArquivo), 900, 900);
	}
}

/* Grava a posicao do heroi antes de entrar na tela de batalha */
void salva_posicao_heroi_batalha(Heroi *heroi)
{
	FILE *nomeArquivo;
	nomeArquivo = fopen("data/heroi.txt", "w+");

	fprintf(nomeArquivo, "%d %d\n", fix_norm(heroi->getPosicaoCenarioX()), fix_norm(heroi->getPosicaoCenarioY()));
	fprintf(nomeArquivo, "%d %d\n", fix_norm(heroi->getScrollX()), fix_norm(heroi->getScrollY()));
	fprintf(nomeArquivo, "%d %d\n", fix_norm(heroi->getPosicaoTelaX()), fix_norm(heroi->getPosicaoTelaY()));
	fclose(nomeArquivo);
}

/* Recupera a posicao do heroi no cenario em que ele estava antes da batalha */
void pega_posicao_heroi_batalha(Heroi *heroi)
{
	FILE *nomeArquivo;
	s32 posicaoX, posicaoY;
	nomeArquivo = fopen("data/heroi.txt", "r");

	fscanf(nomeArquivo, "%d %d", &posicaoX, &posicaoY);
	heroi->setPosicaoCenarioX(posicaoX);
	heroi->setPosicaoCenarioY(posicaoY);

	fscanf(nomeArquivo, "%d %d", &posicaoX, &posicaoY);
	heroi->setScrollX(posicaoX);
	heroi->setScrollY(posicaoY);

	fscanf(nomeArquivo, "%d %d", &posicaoX, &posicaoY);
	heroi->setPosicaoTelaX(posicaoX);
	heroi->setPosicaoTelaY(posicaoY);

	fclose(nomeArquivo);
}

void salva_posicao_heroi_cenario(u8 tipoCenario, Heroi *heroi)
{
	FILE *streamArquivo;
	char *nomeArquivo;
	
	nomeArquivo = (char *)malloc(256 * sizeof(char));
	sprintf(nomeArquivo, "data/cenario%d.txt", tipoCenario);

	streamArquivo = fopen(nomeArquivo, "w+");
	fprintf(streamArquivo, "%d %d\n", fix_norm(heroi->getPosicaoCenarioX()), fix_norm(heroi->getPosicaoCenarioY()));
	fprintf(streamArquivo, "%d %d\n", fix_norm(heroi->getScrollX()), fix_norm(heroi->getScrollY()));
	fprintf(streamArquivo, "%d %d\n", fix_norm(heroi->getPosicaoTelaX()), fix_norm(heroi->getPosicaoTelaY()));
	fclose(streamArquivo);
	free(nomeArquivo);
}

void pega_posicao_heroi_cenario(u8 tipoCenario, Heroi *heroi)
{
	FILE *streamArquivo;
	char *nomeArquivo;
	s32 posicaoX, posicaoY;

	nomeArquivo = (char *)malloc(256 * sizeof(char));
	sprintf(nomeArquivo, "data/cenario%d.txt", tipoCenario);
	streamArquivo = fopen(nomeArquivo, "w+");

	fscanf(streamArquivo, "%d %d", &posicaoX, &posicaoY);
	heroi->setPosicaoCenarioX(posicaoX);
	heroi->setPosicaoCenarioY(posicaoY);

	fscanf(streamArquivo, "%d %d", &posicaoX, &posicaoY);
	heroi->setScrollX(posicaoX);
	heroi->setScrollY(posicaoY);

	fscanf(streamArquivo, "%d %d", &posicaoX, &posicaoY);
	heroi->setPosicaoTelaX(posicaoX);
	heroi->setPosicaoTelaY(posicaoY);

	fclose(streamArquivo);
	free(nomeArquivo);
}

void salva_jogo(Heroi *heroi)
{
	//TODO pesquisar o que vamos salvar! ^^
}

void pega_jogo(Heroi *heroi)
{
	//TODO o que pegar
}

void carrega_gif_animado(u8 tela, u8 idGif, char *nomeArquivo)
{
	FILE *streamArquivo;
	u32 tamanhoGif;
	char *caminhoArquivo;

	caminhoArquivo = (char *)malloc(256 * sizeof(char));
	sprintf(caminhoArquivo, "gifAnim/%s.gif", nomeArquivo);

	streamArquivo = fopen(caminhoArquivo, "rb");
	free(caminhoArquivo);

	fseek(streamArquivo, 0, SEEK_END);
	tamanhoGif = ftell(streamArquivo);
	rewind(streamArquivo);

	SLOT_GIF_ANIMADO[idGif].buffer = (char *)malloc(tamanhoGif * sizeof(char));
	fread(SLOT_GIF_ANIMADO[idGif].buffer, 1, tamanhoGif, streamArquivo);
	fclose(streamArquivo);

	PA_LoadGif(tela, (void *)SLOT_GIF_ANIMADO[idGif].buffer);	
}

void mostra_gif_animado()
{
	//TODO fazer a funcao que anima o gif e a VBL
}

void descarrega_gif_animado(u8 idGif)
{
	if(SLOT_GIF_ANIMADO[idGif].buffer != NULL)
	{
		free(SLOT_GIF_ANIMADO[idGif].buffer);
	}
}
