#include <PA9.h>
#include "include/creditos.hpp"
#include "include/transicao.hpp"
#include "include/Sound.hpp"

#include <fat.h>				// Devkit

#include "include/efs_lib.h"			// EFS

#include "include/nf_lib.h"				// NightFox's libs
#include "include/nf_easylib.h"


void creditos_marcotoro()
{
	PA_ResetBgSys();
	PA_InitText(1, 0);
	PA_InitText(0, 0);

	//PA_OutputText (0, 1, 9, "Teste creditos");
	NF_LoadFatBg("top", "marcotoroTop");
	NF_LoadRamBg(1, 3, "top");

	NF_LoadFatBg("bot", "marcotoroBot");
	NF_LoadRamBg(0, 3, "bot");

	NF_LoadFatBg("orientadorFlavio", "orientadorFlavio");
	NF_LoadRamBg(0, 1, "orientadorFlavio");
	

	NF_LoadFatBg("orientador", "orientador");
	NF_LoadRamBg(0, 2, "orientador");

	PA_EasyBgScrollX(0, 2, 256);

	brilhoNormalDualScreen();

	for(s16 i = 0; i < 256; i++)
	{
		PA_EasyBgScrollX(0, 1, i);
		PA_EasyBgScrollX(0, 2, 256 - i);
		PA_WaitForVBL();
	}
	

	while(1)
	{
		if(Pad.Newpress.A || Stylus.Newpress)
			break;

		PA_WaitForVBL();
	}

	escureceBrilhoDualScreen();

	PA_DeleteBg(1, 3);
	NF_UnloadBg("top");

	PA_DeleteBg(0, 3);
	NF_UnloadBg("bot");

	PA_DeleteBg(0, 2);
	NF_UnloadBg("orientadorFlavio");

	PA_DeleteBg(0, 1);
	NF_UnloadBg("orientador");
}

void creditos_gobu()
{
	PA_ResetBgSys();
	PA_InitText(1, 0);
	PA_InitText(0, 0);

	NF_LoadFatBg("top", "charNobuTop");
	NF_LoadRamBg(1, 3, "top");
	PA_InitParallaxX(1, 0, 0, 0, 128);
	
		

	NF_LoadFatBg("bot", "charNobuBot");
	NF_LoadRamBg(0, 3, "bot");
	PA_InitParallaxX(0, 0, 0, 0, 128);

	PA_ParallaxScrollX(1, 350);
	PA_ParallaxScrollX(0, 350);

	s8 alpha1 = 12;
	s8 alpha2 = 12;

	//habilita o efeito de alpha blending
	PA_EnableSpecialFx(0, SFX_ALPHA, SFX_BG2 | SFX_BD, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	PA_EnableSpecialFx(1, SFX_ALPHA, SFX_BG2 | SFX_BD, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	NF_LoadFatBg("backTextoTop", "backTextoTop");
	NF_LoadRamBg(1, 2, "backTextoTop");
	PA_SetSFXAlpha(1, alpha1, alpha2);


	NF_LoadFatBg("gobuTextoTop", "gobuTextoTop");
	NF_LoadRamBg(1, 1, "gobuTextoTop");
	PA_InitParallaxY(1, 0, 128, 128, 0);

	NF_LoadFatBg("backTextoBot", "backTextoBot");
	NF_LoadRamBg(0, 2, "backTextoBot");
	PA_SetSFXAlpha(0, alpha1, alpha2);

	NF_LoadFatBg("gobuTextoBot", "gobuTextoBot");
	NF_LoadRamBg(0, 1, "gobuTextoBot");
	PA_InitParallaxY(0, 0, 128, 128, 0);

	

	brilhoNormalDualScreen();

	for(s16 i = 350; i >= 50; i--)
	{
		PA_ParallaxScrollX(1, i);
		PA_ParallaxScrollX(0, i);

		PA_WaitForVBL();
	}

	for(s16 i = 0; i < 765; i++)
	{
		PA_ParallaxScrollY(1, i);
		PA_ParallaxScrollY(0, i);

		PA_WaitForVBL();
	}

	while(1)
	{
		if(Pad.Newpress.A || Stylus.Newpress)
			break;

		PA_WaitForVBL();
	}

	escureceBrilhoDualScreen();

	PA_DeleteBg(1, 3);
	NF_UnloadBg("top");

	PA_DeleteBg(0, 3);
	NF_UnloadBg("bot");

	PA_DeleteBg(1, 2);
	NF_UnloadBg("backTextoTop");

	PA_DeleteBg(0, 2);
	NF_UnloadBg("backTextoBot");

	PA_DeleteBg(1, 1);
	NF_UnloadBg("gobuTextoTop");

	PA_DeleteBg(0, 1);
	NF_UnloadBg("gobuTextoBot");
}

void creditos_tiemy()
{
	PA_ResetBgSys();
	PA_InitText(1, 0);
	PA_InitText(0, 0);

	NF_LoadFatBg("top", "charTiemyTop");
	NF_LoadRamBg(1, 3, "top");
	PA_InitParallaxX(1, 0, 0, 0, 128);

	NF_LoadFatBg("bot", "charTiemyBot");
	NF_LoadRamBg(0, 3, "bot");
	PA_InitParallaxX(0, 0, 0, 0, 128);

	s8 alpha1 = 12;
	s8 alpha2 = 12;

	//habilita o efeito de alpha blending
	PA_EnableSpecialFx(0, SFX_ALPHA, SFX_BG2 | SFX_BD, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	NF_LoadFatBg("backTexto2Bot", "backTexto2Bot");
	NF_LoadRamBg(0, 2, "backTexto2Bot");
	PA_SetSFXAlpha(0, alpha1, alpha2);

	NF_LoadFatBg("tiemyTexto2Bot", "tiemyTexto2Bot");
	NF_LoadRamBg(0, 1, "tiemyTexto2Bot");
	//PA_InitParallaxY(0, 0, 128, 128, 0);

	brilhoNormalDualScreen();

	for(s16 i = 0; i < 500; i++) 
	{
		PA_ParallaxScrollX(1, i);
		PA_ParallaxScrollX(0, i);
		PA_WaitForVBL();
	}


	while(1)
	{
		if(Pad.Newpress.A || Stylus.Newpress)
			break;

		PA_WaitForVBL();
	}

	escureceBrilhoDualScreen();

	PA_DeleteBg(1, 3);
	NF_UnloadBg("top");

	PA_DeleteBg(0, 3);
	NF_UnloadBg("bot");

	PA_DeleteBg(1, 2);
	NF_UnloadBg("backTexto2Bot");

	PA_DeleteBg(1, 1);
	NF_UnloadBg("tiemyTexto2Bot");
}

void creditos()
{
	PA_WaitForVBL();
	playMP3("creditos");
	AS_SetMP3Loop(true);
	escureceBrilhoDualScreen();

	creditos_gobu();
	creditos_tiemy();
	creditos_marcotoro();

	stopMP3();
	PA_WaitForVBL();

	brilhoNormalDualScreen();

	playMP3("menuFundo");
	AS_SetMP3Loop(true);
	
}
