
#ifndef BATALHA_HPP
#define BATALHA_HPP

#include <PA9.h>
#include <stdlib.h>
#include "Magia.hpp"
#include "Heroi.hpp"
#include "transicao.hpp"
#include "Batalha.hpp"
#include "Status.hpp"
#include "definicoes.hpp"
#include "Inimigo.hpp"
#include "Numero.hpp"
#include "Texto.hpp"

//#include "Sound.hpp"
//#include <maxmod9.h>
class Batalha
{
	public:
		int encontra_batalha();
		
		u8 getNumeroInimigos();

		void setNumeroInimigos(u8 numero_inimigos);
		void tela_transicao(int i, Cenario *cenario);
		void inicia_variaveis_transicao();
		void iniciaImagemDano (Inimigo **inimigo, Heroi *heroi);
		void mostraStatusHeroi (Heroi *heroi);
		void mostraStatusInimigo (Inimigo **inimigo, int n_inimigos);
		void carregaCenarioBatalha (Cenario *cenario);
		void descarregaCenarioBatalha (Cenario *cenario);
		void apagaFotosInimigos(Inimigo **inimigo);
		void descarregaInimigo (Inimigo **inimigo);
		void heroiNaBatalha (Heroi *heroi, Inimigo **inimigo, s16 posCenario[], Cenario *cenario);
		void empurraHeroi (Heroi *heroi, Inimigo *inimigo);
		void heroiBateNoInimigo (Heroi *heroi, Inimigo **inimigo);
		void incorporaEspirito(Heroi *heroi);
		void retocaMusica(Cenario *cenario);
		void liberaImagemDeDanos ();
		void iniciaImagemDeDanos ();
		void guardaPosicaoHeroiAntes(Heroi *heroi);
		void reposicionaHeroi(Heroi *heroi);
		void mostraDanoNaTela(Heroi *heroi, Inimigo *inimigo, int dano);
		void atualizaTemporarios(Heroi *heroi);
		void recarregaSpriteDoCenario(Cenario *cenario, int statusBau);

		Inimigo **sorteiaInimigos(Inimigo **inimigo, int n_inimigos);
		Inimigo **initInimigos (Inimigo **inimigo, int n_inimigos, int id_inimigo_sorteado[]);
		Inimigo **batalha (Heroi *heroi, Cenario *cenario, Status *status, Inimigo **inimigo, Magia *magia, s16 pos_cenario[], int statusBau);
		Inimigo **carregaInimigo (Inimigo **inimigo);
		
		char *retornaNomeInimigo (char *nomeFoto);

	protected:
		u8 _numero_inimigos;
		s8 cwidth;
		s8 cheight;
		u16 cadd;
		s32 ceixo_x;   /*Scroll positions...*/
		s32 ceixo_y;

		//dano q o inimigo da no heroi
		Numero *inimigoHer1_imagem_dano;
		Numero *inimigoHer2_imagem_dano;
		Numero *inimigoHer3_imagem_dano;

		//life q o heroi recupera com a pocao
		Numero *heroi_imagem_life;

		//dano q cada inimigo toma do heroi
		Numero *heroiIni1_imagem_dano;
		Numero *heroiIni2_imagem_dano;
		Numero *heroiIni3_imagem_dano;

		Numero *heroiIni1_imagem_dano_rot;
		Numero *heroiIni2_imagem_dano_rot;
		Numero *heroiIni3_imagem_dano_rot;

		Numero *heroiIni1_imagem_dano_rot_fogo_ef; //dano efetivo
		Numero *heroiIni2_imagem_dano_rot_fogo_ef;
		Numero *heroiIni3_imagem_dano_rot_fogo_ef;

		Numero *heroiIni1_imagem_dano_rot_fogo_nef; //dano nao efetivo
		Numero *heroiIni2_imagem_dano_rot_fogo_nef;
		Numero *heroiIni3_imagem_dano_rot_fogo_nef;

		Numero *heroiIni1_imagem_dano_mag_ef;
		Numero *heroiIni2_imagem_dano_mag_ef;
		Numero *heroiIni3_imagem_dano_mag_ef;

		Numero *heroiIni1_imagem_dano_mag_nef;
		Numero *heroiIni2_imagem_dano_mag_nef;
		Numero *heroiIni3_imagem_dano_mag_nef;

		Numero *heroiIni1_imagem_dano_fogo_ef;
		Numero *heroiIni2_imagem_dano_fogo_ef;
		Numero *heroiIni3_imagem_dano_fogo_ef;

		Numero *heroiIni1_imagem_dano_fogo_nef;
		Numero *heroiIni2_imagem_dano_fogo_nef;
		Numero *heroiIni3_imagem_dano_fogo_nef;

				



};

#endif
