/*========================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	Broken Soul is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
===========================================================================*/

#ifndef CENARIO_HPP
#define CENARIO_HPP

#include <PA9.h>				// PA_LIB
#include <fat.h>				// Devkit

#include "efs_lib.h"				// EFS

#include "nf_lib.h"				// NightFox's libs
#include "nf_easylib.h"

#include "definicoes.hpp"

class Cenario
{
	public:
		/* Guarda a referencia do cenario sendo mostrado na tela. */
		const char* referenciaAtual;

		/* Guarda a referencia do cenario antes de iniciar a batalha */
		const char* referenciaAnterior;

		void setReferencia(const char* referencia);
		
		void setReferenciaAnterior(const char* referencia);

		const char* getReferencia();

		const char* getReferenciaAnterior();

		void carregaBackground(u16 tela, u16 bg_num, const char* referencia, const char* nome);

		void descarregaBackground(u16 tela, u16 bg_num, const char* referencia);

		void moveBackground(s16 pos_cenario[], s32 scrollX, s32 scrollY, u8 direcao);
};
#endif
