/*=========================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	Broken Soul is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
============================================================================*/

#ifndef INIMIGO_HPP
#define INIMIGO_HPP

#include "efs_lib.h"         // EFS
#include "nf_lib.h"              // NightFox's libs
#include "nf_easylib.h"

#include "Persona.hpp"
#include "definicoes.hpp"
#include "Heroi.hpp"

//#include "Sound.hpp"


/* Heranca */
class Inimigo : public Persona {
	public:
		char *getNomeArquivo();

		int getFatorVelocidade();
		int getTipoComportamento();

		s32 getMp();
		s32 getDinheiro();		
		s32 getNivel();		
		s32 getXPMagia();
		s32 getNivelMagia();

		bool getStatusAtacando();
		bool getViradoPraDireita();
		bool getTomouDano();
		bool getMorto();
		bool getDanoMagico();

		u16 getFrameAnim ();
		u16 getContTomouDano ();
		u16 getTamSprite ();
		u16 getHpMax ();
		
		void setDanoMagico(bool dano_magico);
		void setMorto (bool morreu);
		void setComportamento (int tipoComportamento);
		void setTamSprite (u16 tam);
		void setTomouDano(bool tomou);
		void setViradoPraDireita (bool virado);
		void setNomeArquivo(char nome[]);
		void setMp(s32 sp);		
		void setHpMax(u16 hpMax);
		void setDinheiro(s32 dinheiro);
		void setNivel(s32 nivel);
		void setXPMagia(s32 xp_magia);
		void setNivelMagia(s32 nivel_magia);
		void setFrameAnim (u16 frame);
		void setContTomouDano (u16 contTomouDano);		/*tempo de dano - pra ser repelido qndo for atacado*/
		void setStatusAtacando (bool atacando);
		void setFatorVelocidade(int fator);
		void anda(Heroi *heroi, char *nomeInimigo);
		void ehAcertado(Heroi *heroi, char *nomeInimigo);
		void comportamentoInimigo (Heroi *heroi, int flag_descarrega, int id_inimigo);
		void atualizaStatus (int id);
		bool colisaoComHeroi (Heroi *heroi);

		//IA dos inimigos
		void foge(Heroi *heroi, char *nomeInimigo, s32 angulo);
		void traicoeiro (Heroi *heroi, char *nomeInimigo, s32 angulo);
		void agressivo (Heroi *heroi, char *nomeInimigo, s32 angulo);
		//
		
		void iniciaEspinho(int i);
		void iniciaGelecaVerde(int i);
		void iniciaGelecaAzul(int i);
		void iniciaGelecaVermelho(int i);
		void iniciaRocha(int i);
		void iniciaRocha2(int i);

	private:
		s32 _sp,
			_dinheiro,
			_nivel,
			_xp_magia,
			_nivel_magia;

		int _fatorVelocidade,
			_tipoComportamento;

		u16 _frame,
			_contTomouDano,
			_tamanho_sprite,
			_hp_max;

		bool _atacando,
			 _direita,
			 _tomouDano,	//pra verificar se tomou dano e decrementar o status
			 _morto,
			 _dano_magico;

		char _nomeArquivo[30];
};

#endif
