#ifndef MAGIA_HPP
#define MAGIA_HPP

#include <PA9.h>
#include <stdlib.h>

#include "efs_lib.h"         // EFS
#include "nf_lib.h"              // NightFox's libs
#include "nf_easylib.h"

#include "definicoes.hpp"


class Magia{
	public:
		void setContMagiaVivo(u16 cont);
		void setAngulo(u16 angulo);
		void setXInicial(s16 x);
		void setYInicial(s16 y);
		void setXFinal(s16 x);
		void setYFinal(s16 y);
		void setXMagia(s32 x);
		void setYMagia(s32 y);
		void setAtivado(bool ativo);
		void setVivo (bool vivo);
		void setRecoAtivado(bool ativado);
		void setColidiu(bool colidiu);

		u16 getAngulo();
		s16 getXInicial();
		s16	getYInicial();
		s16 getXFinal();
		s16	getYFinal();
		s32 getXMagia();
		s32 getYMagia();
		u16 getContMagiaVivo();
		bool getAtivado();
		bool getRecoAtivado();
		bool getVivo();
		bool getColidiu();
		bool controlaMagia(s32 heroiScrollX, s32 heroiScrollY, s32 inimigoPosX, s32 inimigoPosY, u8 tamSprite, int atualizouPosicao);

		void iniciaMagia(s32 heroiX, s32 heroiY, u16 angulo, u16 direcao);
		void atualizaMagia(u8 tela, s32 heroiScrollX, s32 heroiScrollY);
		void apagaMagia();
		void scrollMagia(u8 tela, char *nomeArquivo, s32 posicaoX, s32 posicaoY, s32 scrollX, s32 scrollY);
		bool colideMagia(s32 inimigoX, s32 inimigoY, u16 tam_sprite);
		void pegaFogo();
		void tempoDeVidaMagia();

	private:
		bool _colidiu;
		bool _ativo;
		bool _reco_ativado;
		bool _vivo;
		u16 _cont;
		u16 _angulo;
		s16 _x_inicial;
		s16 _y_inicial;
		s16 _x_final;
		s16 _y_final;
		s32 _x_magia;
		s32 _y_magia;
};

#endif
