#ifndef NPC_HPP
#define NPC_HPP

/*=========================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	Broken Soul is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
=========================================================================*/

#include <PA9.h>
#include "Heroi.hpp"
#include "transicao.hpp"
#include "definicoes.hpp"

#include "comumLib.hpp"

void iniciaSpriteCidade();
void carregaSpriteCidade(Heroi *hero);
void descarregaSpriteCidade();
void moveNPCCidade(char *NPC, int NPC_ID, int direcao, s16 pos_original);
u8 scrollNPCCidade(Heroi *hero, u8 tipo);

void iniciaSpriteFloresta();
void carregaSpriteFloresta();
void scrollNPCFloresta (Heroi *hero, u8 tipo);
void descarregaSpriteFloresta();

void descarregaSpriteCastelo();
void carregaSpriteCastelo();
void scrollNPCCastelo(Heroi *heroi, u8 tipo);

void moveNPC(char *NPC, int NPC_ID, int direcao, s16 pos_original);
void andaNPCHorizontal(char *NPC, int NPC_ID, int direcao, s16 pos_original);
void andaNPCVertical(char *NPC, int NPC_ID, int direcao, s16 pos_original);	

void iniciaSpriteCaverna();
void carregaSpriteCaverna(u8 frameBau);
void descarregaSpriteCaverna();
void scrollSpriteCaverna(Heroi *heroi, u8 tipo);

void iniciaSpriteDeserto();
void carregaSpriteDeserto();
void descarregaSpriteDeserto();
void scrollSpriteDeserto(Heroi *heroi, u8 tipo);

u8 colisaoHeroiNPC(Heroi *heroi, u8 tipo, u8 tamanho);
u8 distanciaFalaHeroiNPC(s32 heroiX, s32 heroiY, char *npcNome);

void descarregaSpriteBau();
void carregaSpriteBau();
void scrollItemBau(Heroi *heroi);
#endif
