/*========================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	Broken Soul is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
==========================================================================*/

#ifndef PERSONA_HPP
#define PERSONA_HPP

#include <PA9.h>
#include <iostream>
#include <string>
#include "definicoes.hpp"

class Persona
{
	public:
		char *getNome();
		u8 getStatus();
		u8 getAtaque(int nAtaque);
		u8 getDefesa(int nDefesa);
		u8 getDirecao();
		u16 getHp();
		u8 getPtsAtaque();

		s32 getExperiencia();
		s32 getExperienciaMax();
		s32 getTempoAtaque(int nAtaque);
		s32 getTempoDefesa(int nDefesa);
		s32 getPosicaoCenarioX();
		s32 getPosicaoCenarioY();
		s32 getScrollX();
		s32 getScrollY();
		s32 getVelocidade();
		s32 getRaioColisao();
		s32 getPosicaoTelaX();
		s32 getPosicaoTelaY();
		
		void setNome(char nome[]);
		void setStatus(u8 status);
		void setAtaque(int nAtaque, u8 ataque);
		void setDefesa(int nDefesa, u8 defesa);
		void setHp(u16 hp);
		void setPtsAtaque(u8 pts_ataque);
		void setExperiencia(s32 experiencia);
		void setExperienciaMax(s32 experiencia_max);
		void setTempoAtaque(int nAtaque, s32 tempoAtaque);
		void setTempoDefesa(int ndefesa, s32 tempoDefesa);
		void setPosicaoCenarioX(s32 posicaoCenarioX);
		void setPosicaoCenarioY(s32 posicaoCenarioY);
		void setScrollX(s32 scrollX);
		void setScrollY(s32 scrollY);
		void setVelocidade(s32 velocidade);
		void setRaioColisao(s32 raio);
		void setPosicaoTelaX(s32 posicaoTelaX);
		void setPosicaoTelaY(s32 posicaoTelaY);
		void setDirecao(u8 direcao);

	protected:
		char _nome[30];
		u8 _status,
		     _ataque[4],
		     _defesa[2],
			 _direcao,
			 _hp_max,
			 _pts_ataque;

		u16 _hp;

		s32 _experiencia,
			_experiencia_max,
			_tempoAtaque[4],
			_tempoDefesa[2],
			_posicaoCenario[2],
			_scroll[2],
			_velocidade,
			_raioColisao,
			_posicaoTela[2];
};

#endif
