#ifndef STATUS_HPP
#define STATUS_HPP

#include <PA9.h>
#include "Sound.hpp"
#include "Item.hpp"
#include "Heroi.hpp"
#include "transicao.hpp"
#include "Status.hpp"
#include "comumLib.hpp"
#include "Inimigo.hpp"

#include "efs_lib.h"			// EFS

#include "nf_lib.h"				// NightFox's libs
#include "nf_easylib.h"

#define BARRA_EXP_MAG 42
#define BARRA_EXP_NORM 0

#define POS_X_SETA 7
#define POS_Y_SETA_1 117
#define POS_Y_SETA_2 133
#define POS_Y_SETA_3 149
#define POS_Y_SETA_4 165

#define POS_X_SETA_ITEM	    70
#define POS_Y_SETA_ITEM_1   60
#define POS_Y_SETA_ITEM_2   68 
#define POS_Y_SETA_ITEM_3   76
#define POS_Y_SETA_ITEM_4   84
#define POS_Y_SETA_ITEM_5   92
#define POS_Y_SETA_ITEM_6   100
#define POS_Y_SETA_ITEM_7   108
#define POS_Y_SETA_ITEM_8   116
#define POS_Y_SETA_ITEM_9   124
#define POS_Y_SETA_ITEM_10  132

class Status
{
	public:

		u16 get_endereco_sprite ();
		u16 get_endereco_seta ();
		u16 get_endereco_seta_item ();
		u8 get_x_seta ();
		u8 get_y_seta ();
		u8 get_x_seta_item ();
        u8 get_y_seta_item ();

		void set_endereco_sprite (u16 end);
		void set_endereco_seta (u16 end);
		void set_endereco_seta_item (u16 end);
		void set_x_seta (u8 x);
		void set_y_seta (u8 y);
		void set_x_seta_item (u8 x);
        void set_y_seta_item (u8 y);
		void carregaInimigoStatus(Inimigo **inimigo, u8 n_inimigos);
		void inicia_status();
		void mostra_status (Heroi *heroi);
		void posiciona_seta();
		u8 posiciona_seta_item (Heroi *heroi, u8 tipoMenu);
		void carrega_template_batalha ();
		void descarrega_template_batalha ();
		int  abrir_menu(Item *item, int menu, Heroi *heroi, u8 *botaoStart, u8 *carregaPaused);
		int  abrir_menu_item(Item *item, int menu, Heroi *heroi);
		int  menu_sair(int menu, u8 *botaoStart, u8 *carregaPaused);
		void usar_item_selecionado(Heroi *heroi, Item *item);
		

	private:
		/*endereco onde fica a imagem na VRAM do DS*/
		u16 _endereco_seta;	
		u16 _endereco_seta_item;
		u8 _x_seta;		/*coordenada da seta*/
		u8 _y_seta;		/*coordenada da seta*/
		u8 _x_seta_item;
		u8 _y_seta_item;
		bool esta_menu_pai;
};

#endif
