/*=========================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	Broken Soul is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
============================================================================*/

#ifndef DEFINICOES_HPP
#define DEFINICOES_HPP

/* Macros */
#define norm_fix(x) ((x)<<8)
#define fix_norm(x) ((x)>>8)

/* Constantes */
#define PARADO 1
#define ANDANDO 2

#define ATACANDO 3
#define ATACOU 4

#define LANCANDO_MAGIA 5

#define CIMA 1
#define BAIXO 2
#define LADO_DIREITO 3
#define LADO_ESQUERDO 4

#define CENTROX 127
#define CENTROY 95

#define ITENS_MAX_MOCHILA 10

#define ESTA_MENU_PAI 0
#define ESTA_MENU_ITEM 1
#define ESTA_MENU_ESPIRITOS 2
#define ESTA_MENU_SAIR 3

#define ATAQUE_A 0

#define VELOCIDADE_ATAQUE 19

#define VELOCIDADE_ANIMACAO_MAGIA 10

#define CENTRO_SPRITE_HEROI_X 32
#define CENTRO_SPRITE_HEROI_Y 32

#define INICIO_SPRITE_ANDANDO_CIMA 0
#define FIM_SPRITE_ANDANDO_CIMA 9

#define INICIO_SPRITE_ANDANDO_BAIXO 10
#define FIM_SPRITE_ANDANDO_BAIXO 19

#define INICIO_SPRITE_ANDANDO_LADO 20
#define FIM_SPRITE_ANDANDO_LADO 29

#define ATAQUE_A_INICIO_CIMA 39
#define ATAQUE_A_FIM_CIMA 47

#define ATAQUE_A_INICIO_BAIXO 48
#define ATAQUE_A_FIM_BAIXO 56

#define ATAQUE_A_INICIO_LADO 57
#define ATAQUE_A_FIM_LADO 65

#define ATAQUE_ESPADA_FOGO_INICIO_CIMA 75
#define ATAQUE_ESPADA_FOGO_FIM_CIMA 81

#define ATAQUE_ESPADA_FOGO_INICIO_BAIXO 84
#define ATAQUE_ESPADA_FOGO_FIM_BAIXO 91

#define ATAQUE_ESPADA_FOGO_INICIO_LADO 92
#define ATAQUE_ESPADA_FOGO_FIM_LADO 99

#define LANCANDO_MAGIA_INICIO_CIMA 109
#define LANCANDO_MAGIA_FIM_CIMA 114

#define LANCANDO_MAGIA_INICIO_LADO 121
#define LANCANDO_MAGIA_FIM_LADO 126

#define LANCANDO_MAGIA_INICIO_BAIXO 115
#define LANCANDO_MAGIA_FIM_BAIXO 120

#define ID_SETA_MENU 84
#define ID_SETA_SUBMENU 85

#define PALETA_SETA_MENU 13
#define PALETA_SETA_SUBMENU 14
#define PALETA_BARRA_EXP 15

#define TEMPO_REPULSAO 20

/////////////////////////////////////////////////////////////////////////////////////////
//enderecos de sprite pra tela de baixo
#define END_HEROI 0
#define END_SETA_CONVERSA 1

#define PALETA_HEROI 0
#define PALETA_SETA_CONVERSA 1 

//////////////////////////////////////////////////////////////////////////////////////////
//posicao dos NPCs da cidade na tela
#define GOKU_ID 0
#define GOKU_X 250
#define GOKU_Y 70

#define SENHOR_ID 9
#define SENHOR_X 320
#define SENHOR_Y 70

#define SENHORA_AZUL_ID 1
#define SENHORA_AZUL_X 150
#define SENHORA_AZUL_Y 285

#define IRMA_ID 2
#define IRMA_X 390
#define IRMA_Y 235

#define GIRL_ID 3
#define GIRL_X 13
#define GIRL_Y 65

#define FAZENDEIRO_MORENO_ID 4
#define FAZENDEIRO_MORENO_X 14
#define FAZENDEIRO_MORENO_Y 455

#define BOY_ID 5
#define BOY_X 311
#define BOY_Y 460

#define SENHORA_BRANCO_ID 6
#define SENHORA_BRANCO_X 131
#define SENHORA_BRANCO_Y 421

#define GALINHA_ID 8
#define GALINHA_X 82
#define GALINHA_Y 426

#define FAZENDEIRO_LOIRO_ID 7
#define FAZENDEIRO_LOIRO_X 100
#define FAZENDEIRO_LOIRO_Y 400

#define COLISAO_HORIZONTAL 1
#define COLISAO_VERTICAL 2

//////////////////////////////////////////////////////////////////////////////////////////
//posicao dos NPCs da floresta na tela
#define BORBOLETA1_ID 0
#define BORBOLETA2_ID 1
#define CARA_FLORESTA_ID 2

#define CARA_FLORESTA_X 158
#define CARA_FLORESTA_Y	50


//////////////////////////////////////////////////////////////////////////////////////////
//posicao dos NPCs do deserto na tela
#define CARA_DO_DESERTO_ID 0

#define CARA_DO_DESERTO_X 100
#define CARA_DO_DESERTO_Y 30

//////////////////////////////////////////////////////////////////////////////////////////
//posicao dos NPCs na caverna na tela
#define CARA_DA_CAVERNA_ID 0

#define CARA_DA_CAVERNA_X 90
#define CARA_DA_CAVERNA_Y 328

//////////////////////////////////////////////////////////////////////////////////////////
//posicao dos NPCs ni inn na tela
#define CARA_DO_INN_ID 0

#define CARA_DO_INN_X 100
#define CARA_DO_INN_Y 100

//////////////////////////////////////////////////////////////////////////////////////////
//posicao dos NPCs do castelo na tela
#define REI_ID 0
#define RAINHA_ID 1
#define MAGO_ID 2

#define REI_X	103
#define REI_Y	66
#define RAINHA_X	124
#define RAINHA_Y	66
#define MAGO_X	170
#define MAGO_Y	80

/////////////////////////////////////////////////////////////////////////////////////////
//tipo de comportamento do inimigo
#define AGRESSIVO 0
#define TRAICOEIRO 1
#define FUJAO 2





//////////////////////////////////////////////////////////////////////////////////////////
//id dos personagens da batalha
#define INIMIGO1 0
#define INIMIGO2 1
#define INIMIGO3 2
#define HEROI 3
#define NUM_VERDE 4  

//////////////////////////////////////////////////////////////////////////////////////////
//enumeracao dos cenarios
enum Cenarios {FALSO = 0, VERDADEIRO, MAPA, CIDADE, CASTELO, INN, FLORESTA1, FLORESTA2, DESERTO1, DESERTO2, FOSSIL, CAVERNA1, CAVERNA2, CAVERNA3, CHEFE1, CHEFE2, ROCHA, VULCAO1, VULCAO2, CHEFE3};

enum Tipo_Item {
	ITEM_HP = 0,
	ITEM_MP,
	ITEM_DEF
};

enum Quests {
	QUEST_FAZ_MORENO = 0,
	QUEST_FAZ
};
#endif 
