#ifndef __NF_COMMON_H__
#define __NF_COMMON_H__

#ifdef __cplusplus
extern "C" {
#endif





	// NightFox LIB - COMMON Functions
	// Requires PA_LIB, NODA AS_LIB & EFS 2.0.
	// Code by NightFox
	// http://blogs.gamefilia.com/knightfox
	// Version BETA.3.c.081117





	// Include required libs
	#include <PA9.h>			// PA_LIB




	// Function NF_FadeIn();
	void NF_FadeIn(void);
	/*
	Makes both screens fade from black to normal.
	Takes the control of program until it ends.
	*/


	// Function NF_FadeOut();
	void NF_FadeOut(void);
	/*
	Makes both screens fade from normal to black.
	Takes the control of program until it ends
	*/



	// Function NF_Error();
	void NF_Error(u8 codigo, const char* descripcion);
	/*
	NF_Error(
			u8 error code,
			char "description");
	Generates a error message for debuggin, and stops the program.
	Use NULL as description if you dont want to show any extended message.

	code		message
	----		-------
	0			No errors
	1			File not found
	2			Out of memory
	3			Invalid argument in fuction
	4			Background not found
	5			Out of bg slots
	6			Out of sfx slots
	7			Out of collision map slots

	*/



	// Function NF_InitPA();
	void NF_InitPA(void);
	/*
	Inits PALIB with most common options
	*/



	// Function NF_SetDefaultMode(u8 a, u8 b);
	void NF_SetDefaultMode(u8 a, u8 b);
	/*
	Sets the most common mode for graphics
	a - screen 0 / b - screen 1
	0 - Default mode, no special Bg's. No text.
	1 - Default mode, no special Bg's. Text on layer 0.
	*/





#ifdef __cplusplus
}
#endif


#endif
