#ifndef __NF_EASYCOMMON_H__
#define __NF_EASYCOMMON_H__

#ifdef __cplusplus
extern "C" {
#endif





	// NightFox LIB - Easy Common Functions
	// Requires PA_LIB, NODA AS_LIB & EFS 2.0.
	// Code by NightFox
	// http://blogs.gamefilia.com/knightfox
	// Version BETA.3.c.081117





	// Include required libs
	#include <PA9.h>			// PA_LIB





	// Function NF_EasyMoveSprite();
	void NF_EasyMoveSprite(u8 pantalla, const char* referencia, s16 x, s16 y);
	/*
	Moves the sprite to the given coordinates
	NF_EasyMoveSprite(
					u8 screen,
					"name of the sprite",
					s16 position x,
					s16 position y);
	NF_EasyMoveSprite(1, "mysprite", 80, 60);
	*/




	// Function NF_EasySetSpriteFrame();
	void NF_EasySetSpriteFrame(u8 pantalla, const char* referencia, u16 frame);
	/*
	Sets the frame on a animated sprite
	NF_EasySetSpriteFrame(
						u8 screen,
						"mysprite",
						u16 frame);
	NF_EasySetSpriteFrame(1, "player", 3);
	*/





	// Function NF_EasySetSpriteLayer();
	void NF_EasySetSpriteLayer(u8 pantalla, const char* referencia, u8 layer);
	/*
	Sets the background layer over the sprite will be drawed.
	NF_EasySetSpriteLayer(
						u8 screen,
						"mysprite",
						u8 background);
	NF_EasySetSpriteFrame(1, "player", 2);
	*/





	// Function NF_EasySpriteFlipH();
	void NF_EasySpriteFlipH(u8 pantalla, const char* referencia);
	/*
	Flips the sprite horitzontaly
	NF_EasySpriteFlipH(
						u8 screen,
						"mysprite");
	NF_EasySpriteFlipH(1, "player");
	*/





	// Function NF_EasySpriteFlipV();
	void NF_EasySpriteFlipV(u8 pantalla, const char* referencia);
	/*
	Flips the sprite verticaly
	NF_EasySpriteFlipV(
						u8 screen,
						"mysprite");
	NF_EasySpriteFlipV(1, "player");
	*/





	// Function NF_EasyDeleteSprite();
	extern u8 NF_EasyGetSpriteId(u8 pantalla, const char* referencia);
	/*
	Returns the internal ID assigned to the sprite.
	Use this to get the ID number of sprite and use later in other sprite functions of PALIB
	u8 NF_EasyGetSpriteId(
						u8 screen,
						"name of the sprite");
	n = NF_EasyGetSpriteId(1, "mysprite")
	*/





	// Function NF_EasyOverlapSprite();
	extern bool NF_EasyOverlapSprite(u8 pantalla, const char* sprite_a, const char* sprite_b);
	/*
	Return if tow sprites are overlaping.
	Returns TRUE or FALSE (Boolean type)
	NF_EasyOverlapSprite(
						u8 screen,
						"sprite a",
						"sprite b");
	if (NF_EasyOverlapSprite(1, "player", "enemy")) {
		live --;
	} else {
		score ++;
	}
	*/





#ifdef __cplusplus
}
#endif


#endif
