/*=========================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	Broken Soul is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
=========================================================================*/

/*#include <PA9.h>*/
//#include <maxmod9.h>

#include "include/main.hpp"
#include "include/menu.hpp"

#include <unistd.h>
#include <malloc.h>


bool batalhando = false;
s32 angulo;
s8 statusBau;
s8 quests[2];
Item *itemNovo;

extern u8 __end__[];        // end of static code and data
extern u8 __eheap_end[];    // farthest point to which the heap will grow

void mudaStatusQuests(u8 npcIndex);
void mudaFalaNPCQuest(u8 npcIndex);

u8* getHeapStart() {
	   return __end__;
}
u8* getHeapEnd() {
	   return (u8*)sbrk(0);
}
u8* getHeapLimit() {
	   return __eheap_end;
}
int getMemUsed() {
	   struct mallinfo mi = mallinfo();
	      return mi.uordblks;
}
int getMemFree() {
	   struct mallinfo mi = mallinfo();
	      return mi.fordblks + (getHeapLimit() - getHeapEnd());
}

void colisaoDetect(Heroi *heroi, Cenario *cenario)
{
	u8 tipoCenario, direcaoColisaoHorizontal, direcaoColisaoVertical;

	if(Stylus.Held) 
	{
		heroi->setStatus(ANDANDO);
		angulo = PA_GetAngle((fix_norm(heroi->getPosicaoTelaX())), (fix_norm(heroi->getPosicaoTelaY())), Stylus.X, Stylus.Y);
		heroi->setAngulo(angulo);

		tipoCenario = temColisao(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), angulo, cenario->getReferencia(),
		&direcaoColisaoHorizontal, &direcaoColisaoVertical);

		heroi->setPosicaoCenarioAnteriorX(heroi->getPosicaoCenarioX());
		heroi->setPosicaoCenarioAnteriorY(heroi->getPosicaoCenarioY());

		heroi->setScrollAnteriorX(heroi->getScrollX());
		heroi->setScrollAnteriorY(heroi->getScrollY());

		heroi->setPosicaoTelaAnteriorX(heroi->getPosicaoTelaX());
		heroi->setPosicaoTelaAnteriorY(heroi->getPosicaoTelaY());

		heroi->setDirecaoColisaoHorizontal(direcaoColisaoHorizontal);
		heroi->setDirecaoColisaoVertical(direcaoColisaoVertical);
		
		/*PA_OutputText (0, 2, 6, "                         ");
		PA_OutputText (0, 2, 6, "PosTelaX: %d", fix_norm(heroi->getPosicaoTelaX()));
		PA_OutputText (0, 2, 7, "                         ");
		PA_OutputText (0, 2, 7, "PosTelaY: %d",fix_norm(heroi->getPosicaoTelaY()));
		PA_OutputText (0, 2, 8, "                         ");
		PA_OutputText (0, 2, 8, "PosCenX: %d",fix_norm(heroi->getPosicaoCenarioX()));
		PA_OutputText (0, 2, 9, "                         ");
		PA_OutputText (0, 2, 9, "PosCenY: %d",fix_norm(heroi->getPosicaoCenarioY()));
		PA_OutputText (0, 2, 10, "                         ");
		PA_OutputText (0, 2, 10, "ScrollX: %d",fix_norm(heroi->getScrollX()));
		PA_OutputText (0, 2, 11, "                         ");
		PA_OutputText (0, 2, 11, "ScrollY: %d",fix_norm(heroi->getScrollY()));*/
		
		if(tipoCenario == MAPA)
		{
			if(strcmp(cenario->getReferencia(), "cidade") == 0)
			{
				descarregaSpriteCidade();
				heroi->setPosicaoTelaX(norm_fix(133));
				heroi->setPosicaoTelaY(norm_fix(163));
				heroi->setPosicaoCenarioX(norm_fix(133));
				heroi->setPosicaoCenarioY(norm_fix(484));
				heroi->setScrollX(norm_fix(0));
				heroi->setScrollY(norm_fix(321));
				heroi->movimenta(heroi->getAngulo(), cenario->getReferencia());
				PA_WaitForVBL();
			}
			else if(strcmp(cenario->getReferencia(), "floresta1") == 0)
			{
				descarregaSpriteFloresta();
				heroi->setPosicaoTelaX(norm_fix(97));
				heroi->setPosicaoTelaY(norm_fix(150));
				heroi->setPosicaoCenarioX(norm_fix(353));
				heroi->setPosicaoCenarioY(norm_fix(415));
				heroi->setScrollX(norm_fix(255));
				heroi->setScrollY(norm_fix(264));
				heroi->movimenta(heroi->getAngulo(), cenario->getReferencia());
				PA_WaitForVBL();
			}
			else if(strcmp(cenario->getReferencia(), "cenarioCaverna") == 0)
			{
				descarregaSpriteCaverna();
				heroi->setPosicaoTelaX(norm_fix(104));
				heroi->setPosicaoTelaY(norm_fix(144));
				heroi->setPosicaoCenarioX(norm_fix(102));
				heroi->setPosicaoCenarioY(norm_fix(262));
				heroi->setScrollX(norm_fix(0));
				heroi->setScrollY(norm_fix(117));
				heroi->movimenta(heroi->getAngulo(), cenario->getReferencia());
				PA_WaitForVBL();
			}
			else if(strcmp(cenario->getReferencia(), "deserto") == 0 ||
					strcmp(cenario->getReferencia(), "deserto2") == 0)
			{
				if (strcmp (cenario->getReferencia(), "deserto") == 0)
					descarregaSpriteDeserto();
				heroi->setPosicaoTelaX(norm_fix(165));
				heroi->setPosicaoTelaY(norm_fix(64));
				heroi->setPosicaoCenarioX(norm_fix(420));
				heroi->setPosicaoCenarioY(norm_fix(93));
				heroi->setScrollX(norm_fix(255));
				heroi->setScrollY(norm_fix(29));
				heroi->movimenta(heroi->getAngulo(), cenario->getReferencia());
				PA_WaitForVBL();
			}
			else if(strcmp(cenario->getReferencia(), "Rocha") == 0)
			{
				heroi->setPosicaoTelaX(norm_fix(197));
				heroi->setPosicaoTelaY(norm_fix(136));
				heroi->setPosicaoCenarioX(norm_fix(453));
				heroi->setPosicaoCenarioY(norm_fix(227));
				heroi->setScrollX(norm_fix(255));
				heroi->setScrollY(norm_fix(91));
				heroi->movimenta(heroi->getAngulo(), cenario->getReferencia());
				PA_WaitForVBL();
			}
			else if(strcmp(cenario->getReferencia(), "vulcao1") == 0)
			{
				heroi->setPosicaoTelaX(norm_fix(197));
				heroi->setPosicaoTelaY(norm_fix(136));
				heroi->setPosicaoCenarioX(norm_fix(453));
				heroi->setPosicaoCenarioY(norm_fix(227));
				heroi->setScrollX(norm_fix(255));
				heroi->setScrollY(norm_fix(91));
				heroi->movimenta(heroi->getAngulo(), cenario->getReferencia());
				PA_WaitForVBL();
			}
			

			transicao_escurecer();
			cenario->descarregaBackground(0, 3, cenario->getReferencia());
			cenario->carregaBackground(0, 3, "mapa", "mapa");
			PA_InitParallaxX(0, 0, 256, 128, 256);
			PA_InitParallaxY(0, 0, 256, 128, 256);
			heroi->setAngulo(0);
			heroi->setStatus(PARADO);
			heroi->setTrocouCenario(1);

			stopMP3();
			PA_WaitForVBL();
			PA_WaitForVBL();
			playMP3("mapa");
			AS_SetMP3Loop(true);
		}
		else if(tipoCenario == CIDADE)
		{
			transicao_escurecer();

			if (strcmp(cenario->getReferencia(), "castelo") == 0){
				descarregaSpriteCastelo();
			}

			cenario->descarregaBackground(0, 3, cenario->getReferencia());
			cenario->carregaBackground(0, 3, "cidade", "cidade");
			PA_InitParallaxX(0, 0, 256, 128, 256);
			PA_InitParallaxY(0, 0, 256, 128, 256);
			heroi->setPosicaoTelaX(norm_fix(160));
			heroi->setPosicaoTelaY(norm_fix(140));
			heroi->setPosicaoCenarioX(norm_fix(280));
			heroi->setPosicaoCenarioY(norm_fix(313));
			heroi->setScrollX(norm_fix(119));
			heroi->setScrollY(norm_fix(72));
			heroi->setAngulo(0);
			heroi->setStatus(PARADO);
			heroi->setTrocouCenario(1);			

			carregaSpriteCidade(heroi);
			heroi->movimenta(angulo, cenario->getReferencia());

			stopMP3();
			PA_WaitForVBL();
			PA_WaitForVBL();
			playMP3("vila");
			AS_SetMP3Loop(true);
		}
		else if(tipoCenario == CASTELO)
		{
			transicao_escurecer();
			cenario->descarregaBackground(0, 3, cenario->getReferencia());
			cenario->carregaBackground(0, 3, "castelo", "castelo");
			cenario->setReferenciaAnterior ("castelo");
			PA_InitParallaxX(0, 0, 256, 128, 256);
			PA_InitParallaxY(0, 0, 256, 128, 256);
			heroi->setPosicaoTelaX(norm_fix(129));
			heroi->setPosicaoTelaY(norm_fix(170));
			heroi->setPosicaoCenarioX(norm_fix(129));
			heroi->setPosicaoCenarioY(norm_fix(492));
			heroi->setScrollX(0);
			heroi->setScrollY(norm_fix(321));
			heroi->setAngulo(0);
			heroi->setStatus(PARADO);
			heroi->setTrocouCenario(1);
			descarregaSpriteCidade();
			carregaSpriteCastelo();

			stopMP3();
			PA_WaitForVBL();
			PA_WaitForVBL();
			PA_WaitForVBL();
			PA_WaitForVBL();
			playMP3("castelo");
			AS_SetMP3Loop(true);
		}
		else if(tipoCenario == INN)
		{
			transicao_escurecer();
			cenario->descarregaBackground(0, 3, cenario->getReferencia());
			cenario->carregaBackground(0, 3, "inn", "inn");
			PA_InitParallaxX(0, 0, 256, 128, 256);
			PA_InitParallaxY(0, 0, 256, 128, 256);
			heroi->setPosicaoTelaX(norm_fix(50));
			heroi->setPosicaoTelaY(norm_fix(150));
			heroi->setPosicaoCenarioX(norm_fix(50));
			heroi->setPosicaoCenarioY(norm_fix(150));
			heroi->setScrollX(0);
			heroi->setScrollY(0);
			heroi->setAngulo(0);
			heroi->setStatus(PARADO);
			heroi->setTrocouCenario(1);
			descarregaSpriteCidade();
		}
		else if(tipoCenario == FLORESTA1)
		{
			transicao_escurecer();
			cenario->descarregaBackground(0, 3, cenario->getReferencia());
			cenario->carregaBackground(0, 3, "floresta1", "floresta1");
			cenario->setReferenciaAnterior("floresta1");
			PA_InitParallaxX(0, 0, 256, 128, 256);
			PA_InitParallaxY(0, 0, 256, 128, 256);
			heroi->setPosicaoTelaX(norm_fix(140));
			heroi->setPosicaoTelaY(norm_fix(20));
			heroi->setPosicaoCenarioX(norm_fix(140));
			heroi->setPosicaoCenarioY(norm_fix(20));
			heroi->setScrollX(0);
			heroi->setScrollY(0);
			heroi->setAngulo(0);
			heroi->setStatus(PARADO);
			heroi->setTrocouCenario(1);

			carregaSpriteFloresta();

			stopMP3();
			PA_WaitForVBL();
			PA_WaitForVBL();
			playMP3("floresta");
			AS_SetMP3Loop(true);
		}
		else if(tipoCenario == FLORESTA2)
		{
			transicao_escurecer();
			cenario->descarregaBackground(0, 3, cenario->getReferencia());
			cenario->carregaBackground(0, 3, "floresta2", "floresta2");
			PA_InitParallaxX(0, 0, 256, 128, 256);
			PA_InitParallaxY(0, 0, 256, 128, 256);
			heroi->setPosicaoTelaX(norm_fix(20));
			heroi->setPosicaoTelaY(norm_fix(115));
			heroi->setPosicaoCenarioX(norm_fix(20));
			heroi->setPosicaoCenarioY(norm_fix(115));
			heroi->setScrollX(0); 
			heroi->setScrollY(0);
			heroi->setAngulo(0);
			heroi->setStatus(PARADO);
			heroi->setTrocouCenario(1);

			descarregaSpriteFloresta();
		}
		else if(tipoCenario == DESERTO1)
		{
			transicao_escurecer();
			cenario->descarregaBackground(0, 3, cenario->getReferencia());
			cenario->carregaBackground(0, 3, "deserto", "deserto");
			PA_InitParallaxX(0, 0, 256, 128, 256);
			PA_InitParallaxY(0, 0, 256, 128, 256);
			heroi->setPosicaoTelaX(norm_fix(50));
			heroi->setPosicaoTelaY(norm_fix(100));
			heroi->setPosicaoCenarioX(norm_fix(50));
			heroi->setPosicaoCenarioY(norm_fix(100));
			heroi->setScrollX(0);
			heroi->setScrollY(0);
			heroi->setAngulo(0);
			heroi->setStatus(PARADO);
			heroi->setTrocouCenario(1);
			carregaSpriteDeserto();

			stopMP3();
			PA_WaitForVBL();
			PA_WaitForVBL();
			playMP3("deserto");
			AS_SetMP3Loop(true);
		}
		else if(tipoCenario == DESERTO2)
		{
			transicao_escurecer(); 
			cenario->descarregaBackground(0, 3, cenario->getReferencia());
			cenario->carregaBackground(0, 3, "deserto2", "deserto2");
			PA_InitParallaxX(0, 0, 256, 128, 256);
			PA_InitParallaxY(0, 0, 256, 128, 256);
			heroi->setPosicaoTelaX(norm_fix(100));
			heroi->setPosicaoTelaY(norm_fix(100));
			heroi->setPosicaoCenarioX(norm_fix(100));
			heroi->setPosicaoCenarioY(norm_fix(100));
			heroi->setScrollX(0);
			heroi->setScrollY(0);
			heroi->setAngulo(0);
			heroi->setStatus(PARADO);
			heroi->setTrocouCenario(1);
			descarregaSpriteDeserto();
		}
		else if(tipoCenario == CAVERNA1)
		{
			transicao_escurecer();
			cenario->descarregaBackground(0, 3, cenario->getReferencia());

			cenario->carregaBackground(0, 3, "cenarioCaverna", "cenarioCaverna");
			PA_InitParallaxX(0, 0, 256, 128, 256);
			PA_InitParallaxY(0, 0, 256, 128, 256);
			heroi->setPosicaoTelaX(norm_fix(25));
			heroi->setPosicaoTelaY(norm_fix(163));
			heroi->setPosicaoCenarioX(norm_fix(25));
			heroi->setPosicaoCenarioY(norm_fix(493));
			heroi->setScrollX(norm_fix(1));
			heroi->setScrollY(norm_fix(329));
			heroi->setAngulo(0);
			heroi->setStatus(PARADO);
			heroi->setTrocouCenario(1);
			carregaSpriteCaverna(statusBau);

			stopMP3();
			PA_WaitForVBL();
			PA_WaitForVBL();
			playMP3("caverna");
			AS_SetMP3Loop(true);
		}
		else if(tipoCenario == CAVERNA2)
		{
			transicao_escurecer();
			cenario->descarregaBackground(0, 3, cenario->getReferencia());
			cenario->carregaBackground(0, 3, "cenarioCaverna2", "cenarioCaverna2");
			PA_InitParallaxX(0, 0, 256, 128, 256);
			PA_InitParallaxY(0, 0, 256, 128, 256);
			heroi->setPosicaoTelaX(norm_fix(28));
			heroi->setPosicaoTelaY(norm_fix(162));
			heroi->setPosicaoCenarioX(norm_fix(28));
			heroi->setPosicaoCenarioY(norm_fix(491));
			heroi->setScrollX(0);
			heroi->setScrollY(norm_fix(329));
			heroi->setAngulo(0);
			heroi->setStatus(PARADO);
			heroi->setTrocouCenario(1);
			descarregaSpriteCaverna();

		}
		else if(tipoCenario == CAVERNA3)
		{
			transicao_escurecer();
			cenario->descarregaBackground(0, 3, cenario->getReferencia());
			cenario->carregaBackground(0, 3, "cenarioCaverna3", "cenarioCaverna3");
			PA_InitParallaxX(0, 0, 256, 128, 256);
			PA_InitParallaxY(0, 0, 256, 128, 256);
			heroi->setPosicaoTelaX(norm_fix(22));
			heroi->setPosicaoTelaY(norm_fix(153));
			heroi->setPosicaoCenarioX(norm_fix(22));
			heroi->setPosicaoCenarioY(norm_fix(483));
			heroi->setScrollX(0);
			heroi->setScrollY(norm_fix(329));
			heroi->setAngulo(0);
			heroi->setStatus(PARADO);
			heroi->setTrocouCenario(1);
			descarregaSpriteCaverna();
		}
		else if(tipoCenario == ROCHA)
		{
			transicao_escurecer();
			cenario->descarregaBackground(0, 3, cenario->getReferencia());
			cenario->carregaBackground(0, 3, "Rocha", "Rocha");
			PA_InitParallaxX(0, 0, 256, 128, 256);
			PA_InitParallaxY(0, 0, 256, 128, 256);
			heroi->setPosicaoTelaX(norm_fix(126));
			heroi->setPosicaoTelaY(norm_fix(153));
			heroi->setPosicaoCenarioX(norm_fix(126));
			heroi->setPosicaoCenarioY(norm_fix(475));
			heroi->setScrollX(norm_fix(0));
			heroi->setScrollY(norm_fix(321));
			heroi->setAngulo(0);
			heroi->setStatus(PARADO);
			heroi->setTrocouCenario(1);

			stopMP3();
			PA_WaitForVBL();
			PA_WaitForVBL();
			PA_WaitForVBL();
			PA_WaitForVBL();
			playMP3("rocha");
			AS_SetMP3Loop(true);
		}
		else if(tipoCenario == VULCAO1)
		{
			transicao_escurecer();
			cenario->descarregaBackground(0, 3, cenario->getReferencia());
			cenario->carregaBackground(0, 3, "vulcao1", "vulcao1");
			PA_InitParallaxX(0, 0, 256, 128, 256);
			PA_InitParallaxY(0, 0, 256, 128, 256);
			heroi->setPosicaoTelaX(norm_fix(31));
			heroi->setPosicaoTelaY(norm_fix(137));
			heroi->setPosicaoCenarioX(norm_fix(32));
			heroi->setPosicaoCenarioY(norm_fix(458));
			heroi->setScrollX(norm_fix(1));
			heroi->setScrollY(norm_fix(321));
			heroi->setAngulo(0);
			heroi->setStatus(PARADO);
			heroi->setTrocouCenario(1);
		}
		else if(tipoCenario == VULCAO2)
		{
			transicao_escurecer();
			cenario->descarregaBackground(0, 3, cenario->getReferencia());
			cenario->carregaBackground(0, 3, "vulcao2", "vulcao2");
			PA_InitParallaxX(0, 0, 256, 128, 256);
			PA_InitParallaxY(0, 0, 256, 128, 256);
			heroi->setPosicaoTelaX(norm_fix(30));
			heroi->setPosicaoTelaY(norm_fix(30));
			heroi->setPosicaoCenarioX(norm_fix(30));
			heroi->setPosicaoCenarioY(norm_fix(30));
			heroi->setScrollX(norm_fix(0));
			heroi->setScrollY(norm_fix(0));
			heroi->setAngulo(0);
			heroi->setStatus(PARADO);
			heroi->setTrocouCenario(1);
		}
	}
}

void carregaTextoNPCCidade()
{
	u8 i;
	for(i = 0; i < 9; i++)
	{
		textoNPC[i] = new Texto();
		falaNPC[i] = 0;
	}

	textoNPC[0]->carrega_arquivo_texto("goku");
	textoNPC[1]->carrega_arquivo_texto("boy");
	textoNPC[2]->carrega_arquivo_texto("irma");
	textoNPC[3]->carrega_arquivo_texto("fazendeiroMoreno");
	textoNPC[4]->carrega_arquivo_texto("fazendeiroLoiro");
	textoNPC[5]->carrega_arquivo_texto("senhoraBranco");
	textoNPC[6]->carrega_arquivo_texto("galinha");
	textoNPC[7]->carrega_arquivo_texto("girl");
	textoNPC[8]->carrega_arquivo_texto("senhoraAzul");
	textoNPC[9]->carrega_arquivo_texto("senhor");
}

void carregaTextoNPCCastelo()
{
	u8 i;
	for(i = 0; i < 3; i++)
	{
		textoNPCCastelo[i] = new Texto();
		falaNPCCastelo[i] = 0;
	}

	textoNPCCastelo[0]->carrega_arquivo_texto("rei");
	textoNPCCastelo[1]->carrega_arquivo_texto("rainha");
	textoNPCCastelo[2]->carrega_arquivo_texto("magoVelho");
}

void carregaTextoNPCDeserto()
{
	u8 i;
	for(i = 0; i < 1; i++)
	{
		textoNPCDeserto[i] = new Texto();
		falaNPCDeserto[i] = 0;
	}

	textoNPCDeserto[0]->carrega_arquivo_texto("cara_do_deserto");
}

void carregaTextoNPCFloresta()
{
	u8 i;
	for(i = 0; i < 3; i++)
	{
		textoNPCFloresta[i] = new Texto();
		falaNPCFloresta[i] = 0;
	}

	textoNPCFloresta[0]->carrega_arquivo_texto("cara_da_floresta");
	textoNPCFloresta[1]->carrega_arquivo_texto("cara_da_floresta");
	textoNPCFloresta[2]->carrega_arquivo_texto("cara_da_floresta");
}

void carregaTextoNPCCaverna()
{
	u8 i;
	for(i = 0; i < 2; i++)
	{
		textoNPCCaverna[i] = new Texto();
		falaNPCCaverna[i] = 0;
	}

	textoNPCCaverna[0]->carrega_arquivo_texto("cara_da_caverna");
	textoNPCCaverna[1]->carrega_arquivo_texto("itemBau");
}

void textoNPCSelecionado(Heroi *heroi, u8 npcIndex)
{
	if(npcIndex == 0)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "goku") == 0)
			return; 
	}
	else if(npcIndex == 1)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "boy") == 0)
			return; 
	}
	else if(npcIndex == 2)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "irma") == 0)
			return; 
	}
	else if(npcIndex == 3)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "fMoreno") == 0)
			return; 
	}
	else if(npcIndex == 4)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "fLoiro") == 0)
			return; 
	}
	else if(npcIndex == 5)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "sBranco") == 0)
			return; 
	}
	else if(npcIndex == 6)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "galinha") == 0)
			return; 
	}
	else if(npcIndex == 7)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "girl") == 0)
			return; 
	}
	else if(npcIndex == 8)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "sAzul") == 0)
			return; 
	}
	else if(npcIndex == 9)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "senhor") == 0)
			return;
	}

	textoNPC[npcIndex]->inicia_box();
	textoNPC[npcIndex]->carrega_texto_box();

	mudaStatusQuests(npcIndex);
	mudaFalaNPCQuest(npcIndex);

	if(falaNPC[npcIndex] == 0)
	{
		textoNPC[npcIndex]->pega_qde_fala();
		falaNPC[npcIndex] = 1;
	}

	textoNPC[npcIndex]->fala_personagem();
	textoNPC[npcIndex]->apaga_texto_text_box();
	textoNPC[npcIndex]->apaga_text_box();
}

void textoNPCSelecionadoCastelo(Heroi *heroi, u8 npcIndex)
{
	if(npcIndex == 0)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "rei") == 0)
			return; 
	}
	else if(npcIndex == 1)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "rainha") == 0)
			return; 
	}
	else if(npcIndex == 2)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "magoVelho") == 0)
			return; 
	}

	textoNPCCastelo[npcIndex]->inicia_box();
	textoNPCCastelo[npcIndex]->carrega_texto_box();

	if(falaNPCCastelo[npcIndex] == 0)
	{
		textoNPCCastelo[npcIndex]->pega_qde_fala();
		falaNPCCastelo[npcIndex] = 1;
	}

	textoNPCCastelo[npcIndex]->fala_personagem();
	textoNPCCastelo[npcIndex]->apaga_texto_text_box();
	textoNPCCastelo[npcIndex]->apaga_text_box();
}

void textoNPCSelecionadoDeserto(Heroi *heroi, u8 npcIndex)
{
	if(npcIndex == 0)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "cara_do_deserto") == 0)
			return; 
	}

	textoNPCDeserto[npcIndex]->inicia_box();
	textoNPCDeserto[npcIndex]->carrega_texto_box();

	if(falaNPCDeserto[npcIndex] == 0)
	{
		textoNPCDeserto[npcIndex]->pega_qde_fala();
		falaNPCDeserto[npcIndex] = 1;
	}

	textoNPCDeserto[npcIndex]->fala_personagem();
	textoNPCDeserto[npcIndex]->apaga_texto_text_box();
	textoNPCDeserto[npcIndex]->apaga_text_box();
	cenario->descarregaBackground(0, 3, cenario->getReferencia());
	cenario->carregaBackground(0, 3, "deserto", "deserto");
	PA_InitParallaxX(0, 0, 256, 128, 256);
	PA_InitParallaxY(0, 0, 256, 128, 256);
}

void textoNPCSelecionadoFloresta(Heroi *heroi, u8 npcIndex)
{
	if(npcIndex == 0)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "cara_da_floresta") == 0)
			return; 
	}

	textoNPCFloresta[npcIndex]->inicia_box();
	textoNPCFloresta[npcIndex]->carrega_texto_box();

	if(falaNPCFloresta[npcIndex] == 0)
	{
		textoNPCFloresta[npcIndex]->pega_qde_fala();
		falaNPCFloresta[npcIndex] = 1;
	}

	textoNPCFloresta[npcIndex]->fala_personagem();
	textoNPCFloresta[npcIndex]->apaga_texto_text_box();
	textoNPCFloresta[npcIndex]->apaga_text_box();
}

void textoNPCSelecionadoCaverna(Heroi *heroi, u8 npcIndex)
{
	if(npcIndex == 0)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "cara_da_caverna") == 0)
			return; 
	}
	else if(npcIndex == 1)
	{
		if(distanciaFalaHeroiNPC(heroi->getPosicaoCenarioX(), heroi->getPosicaoCenarioY(), "itemBau") == 0)
			return; 
	}

	if(npcIndex == 1)
	{
		if(quests[QUEST_FAZ_MORENO] == -1)
		{
			return;
		}
	}

	textoNPCCaverna[npcIndex]->inicia_box();
	textoNPCCaverna[npcIndex]->carrega_texto_box();

	if(falaNPCCaverna[npcIndex] == 0)
	{
		if(npcIndex == 1)
		{
			statusBau = 1;
			NF_EasySetSpriteFrame(0, "bau", 1);
			NF_EasySetSpriteLayer(0, "bau", 3);
			quests[QUEST_FAZ_MORENO] = 1;
		}
		textoNPCCaverna[npcIndex]->pega_qde_fala();
		falaNPCCaverna[npcIndex] = 1;

	}
	else if(npcIndex == 1)
	{
		if(falaNPCCaverna[npcIndex] == 1 && statusBau == 1)
		{
			falaNPCCaverna[npcIndex] = 2;
			textoNPCCaverna[npcIndex]->pula_proxima_fala();
		}
	}

	textoNPCCaverna[npcIndex]->fala_personagem();
	textoNPCCaverna[npcIndex]->apaga_texto_text_box();
	textoNPCCaverna[npcIndex]->apaga_text_box();
}

void mudaStatusQuests(u8 npcIndex)
{
	if(npcIndex == FAZENDEIRO_MORENO_ID - 1)
	{
		if(quests[QUEST_FAZ_MORENO] == -1)
		{
			quests[QUEST_FAZ_MORENO] = 0;
		}
	}
}

void mudaFalaNPCQuest(u8 npcIndex)
{
	if(npcIndex == FAZENDEIRO_MORENO_ID - 1)
	{
		if(quests[QUEST_FAZ_MORENO] == 1)
		{
			quests[QUEST_FAZ_MORENO] = 2;
			textoNPC[npcIndex]->pula_proxima_fala();
			itemNovo = new Item();
			itemNovo->setNome("Pocao HP");
			itemNovo->setAdicionaHp(50);
			itemNovo->setTipoItem(ITEM_HP);
			itemNovo->setQtde(1);
			heroi->getMochila()->adiciona(itemNovo);
		}
		else if(quests[QUEST_FAZ_MORENO] == 2)
		{
			quests[QUEST_FAZ_MORENO] = 3;
			textoNPC[npcIndex]->pula_proxima_fala();
		}
	}
}

void inicioJogo(Heroi *heroi, Cenario *cenario)
{
	Texto *texto;
	u8 i;
	texto = new Texto();
	texto->carrega_arquivo_texto("inicioJogo");
	cenario->carregaBackground(0, 3, "castelo", "castelo");
	carregaSpriteCastelo();

	texto->inicia_box();
	texto->carrega_texto_box();
	
	
	for(i = 0; i < 3; i++)
	{
		texto->pega_texto_arquivo();
		texto->escreve_texto();
		texto->apaga_texto_text_box();
		PA_WaitForVBL();
	}

	PA_SetBrightness(1, -31);
	NF_LoadFatBg("recMaHeroi", "rMaFogo");
	NF_LoadRamBg(1, 3, "recMaHeroi");
	transicao_clarear_cima();

	for(i = 0; i < 6; i++)
	{
		texto->pega_texto_arquivo();
		texto->escreve_texto();
		texto->apaga_texto_text_box();
		PA_WaitForVBL();
	}

	transicao_escurecer();
	transicao_escurecer_cima();
	PA_DeleteBg(1, 3);
	NF_UnloadBg("recMaHeroi");
	PA_SetBrightness(1, 0);

	texto->apaga_text_box();
	descarregaSpriteCastelo();
	cenario->descarregaBackground(0, 3, cenario->getReferencia());
}

// Function: main()
int main(int argc, char ** argv)
{
	int menu = ESTA_MENU_PAI;
	u8 carregaPaused;
	u8 direcao = 0;
	u8 botaoStart = 0;
	u8 i, tipo, carregouNPCCidade, carregouNPCCastelo, carregouNPCDeserto, carregouNPCFloresta, carregouNPCCaverna;
	s16 posCenario[2] = {0, 0};

	s16 fps = 0;
	s16 fpstime = 0;
	s16 lasttime = 0;

	init();
	cenario = new Cenario();
	heroi = new Heroi();

	heroi->carregaSprite(0, 0);
	heroi->inicializa(100, 80);

	inicioJogo(heroi, cenario);

	status->inicia_status();

	heroi->setPosicaoTelaX(norm_fix(160));
	heroi->setPosicaoTelaY(norm_fix(140));
	heroi->setPosicaoCenarioX(norm_fix(280));
	heroi->setPosicaoCenarioY(norm_fix(313));
	heroi->setScrollX(norm_fix(119));
	heroi->setScrollY(norm_fix(72));
	heroi->setAngulo(0);
	heroi->setVelocidade(12);

	cenario->carregaBackground(0, 3, "cidade", "cidade");
	PA_InitParallaxX(0, 0, 256, 128, 256);
	PA_InitParallaxY(0, 0, 256, 128, 256);

	//carregaSpriteCidade(heroi);

//	status->mostra_status(heroi);
	carregaSpriteCidade(heroi);
	heroi->movimenta(angulo, cenario->getReferencia());
	scrollNPCCidade(heroi, 0);
	cenario->moveBackground(posCenario, heroi->getScrollX(), heroi->getScrollY(), direcao);
	heroi->anda(posCenario, cenario);
	transicao_clarear();

	playMP3("vila");
	AS_SetMP3Loop(true);

	carregaPaused = 0;

	carregouNPCCidade = 0;
	carregouNPCCastelo = 0;
	carregouNPCDeserto = 0;
	carregouNPCFloresta = 0;
	carregouNPCCaverna = 0;
	statusBau = 0;

	float v = 10/3;

	while (1)
	{
//		fps += 1;
//		fpstime = PA_RTC.Seconds;
//		if (fpstime != lasttime) {
//			PA_OutputText(0 ,0 , 3, "Fps %d / 60", fps);
//			lasttime = fpstime;
//			fps = 0;
//		}
//		PA_OutputText (0, 1, 4, "mem livre: %d", getMemFree());
		
		if(Pad.Newpress.Start && !batalhando) 
		{
			botaoStart = 1;
			AS_MP3Pause();
		}

		if(botaoStart)
		{
			if(carregaPaused == 0)
			{
				NF_LoadFatBg("palavraPaused", "palavraPaused");
				NF_LoadRamBg(0, 1, "palavraPaused");
				carregaPaused = 1;
			}
			heroi->pahra();
			if (menu == ESTA_MENU_PAI){
				menu = status->abrir_menu(item, menu, heroi, &botaoStart, &carregaPaused);
				status->posiciona_seta(/*sons*/);
			}
			if (menu == ESTA_MENU_ITEM){
				menu = status->abrir_menu_item(item, menu, heroi);
				if(status->posiciona_seta_item(heroi, 0) == 1)
					menu = ESTA_MENU_PAI;

			}
			if (menu == ESTA_MENU_ESPIRITOS){
				//menu = status->abrir_menu_item(item, menu, heroi);
				//status->posiciona_seta_item(heroi, 1);
			}
			if (menu == ESTA_MENU_SAIR) {	
			    menu = status->menu_sair(menu, &botaoStart, &carregaPaused);
				status->posiciona_seta_item(heroi, 2);
			}
		}
		else
		{
			colisaoDetect(heroi, cenario);
			heroi->anda(posCenario, cenario);
			cenario->moveBackground(posCenario, heroi->getScrollX(), heroi->getScrollY(), direcao);

			tipo = 0;
			if(strcmp(cenario->getReferencia(), "cidade") == 0)
			{
				if(carregouNPCCidade == 0)
				{
					carregaTextoNPCCidade();
					carregouNPCCidade = 1;
				}

				tipo = colisaoHeroiNPC(heroi, CIDADE, 10);

				for (i = 0; i < 128; i++) {
					if (PA_SpriteTouched(i) && (i - 1 >= 0))
					{
						/*PA_OutputText(0 ,0 , 10, "                           ");
						PA_OutputText(0 ,0 , 10, "Quest: %d %d", quests[QUEST_FAZ_MORENO], i - 1);*/
						textoNPCSelecionado(heroi, i - 1);
						
						
					}
				}
			}
			else if(strcmp(cenario->getReferencia(), "castelo") == 0)
			{
				if(carregouNPCCastelo == 0)
				{
					carregaTextoNPCCastelo();
					carregouNPCCastelo = 1;
				}

				tipo = colisaoHeroiNPC(heroi, CASTELO, 3);

				for (i = 0; i < 128; i++) {
					if (PA_SpriteTouched(i) && (i - 1 >= 0))
					{
						textoNPCSelecionadoCastelo(heroi, i - 1);
					}
				}
			}
			else if(strcmp(cenario->getReferencia(), "deserto") == 0 ||
					strcmp(cenario->getReferencia(), "deserto2") == 0)
			{
				if(carregouNPCDeserto == 0)
				{
					carregaTextoNPCDeserto();
					carregouNPCDeserto = 1;
				}

				tipo = colisaoHeroiNPC(heroi, DESERTO1, 1);

				for (i = 0; i < 128; i++) {
					if (PA_SpriteTouched(i) && (i - 1 >= 0))
					{
						textoNPCSelecionadoDeserto(heroi, i - 1);
					}
				}
			}
			else if(strcmp(cenario->getReferencia(), "floresta1") == 0 ||
					strcmp(cenario->getReferencia(), "floresta2") == 0)
			{
				if(carregouNPCFloresta == 0)
				{
					carregaTextoNPCFloresta();
					carregouNPCFloresta = 1;
				}

				tipo = colisaoHeroiNPC(heroi, FLORESTA1, 3);

				for (i = 0; i < 128; i++) {
					if (PA_SpriteTouched(i) && (i - 1 >= 0))
					{
						textoNPCSelecionadoFloresta(heroi, i - 1);
					}
				}
			}
			else if(strcmp(cenario->getReferencia(), "cenarioCaverna") == 0 ||
					strcmp(cenario->getReferencia(), "cenarioCaverna2") == 0)
			{
				if(carregouNPCCaverna == 0)
				{
					carregaTextoNPCCaverna();
					carregouNPCCaverna = 1;
				}

				tipo = colisaoHeroiNPC(heroi, CAVERNA1, 2);

				for (i = 0; i < 128; i++) {
					if (PA_SpriteTouched(i) && (i - 1 >= 0))
					{
						textoNPCSelecionadoCaverna(heroi, i - 1);
						/*PA_OutputText(0 ,0 , 10, "                           ");
						PA_OutputText(0 ,0 , 10, "Quest: %d", quests[QUEST_FAZ_MORENO]);*/
					}
				}
			}

			if(tipo != 0)
			{
				heroi->setPosicaoCenarioX(heroi->getPosicaoCenarioAnteriorX());
				heroi->setPosicaoCenarioY(heroi->getPosicaoCenarioAnteriorY());

				heroi->setScrollAnteriorX(heroi->getScrollX());
				heroi->setScrollAnteriorY(heroi->getScrollY());

				heroi->setPosicaoTelaX(heroi->getPosicaoTelaAnteriorX());
				heroi->setPosicaoTelaY(heroi->getPosicaoTelaAnteriorY());

				heroi->setDirecaoColisaoHorizontal(1);
				heroi->setDirecaoColisaoVertical(1);
			}

			if(strcmp(cenario->getReferencia(), "cidade") == 0) 
				scrollNPCCidade(heroi, tipo);

			if(strcmp(cenario->getReferencia(), "castelo") == 0)
				scrollNPCCastelo(heroi, tipo);

			if(strcmp(cenario->getReferencia(), "floresta1") == 0)
				scrollNPCFloresta(heroi, tipo);

			if(strcmp(cenario->getReferencia(), "cenarioCaverna") == 0)
			{
				scrollSpriteCaverna(heroi, tipo);
				scrollItemBau(heroi);
			}
			
			if(strcmp(cenario->getReferencia(), "deserto") == 0)
				scrollSpriteDeserto(heroi, tipo);
				
			// aqui comeca a batalha do jogo
			// batalhando eh a variavel que controla a batalha. se true, entra na batalha
			
			if (batalhando == false && (strcmp(cenario->getReferencia(), "inn") != 0 && strcmp(cenario->getReferencia(), "castelo") != 0 && strcmp(cenario->getReferencia(), "cidade") != 0)){
				
				batalha = modo_batalha_init(musica_tocando, heroi, cenario);
				heroi->setExperienciaAcumulada(0);
			}
			if (batalhando){			
				heroi->ataca();
				heroi->lancaMagia(magia);
				batalha->heroiNaBatalha(heroi, inimigo, posCenario, cenario);
				inimigo = batalha->batalha (heroi, cenario, status, inimigo, magia, posCenario, statusBau);
				if (inimigo == NULL)
					batalhando = false;
			}
			else{
				status->mostra_status(heroi);
			}
		}
		PA_WaitForVBL();
	}
	
	return 0;
} // End of main()

void init()
{
	NF_InitPA();				// Init PA_LIB
	NF_InitFAT();				// Init EFS & FAT
	NF_InitBuffers();			// Init buffers
	NF_FreeBuffers();
	NF_SetFatRoot("EFS");		// Sets EFS as root
	NF_SetDefaultMode(1, 1);	// Default video mode (Test also in both screens)
	NF_EasyInit();

	// Habilita o alpha-blending
	PA_EnableSpecialFx(0, // tela
						SFX_ALPHA, // modo alpha-blending
						0, // Nada
						SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_BD); // Tudo normal

	textoApresentacao();

	splash();

	apresentacao();

	menu_inicial();
	//reconheceForma2();

	PA_InitText(1, 0);
	PA_InitText(0, 0);

	item = new Item ();
	//item->iniciaFila();

	inimigo = NULL;

	status = new Status();

	magia = new Magia();
	magia->setAtivado(false);
	magia->setRecoAtivado(false);
	magia->setVivo(false);

	//status->inicia_status();
	quests[QUEST_FAZ_MORENO] = -1;
}

Batalha *modo_batalha_init(u8 musica_tocando, Heroi *heroi, Cenario *cenario)
{
	s8 i;

	if(Stylus.Held)
	{
		Batalha *batalhaa = new Batalha();
		if (batalhaa->encontra_batalha()){
			batalhando = true;
			batalhaa->guardaPosicaoHeroiAntes(heroi);
			PA_SetSpriteMode(0, NF_EasyGetSpriteId (0, heroi->getNome()), 1);

			if (strcmp(cenario->getReferencia(), "floresta1") == 0){
				descarregaSpriteFloresta();
			}
			else
			if (strcmp(cenario->getReferencia(), "deserto") == 0){
				descarregaSpriteDeserto();
			}
			else
			if (strcmp(cenario->getReferencia(), "cenarioCaverna") == 0){
				descarregaSpriteCaverna();
			}

			stopMP3();
			i = 0;
			while(i != 10)
			{
				i++;
				PA_WaitForVBL();
			}
			//playMP3("encontra_inimigo");

			for(i = 15; i >= 0; i--)
			{
				PA_SetSFXAlpha(0, i, 15);
				PA_WaitForVBL();
			}

			PA_SetSpriteMode(0, NF_EasyGetSpriteId (0, heroi->getNome()), 0);
			heroi->carregaSprite(0, 1); // descarrega o sprite

			status->carrega_template_batalha();
			batalhaa->tela_transicao(musica_tocando, cenario);


			PA_InitParallaxX(0, 0, 256, 128, 256);
			PA_InitParallaxY(0, 0, 256, 128, 256);

			heroi->setPosicaoTelaX(norm_fix(50));
			heroi->setPosicaoTelaY(norm_fix(150));
			heroi->setPosicaoCenarioX(norm_fix(50));
			heroi->setPosicaoCenarioY(norm_fix(150));
			heroi->setScrollX(norm_fix(0));
			heroi->setScrollY(norm_fix(0));
			
			heroi->carregaSprite(1, 0); // carrega o herio com ataque
			PA_SetSpriteMode(0, NF_EasyGetSpriteId (0, heroi->getNome()), 1);
			PA_SetSFXAlpha(0, 0, 15);
			
			playMP3("batalha");
			AS_SetMP3Loop(true);
			for(i = 1; i < 16; i++)
			{
				PA_SetSFXAlpha(0, i, 15);
				PA_WaitForVBL();
			}
			PA_SetSpriteMode(0, NF_EasyGetSpriteId (0, heroi->getNome()), 0);
			
			batalhaa->setNumeroInimigos(0);

//			stopMP3();
			i = 0;
			while(i != 10)
			{
				i++;
				PA_WaitForVBL();
			}

			//carregaEfeito("somGolpeAcertado", "bump");
			carregaEfeito("inimigoMorrendo", "inimigo_morrendo");
		}
		else free(batalhaa);

		return batalhaa;
	}
}

