/*=========================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	Broken Soul is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
=========================================================================*/

#include "include/transicao.hpp"
#include "include/Sound.hpp"
#include "include/creditos.hpp"

void carrega_menu()
{
	PA_ResetBgSys();

	PA_SetBrightness(0, -31); // all black
	PA_SetBrightness(1, -31); // all black

	NF_LoadFatBg("menuInicialTop", "menuTop");
	NF_LoadRamBg(1, 3, "menuInicialTop");

	NF_LoadFatBg("menuInicialBot", "menuBot");
	NF_LoadRamBg(0, 3, "menuInicialBot");
	
	for(s8 i = -31; i <= 0; i++){
		PA_SetBrightness(0, i); 
		PA_SetBrightness(1, i); 
		PA_WaitForVBL();		   
	}
}

void descarrega_menu()
{
	for(s8 i = 0; i > -32; i--){
		PA_SetBrightness(0, i); 
		PA_SetBrightness(1, i); 
		PA_WaitForVBL();		   
	} 
	
	PA_DeleteBg(1, 3);
	NF_UnloadBg("menuInicialTop");

	PA_DeleteBg(0, 3);
	NF_UnloadBg("menuInicialBot");

	PA_DeleteBg(0, 1);
	NF_UnloadBg("menuIniciar");
	PA_ResetBgSys();
	PA_SetBrightness(0, 0); // normal
	PA_SetBrightness(1, 0); // normal
}

void menu_inicial()
{
	u8 pressionaIniciar = 0;
	u8 pressionaContinuar = 0;
	u8 pressionaCreditos = 0;
	
	carrega_menu();
	/*PA_InitText(1, 0);
	PA_InitText(0, 0);*/

	NF_LoadFatSfx("menuSelecionado", "continue_dialogo");
	NF_LoadFatSfx("jogoInicio", "confirma_inicio_jogo");
	playMP3("menuFundo");
	AS_SetMP3Loop(true);
	while(1)
	{
		
		/*PA_OutputText(1 ,0 , 5, "                       ");
		PA_OutputText(1 ,0 , 5, "%c1Stylus %d %d", Stylus.X, Stylus.Y);*/
		if (Stylus.Newpress) {
			PA_WaitForVBL();
			if (Stylus.X > 9 && Stylus.X < 128) {
				if (Stylus.Y >= 124 && Stylus.Y < 142) {
					if (pressionaIniciar == 0) {
						NF_PlaySfx("menuSelecionado");
						if (pressionaContinuar != 0) {
							PA_DeleteBg(0, 1);
							NF_UnloadBg("menuContinuar");
							pressionaContinuar = 0;
						}
							
						if (pressionaCreditos != 0) {
							PA_DeleteBg(0, 1);
							NF_UnloadBg("menuCreditos");
							pressionaCreditos = 0;
						}
					
						NF_LoadFatBg("menuIniciar", "menuIniciar");
						NF_LoadRamBg(0, 1, "menuIniciar");
						pressionaIniciar = 1;
					}
					else if (pressionaIniciar == 1)
					{
						NF_PlaySfx("jogoInicio");
						break;
					}
				}
				else if (Stylus.Y >= 142 && Stylus.Y < 162) {
					if (pressionaContinuar == 0) {
						NF_PlaySfx("menuSelecionado");
						if (pressionaIniciar != 0) {
							PA_DeleteBg(0, 1);
							NF_UnloadBg("menuIniciar");
							pressionaIniciar = 0;
						}
							
						if (pressionaCreditos != 0) {
							PA_DeleteBg(0, 1);
							NF_UnloadBg("menuCreditos");
							pressionaCreditos = 0;
						}
							
						NF_LoadFatBg("menuContinuar", "menuContinuar");
						NF_LoadRamBg(0, 1, "menuContinuar");
						pressionaContinuar++;
					}
				}
				else if (Stylus.Y >= 162 && Stylus.Y <= 180) {
					if (pressionaCreditos == 0) {
						NF_PlaySfx("menuSelecionado");
						if (pressionaContinuar != 0) {
							PA_DeleteBg(0, 1);
							NF_UnloadBg("menuContinuar");
							pressionaContinuar = 0;
						}
							
						if (pressionaIniciar != 0) {
							PA_DeleteBg(0, 1);
							NF_UnloadBg("menuIniciar");
							pressionaIniciar = 0;
						}
							
						NF_LoadFatBg("menuCreditos", "menuCreditos");
						NF_LoadRamBg(0, 1, "menuCreditos");
						pressionaCreditos++;
					}
					else if(pressionaCreditos == 1)
					{
						stopMP3();
						NF_PlaySfx("jogoInicio");
						PA_DeleteBg(1, 3);
						NF_UnloadBg("menuInicialTop");

						PA_DeleteBg(0, 3);
						NF_UnloadBg("menuInicialBot");

						PA_DeleteBg(0, 1);
						NF_UnloadBg("menuCreditos");
						creditos();
						carrega_menu();
						pressionaCreditos = 0;
					}
				}
			}
		}

		PA_WaitForVBL();
	}
	pressionaCreditos = 0;
	stopMP3();
	while(pressionaCreditos != 50)
	{
		PA_WaitForVBL();
		pressionaCreditos++;
	}

	NF_StopSfx("jogoInicio");

	NF_UnloadSfx("menuSelecionado");
	NF_UnloadSfx("jogoInicio");

	descarrega_menu();
}