#ifdef __cplusplus
extern "C" {
#endif





	// NightFox LIB - COMMON Functions
	// Requires PA_LIB, NODA AS_LIB & EFS 2.0.
	// Code by NightFox
	// http://blogs.gamefilia.com/knightfox
	// Version BETA.3.c.081117





	// Incluye las librerias
	#include <PA9.h>			// Librerias PA_LIB

	#include "include/nf_common.h"		// Incluye la cabecera nf_common.h

	#include "include/nf_font.h"		// Fuentes propias





	// Funcion NF_FadeIn();
	void NF_FadeIn(void) {
		float brillo = -16;
		u8 control = 1;
		while (control) {
			brillo += 0.5;
			if (brillo >= 0) {
				control = 0;
			}
			PA_SetBrightness(0, (int)(brillo));
			PA_SetBrightness(1, (int)(brillo));
			PA_WaitForVBL();		// Espera al sincronismo vertical (60fps)
		}
	}





	// Funcion NF_FadeOut();
	void NF_FadeOut(void) {
		float brillo = 0;
		u8 control = 1;
		while (control) {
			brillo -= 0.5;
			if (brillo <= -16) {
				control = 0;
			}
			PA_SetBrightness(0, (int)(brillo));
			PA_SetBrightness(1, (int)(brillo));
			PA_WaitForVBL();		// Espera al sincronismo vertical (60fps)
		}
	}





	// Errores de sistema (debug) //
	void NF_Error(u8 codigo, const char* descripcion) {

			PA_Init();					// Inicializa la PA_Lib
			PA_InitVBL();				// Inicializa la VBL estandar
			PA_Init2D();				// Fuerza la inicializacion del modo 2D
			PA_SetVideoMode(0, 0);		// Inicializa pantalla
			PA_SetVideoMode(1, 0);
			PA_ResetBgSysScreen(0);		// Reinicia el sistema de pantalla
			PA_ResetBgSysScreen(1);
			PA_ResetSpriteSys();		// Reinicia el sistema de Sprites
			PA_DisableSpecialFx(0);		// Deshabilita los efectos especiales
			PA_DisableSpecialFx(1);
			PA_InitText(0, 0);			// Inicializa el texto en ambas pantallas
			PA_InitText(1, 0);

			PA_InitCustomText(0, 0, fuente_error);		// Inicializa el texto en ambas pantallas
			PA_InitCustomText(1, 0, fuente_error);		// En la capa 0
			PA_SetTextCol(0, 31, 31, 31);
			PA_EasyBgLoad(0, 3, bg_system);		// Carga el fondo
			PA_EasyBgLoad(1, 3, bg_system);
			PA_SetBrightness(0, -16);		// Brillo bajado
			PA_SetBrightness(1, -16);

			switch (codigo) {		// Mensage segun el codigo

				case 0:
					PA_OutputText(1, 1, 1, "SIN ERRORES");
					PA_OutputText(0, 1, 1, "NO ERRORS");
					break;

				case 1:
					PA_OutputText(1, 1, 1, "EL ARCHIVO");
					PA_OutputText(1, 1, 3, "%s", descripcion);
					PA_OutputText(1, 1, 5, "NO SE HA ENCONTRADO.");
					PA_OutputText(0, 1, 1, "FILE");
					PA_OutputText(0, 1, 3, "%s", descripcion);
					PA_OutputText(0, 1, 5, "NOT FOUND.");
					break;

				case 2:
					PA_OutputText(1, 1, 1, "MEMORIA RAM INSUFICIENTE.");
					PA_OutputText(0, 1, 1, "OUT OF MEMORY.");
					break;

				case 3:
					PA_OutputText(1, 1, 1, "PARAMETRO EN LA FUNCION");
					PA_OutputText(1, 1, 3, "%s", descripcion);
					PA_OutputText(1, 1, 5, "NO VALIDO.");
					PA_OutputText(0, 1, 1, "INVALID ARGUMENT IN");
					PA_OutputText(0, 1, 3, "%s", descripcion);
					PA_OutputText(0, 1, 5, "FUNCTION.");
					break;

				case 4:
					PA_OutputText(1, 1, 1, "REFERENCIA");
					PA_OutputText(1, 1, 3, "%s", descripcion);
					PA_OutputText(1, 1, 5, "NO SE HA ENCONTRADO.");
					PA_OutputText(0, 1, 1, "REFERENCE");
					PA_OutputText(0, 1, 3, "%s", descripcion);
					PA_OutputText(0, 1, 5, "NOT FOUND.");
					break;

				case 5:
					PA_OutputText(1, 1, 1, "SLOTS DE FONDOS LLENOS.");
					PA_OutputText(0, 1, 1, "OUT OF BACKGROUND SLOTS.");
					break;

				case 6:
					PA_OutputText(1, 1, 1, "SLOTS DE SFX LLENOS.");
					PA_OutputText(0, 1, 1, "OUT OF SFX SLOTS.");
					break;

				case 7:
					PA_OutputText(1, 1, 1, "SLOTS DE CMAP LLENOS.");
					PA_OutputText(0, 1, 1, "OUT OF CMAP SLOTS.");
					break;

				case 8:
					PA_OutputText(1, 1, 1, "SLOTS DE GFX LLENOS.");
					PA_OutputText(0, 1, 1, "OUT OF GFX SLOTS.");
					break;

				case 9:
					PA_OutputText(1, 1, 1, "SLOTS DE PALETAS LLENOS.");
					PA_OutputText(0, 1, 1, "OUT OF PALETTE SLOTS.");
					break;

				case 10:
					PA_OutputText(1, 1, 1, "LIMITE DE SPRITES SUPERADO.");
					PA_OutputText(0, 1, 1, "OUT OF SPRITES.");
					break;

				case 11:
					PA_OutputText(1, 1, 1, "LIMITE DE PALETAS SUPERADO.");
					PA_OutputText(0, 1, 1, "OUT OF PALETTES.");
					break;

				case 255:
					PA_OutputText(1, 1, 1, "ERROR DE CODIGO");
					PA_OutputText(1, 1, 3, "EN LA FUNCION");
					PA_OutputText(1, 1, 5, "%s", descripcion);
					PA_OutputText(0, 1, 1, "CODE ERROR ON");
					PA_OutputText(0, 1, 3, "%s", descripcion);
					PA_OutputText(0, 1, 5, "FUNCTION");
					break;

				default:
					PA_OutputText(1, 1, 1, "ERROR DESCONOCIDO.");
					PA_OutputText(0, 1, 1, "UNKNOW ERROR.");
					break;
				
			}
			
			PA_OutputText(1, 1, 18, "CODIGO DE ERROR: %d.", codigo);
			PA_OutputText(1, 1, 20, "SISTEMA DETENIDO.");
			PA_OutputText(0, 1, 18, "ERROR CODE: %d.", codigo);
			PA_OutputText(0, 1, 20, "SYSTEM STOPPED.");

			NF_FadeIn();		// Muestra el error
			
			while(1) {		// Repite para siempre
				PA_WaitForVBL();
			}

	}





	// Funcion NF_InitPA();			// Inicializa las PA_LIB
	void NF_InitPA(void) {

		PA_Init();					// Inicializa la PA_Lib
		PA_InitVBL();				// Inicializa la VBL estandar
		PA_SetVideoMode(0, 0);		// Inicializa las pantallas con el modo de video correspondiente
		PA_SetVideoMode(1, 0);
		PA_VBLFunctionInit(AS_SoundVBL);		// Asegurate que se sincronizara el sonido
		AS_Init(AS_MODE_MP3 | AS_MODE_SURROUND | AS_MODE_16CH);  // Inicializa la AS_Lib
		AS_SetDefaultSettings(AS_PCM_8BIT, 11025, AS_SURROUND);  // y pon los parametros por defecto
		PA_InitText(0, 0);			// Inicializa el texto en ambas pantallas
		PA_InitText(1, 0);

	}





	// Funcion NF_SetDefaultMode(u8 a, u8 b);		// Pon el modo grafico por defecto
	void NF_SetDefaultMode(u8 a, u8 b) {

		PA_Init2D();					// Fuerza reinicializar el modo 2D
		PA_SetVideoMode(0, 0);			// Inicializa pantalla
		PA_SetVideoMode(1, 0);
		PA_ResetBgSysScreen(0);			// Reinicia el sistema de pantalla
		PA_ResetBgSysScreen(1);
		PA_ResetSpriteSysScreen(0);		// Reinicia el sistema de Sprites
		PA_ResetSpriteSysScreen(1);
		PA_DisableSpecialFx(0);			// Deshabilita los efectos especiales
		PA_DisableSpecialFx(1);

		if (a == 1) {					// Si esta en "Modo 0"
			PA_InitText(0, 0);			// Inicializa el texto en la pantalla 0
		}
		if (b == 1) {					// Si esta en "Modo 0"
			PA_InitText(1, 0);			// Inicializa el texto en la pantalla 1
		}

		PA_SetBrightness(0, -16);		// Restaura el brillo a 0 (imagen en negro)
		PA_SetBrightness(1, -16);

	}





#ifdef __cplusplus
}
#endif
