/*=========================================================================
This file is part of Broken Soul.

    Broken Soul is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	Broken Soul is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Broken Soul.  If not, see <http://www.gnu.org/licenses/>.
=========================================================================*/

#include "include/transicao.hpp"

void transicao_fechar(){
	for (int i = 0; i <= 32; i++) {
		PA_WindowFade(1, // screen
					  0, // fade type, from 0 to 7, test them out !
					  i); // Time, 0 being the screen completely visible, 32 completely out
		PA_WaitForVBL(); // To slow down the fades, we wait a frame...
	}
}

void transicao_abrir(){

	for (int i = 32; i >= 0; i--) {
		PA_WindowFade(1, 0, i);
		PA_WaitForVBL(); // To slow down the fades, we wait a frame...
	}
}

void transicao_escurecer(){

	for (int i = 0; i >= -31; i--) {
		PA_SetBrightness(0, i);
		PA_WaitForVBL(); // To slow down the fades, we wait a frame...
		PA_WaitForVBL(); 
	}	
}

void transicao_clarear(){

	for (int i = -31; i <= 0; i++) {
		PA_SetBrightness(0, i);
		PA_WaitForVBL(); // To slow down the fades, we wait a frame...
		PA_WaitForVBL(); 
	}	
}

void transicao_escurecer_cima(){

	for (int i = 0; i >= -31; i--) {
		PA_SetBrightness(1, i);
		PA_WaitForVBL(); // To slow down the fades, we wait a frame...
		PA_WaitForVBL(); 
	}	
}

void transicao_clarear_cima(){

	for (int i = -31; i <= 0; i++) {
		PA_SetBrightness(1, i);
		PA_WaitForVBL(); // To slow down the fades, we wait a frame...
		PA_WaitForVBL(); 
	}	
}

void brilhoNormalDualScreen()
{
	s8 i;
	for(i = -31; i <= 0; i++){
		PA_SetBrightness(0, i); 
		PA_SetBrightness(1, i); 
		PA_WaitForVBL();		   
	}
}

void escureceBrilhoDualScreen()
{
	s8 i;

	for(i = 0; i > -32; i--){
		PA_SetBrightness(0, i); 
		PA_SetBrightness(1, i); 
		PA_WaitForVBL();		   
	}
}

void busyWait()
{
	s16 i;

	for(i = 0; i < 600; i++)
	{
		if(Pad.Newpress.Anykey || Stylus.Newpress)
			break;
		PA_WaitForVBL();
	} 
}

void efeitoFadeDualScreen(u8 layer, char *arquivoTop, char *arquivoBot)
{
	PA_ResetBgSys();

	// Tudo preto
	PA_SetBrightness(0, -31);
	PA_SetBrightness(1, -31);
	
	// Load splash from fat
	NF_LoadFatBg("top", arquivoTop);
	NF_LoadRamBg(1, layer, "top");

	NF_LoadFatBg("bot", arquivoBot);
	NF_LoadRamBg(0, layer, "bot");

	// Volta ao brilho normal
	brilhoNormalDualScreen();

	// Espera 5 segundos = 300 frames
	busyWait();

	// Escurece a tela
	escureceBrilhoDualScreen();

	NF_UnloadBg("top");
	NF_UnloadBg("bot");
	PA_SetBrightness(0, 0);
	PA_SetBrightness(1, 0);
	PA_ResetBgSys();
}

void fadeScrollDualScreen(u8 layer, char *arquivoTop, char *arquivoBot)
{
	s16 i;
	PA_ResetBgSys();

	// Tudo preto
	PA_SetBrightness(0, -31);
	PA_SetBrightness(1, -31);
	
	// Load splash from fat
	NF_LoadFatBg("top", arquivoTop);
	NF_LoadRamBg(1, layer, "top");
	PA_InitParallaxY(1, 0, 256, 128, 128);

	NF_LoadFatBg("bot", arquivoBot);
	NF_LoadRamBg(0, layer, "bot");
	PA_InitParallaxY(0, 0, 256, 128, 128);
	
	PA_ParallaxScrollY(1, 600);
	PA_ParallaxScrollY(0, 600);

	// Volta ao brilho normal
	brilhoNormalDualScreen();

	// Espera 5 segundos = 300 frames
	s32 scroll = 0;
	for(i = 600; i >= 0; i--)
	{
		if(Pad.Newpress.Anykey || Stylus.Newpress)
			break;
		scroll += 1;

		PA_ParallaxScrollY(1, i);
		PA_ParallaxScrollY(0, i);

		PA_WaitForVBL();
	}
	
	busyWait();

	// Escurece a tela
	escureceBrilhoDualScreen();

	NF_UnloadBg("top");
	NF_UnloadBg("bot");
	PA_SetBrightness(0, 0);
	PA_SetBrightness(1, 0);
	PA_ResetBgSys();
}

void fadeSlideToRightScrollDualScreen(u8 layer, char *arquivoTop, char *arquivoBot)
{
	s16 i;
	PA_ResetBgSys();

	// Tudo preto
	PA_SetBrightness(0, -31);
	PA_SetBrightness(1, -31);
	
	// Load splash from fat
	NF_LoadFatBg("top", arquivoTop);
	NF_LoadRamBg(1, layer, "top");
	PA_InitParallaxX(1, 0, 256, 128, 128);

	NF_LoadFatBg("bot", arquivoBot);
	NF_LoadRamBg(0, layer, "bot");
	PA_InitParallaxX(0, 0, 256, 128, 128);
	
	PA_ParallaxScrollX(1, 500);
	PA_ParallaxScrollX(0, 500);

	// Volta ao brilho normal
	brilhoNormalDualScreen();

	// Espera 5 segundos = 300 frames
	s32 scroll = 0;
	for(i = 500; i >= -200; i--)
	{
		if(Pad.Newpress.Anykey || Stylus.Newpress)
			break;
		scroll += 1;

		PA_ParallaxScrollX(1, i);
		PA_ParallaxScrollX(0, i);

		PA_WaitForVBL();
	}
	
	busyWait();

	// Escurece a tela
	escureceBrilhoDualScreen();

	NF_UnloadBg("top");
	NF_UnloadBg("bot");
	PA_SetBrightness(0, 0);
	PA_SetBrightness(1, 0);
	PA_ResetBgSys();
}
